
/*
  App Icon Drop

  20181006 Ken Shmidheiser
*/

include "Tlbx CocoaUI.incl"
cocoainit

// Must be same name as in Info.plist
output file "App Icon Drop"

_mFile = 1
begin enum
_iOpen
end enum

_mEdit = 2

_window = 1
begin enum output 1
_scrollView
_textView
_openBtn
end enum

void local fn BuildMenu
'~'1
cocoa menu _mFile,,, @"File"
cocoa menu _mFile, _iOpen,, @"Open file", @"o"

editmenu _mEdit
end fn

void local fn BuildWindow
'~'1
dim as CGRect    r

r = fn CGRectMake( 0, 0, 600, 450 )
cocoa window _window, fn ProcessInfoProcessName, r
WindowSetMinSize( _window, fn CGSizeMake( 450, 200 ) )

r = fn CGRectMake( 20, 61, 560, 369 )
scrollview _scrollView, r, NSLineBorder
ViewSetAutoresizingMask( _scrollView, NSViewWidthSizable + NSViewHeightSizable )

subclass// subclass next widget to allow drag drop
textview _textView,, _scrollView
TextViewSetTextContainerInset( _textView, fn CGSizeMake( 8, 8 ) )
ViewRegisterForDraggedTypes( _textView, fn ArrayWithObjects(@"public.text",@"bas",@"txt",@"incl",NULL) )
TextSetFontWithName( _textView, @"Menlo", 13.0 )
TextSetString( _textView, @"" )

r = fn CGRectMake( 478, 13, 108, 32 )
cocoa button _openBtn,,, @"Open file", r
ViewSetAutoresizingMask( _openBtn, NSViewMinXMargin + NSViewMaxYMargin )

WindowMakeFirstResponder( _window, _textView )
end fn

void local fn SetViewText( url as CFURLRef )
'~'1
dim as CFStringRef   tempStr

tempStr = fn StringWithContentsOfURL( url, NSMacOSRomanStringEncoding, NULL )
WindowSetTitleWithRepresentedURL( _window, url )
TextSetString( _textView, tempStr )
end fn

void local fn OpenFile
'~'1
dim as CFURLRef   url

url = OSPanelOpen( _OSPanelDoesntShowTagField, @"Open file.", @"kUTTypeText;bas;txt;incl", @"Open file...", NULL )
if ( url )
fn SetViewText( url )
else
// User canceled
end if
end fn

void local fn DoMenu( menuID as long, itemID as long )
'~'1
select (menuID)
case _mFile
select (itemID )
case _iOpen : fn OpenFile
end select
end select
end fn

void local fn DoDialog( ev as long, tag as long )
'~'1
select (ev)
case _btnClick
select (tag)
case _openBtn : fn OpenFile
end select
case _viewPerformDragOperation : fn SetViewText( fn DialogEventURL )
case _windowWillClose : end
end select
end fn

void local fn DoAppEvent( ev as long )
'~'1
select (ev)
case _appOpenURLs : fn SetViewText( fn AppEventURL )
end select
end fn

on menu fn DoMenu
on dialog fn DoDialog
on appevent fn DoAppEvent

fn BuildMenu
fn BuildWindow

HandleEvents


