
/*
  Email Verifier

  Ken Shmidheiser

  https://developer.apple.com/library/archive/documentation/Cocoa/Conceptual/Predicates/Articles/pUsing.html
*/

include "Tlbx CocoaUI.incl"
cocoainit

include "NSLog.incl"

local fn ValidateEmail( emailStr as CFStringRef ) as Boolean
'~'1
dim as CFStringRef   regex
dim as PredicateRef  pred
dim as Boolean       result : result = _false

regex = @"[A-Z0-9a-z._%+-]+@[A-Za-z0-9.-]+\\.[A-Za-z]{2,64}"
pred = fn PredicateWithFormat( @"SELF MATCHES %@", regex )
result = fn PredicateEvaluateWithObject( pred, emailStr )
end fn = result

dim as CFMutableArrayRef emailMutArr
dim as CFStringRef       testString
dim as Boolean           result

emailMutArr = fn ArrayWithCapacity( 0 )
ArrayAddObject( emailMutArr, @"support@apple.com" )
ArrayAddObject( emailMutArr, @"certainly bogus" )
ArrayAddObject( emailMutArr, @"JaneSmithChicago@esp.com" )
ArrayAddObject( emailMutArr, @"johndoe@gmail.com" )
ArrayAddObject( emailMutArr, @"closebutnotquite@gmail" )
ArrayAddObject( emailMutArr, @"anothertoughone.com" )
ArrayAddObject( emailMutArr, @"hello@yourdomain.com" )
ArrayAddObject( emailMutArr, @"willthispass@.com" )
ArrayAddObject( emailMutArr, @"A random string." )

for testString in emailMutArr
result = fn ValidateEmail( testString )
if (result == _true )
NSLog( @"Valid email address:  \t%@", testString )
else
NSLog( @"Not an email address: \t%@ ", testString )
end if
next

HandleEvents


