
/*
   Regex Find Years

   Find how many times each year in the 20th or 21st century
   is mentioned in a historical Wikipedia article.

   Ken Shmidheiser 20181011
*/

include "Tlbx CocoaUI.incl"
cocoainit

include "NSLog.incl"

dim as CFURLRef    url
dim as CFStringRef findYears, regexPattern, yearMatch
dim as CFArrayRef  matches
dim as CFRange     range
dim as RegularExpressionRef  regex
dim as TextCheckingResultRef matchResult

url = fn URLWithString( @"https://en.wikipedia.org/wiki/Diplomatic_history_of_World_War_II" )
findYears = fn StringWithContentsOfURL( url, NSMacOSRomanStringEncoding, NULL )

regexPattern = @"\\b(?:19|20)\\d{2}\\b"

regex = fn RegularExpressionWithPattern( regexPattern, NSRegularExpressionCaseInsensitive, NULL )
range = fn CFRangeMake( 0, fn StringLength( findYears ) )
matches = fn RegularExpressionMatches( regex, findYears, NULL, range )

for matchResult in matches
yearMatch = fn StringSubstringWithRange( findYears, fn TextCheckingResultRangeAtIndex( matchResult, 0 ) )
NSLog( @"%@", yearMatch )
next

HandleEvents


