
#include "MachTimer.h"

static uint64_t ClockLatency()
{
	uint64_t   t0, t1;
	int        k;
	uint64_t   latency;
	
	latency = 999999999ULL;
	for ( k = 0; k < 100; k++ )
	{
		t0 = mach_absolute_time();
		t1 = mach_absolute_time();
		if ( t1 - t0 < latency ) latency = t1 - t0;
	}
	return latency;
} 


double IntervalNanoseconds( uint64_t t1, uint64_t t0 )
{
	static double    scale;
	static int       inited;
	static uint64_t  latency;
	if ( !inited )
	{
		mach_timebase_info_data_t info;
		mach_timebase_info( &info );
		inited = 1;
		scale = info.numer/info.denom;
		latency = ClockLatency();
	}
	return scale*(t1 - t0 - latency);
}


