// Compiled as Objective-C because the compiler recognises the .m extension.

/*
 Note that we don't import Cocoa in TestObjC.h
 Importing it here allows the rest of the program to be compiled by the plain C compiler.
 */

#import <Cocoa/Cocoa.h> 

#include "TestObjC.h"

Boolean MyNSApplicationLoad( void )
{
	return NSApplicationLoad();
}



/*
// this version proves only that Objective-C is a superset of C
int PlusOneObjC( int x ) 
{
	return x + 1;
}
*/


// this version proves that we can use Cocoa methods
int PlusOneObjC( int x ) 
{
	NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init]; // Cocoa-in-Carbon wrapper
	
	// Cocoa code here ...	
    NSNumber *aNumber = [NSNumber numberWithInt:x + 1];
	int y = [aNumber intValue]; 
	
	[pool release]; // end of Cocoa-in-Carbon wrapper
	return y;
}
