/*
This demo of HICocoaView requires:
- OS X 10.5 or higher
- working internet connection (because a WebView is used as the demo NSView)


rp:20071031
*/

include "Tlbx HIView.incl"
include "Tlbx IBCarbonRuntime.incl"
include "Tlbx HICocoaView.incl"

include library "WebKit/WebKit.h" // for WebView
include resources "main.nib" // file to be copied to <app>/Contents/Resources/en.lproj

#if ndef _DEFINEDINCARBON
//#define NSView as ptr - now in Tlbx HICocoaView.incl Brian   {20140429}
#define WebView as NSView
#endif
toolbox fn NSApplicationLoad = long

// HICocoaView.h - these toolboxes now in Tlbx HICocoaView.incl Brian   {20140429}
//toolbox fn HICocoaViewGetView( HIViewRef inHIView ) = ptr //to NSView 
//toolbox fn HICocoaViewSetView( HIViewRef inHIView, NSView *inNSView ) = OSStatus
//toolbox fn HICocoaViewCreate( NSView *inNSView, OptionBits inOptions, HIViewRef *outHIView ) = OSStatus

end globals


local fn BuildWindow
'~'1
dim as IBNibRef     nib
dim as WindowRef    w
dim as HIViewRef    myHICocoaView
dim as HIViewID     kMyHICocoaViewID
dim as CFStringRef  urlText
dim as ^WebView     myWebView

BeginCCode// ObjC
NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init]; // standard Cocoa-in-Carbon wrapper
myWebView = [[WebView alloc] init];
EndC

urlText = @"http://www.apple.com"

long if ( fn CreateNibReference( @"main", @nib ) == _noErr ) // matching the nib
long if ( fn CreateWindowFromNib( nib, @"Window", @w ) == _noErr ) // matching the nib
kMyHICocoaViewID.signature = _"Test": kMyHICocoaViewID.id = 1 // matching the nib
ShowWindow( w )
fn HIViewFindByID( fn HIViewGetRoot( w), kMyHICocoaViewID, @myHICocoaView )
long if ( myHICocoaView  ) 
fn HICocoaViewSetView( myHICocoaView, #myWebView )
BeginCCode// ObjC
[[myWebView mainFrame] loadRequest:[NSURLRequest requestWithURL:[NSURL URLWithString:(NSString*)urlText]]];
EndC
end if
fn SetUserFocusWindow( w )
end if
DisposeNibReference( nib )
end if

BeginCCode// ObjC
[myWebView release];
[pool release]; // end of standard Cocoa-in-Carbon wrapper
EndC

end fn

// main program
fn NSApplicationLoad() // standard Cocoa-in-Carbon
fn BuildWindow
RunApplicationEventLoop()

