//
//  CFDictionary Additions.h
//
//  Bernie Wylde 20091222
//

#include "CFEnumerator.h"

#ifndef CFDICTIONARY_ADDITIONS_H
#define CFDICTIONARY_ADDITIONS_H

// create
CFDictionaryRef CFDictionaryCreateWithContentsOfFile( FSRef *ref );
CFDictionaryRef CFDictionaryCreateWithContentsOfURL( CFURLRef url );
CFDictionaryRef CFDictionaryCreateWithValuesForKeys( CFArrayRef values, CFArrayRef keys );
CFDictionaryRef CFDictionaryCreateWithValuesAndKeys( CFTypeRef val, ... );

// add
void CFDictionaryAddDictionary( CFMutableDictionaryRef dict, CFDictionaryRef otherDict );
void CFDictionarySetDictionary( CFMutableDictionaryRef dict, CFDictionaryRef otherDict );

// remove
void CFDictionaryRemoveValuesForKeys( CFMutableDictionaryRef dict, CFArrayRef keys );

// compare
Boolean CFDictionaryIsEqualToDictionary( CFDictionaryRef dict1, CFDictionaryRef dict2 );

// accessing keys and values
CFArrayRef CFDictionaryCreateArrayOfAllKeys( CFDictionaryRef dict );
CFArrayRef CFDictionaryCreateArrayOfAllKeysForValue( CFDictionaryRef dict, CFTypeRef value );
CFArrayRef CFDictionaryCreateArrayOfAllValues( CFDictionaryRef dict );
CFArrayRef CFDictionaryCreateArrayOfValuesForKeys( CFDictionaryRef dict, CFArrayRef keys, CFTypeRef notFoundMarker );

// enumerating
CFEnumeratorRef CFDictionaryCreateKeyEnumerator( CFDictionaryRef dict );
CFEnumeratorRef CFDictionaryCreateValueEnumerator( CFDictionaryRef dict );

// store
Boolean CFDictionaryWriteToFile( CFDictionaryRef dict, FSRef *parRef, CFStringRef filename );
Boolean CFDictionaryWriteToPath( CFDictionaryRef dict, CFStringRef path );
Boolean CFDictionaryWriteToURL( CFDictionaryRef dict, CFURLRef url );

// description
CFStringRef CFDictionaryCreateDescription( CFDictionaryRef dict );
CFStringRef CFDictionaryCreateDescriptionInStringsFileFormat( CFDictionaryRef dict );

#endif	/*CFDICTIONARY_ADDITIONS_H*/
