//
//  CFIndexSet.h
//  
//  Bernie Wylde 20091214
//

#ifndef CFINDEXSET_H
#define CFINDEXSET_H

typedef CFTypeRef CFIndexSetRef;
typedef CFTypeRef CFMutableIndexSetRef;

// create
CFIndexSetRef CFIndexSetCreateWithIndex( CFIndex index );
CFIndexSetRef CFIndexSetCreateWithIndexesInRange( CFRange range );
CFIndexSetRef CFIndexSetCreateWithIndexSet( CFIndexSetRef set );
CFMutableIndexSetRef CFIndexSetCreateMutable( void );

// query
CFIndex CFIndexSetGetCount( CFIndexSetRef set );
Boolean CFIndexSetContainsIndex( CFIndexSetRef set, CFIndex index );
Boolean CFIndexSetContainsIndexes( CFIndexSetRef set, CFIndexSetRef indexSet );
Boolean CFIndexSetContainsIndexesInRange( CFIndexSetRef set, CFRange range );
Boolean CFIndexSetIntersectsIndexesInRange( CFIndexSetRef set, CFRange range );
CFIndex CFIndexSetGetCountOfIndexesInRange( CFIndexSetRef set, CFRange range );

// compare
Boolean CFIndexSetIsEqualToIndexSet( CFIndexSetRef set1, CFIndexSetRef set2 );

// add
void CFIndexSetAddIndex( CFMutableIndexSetRef set, CFIndex index );
void CFIndexSetAddIndexes( CFMutableIndexSetRef set, CFIndexSetRef indexSet );
void CFIndexSetAddIndexesInRange( CFMutableIndexSetRef set, CFRange range );

// remove
void CFIndexSetRemoveIndex( CFMutableIndexSetRef set, CFIndex index );
void CFIndexSetRemoveIndexes( CFMutableIndexSetRef set, CFIndexSetRef indexSet );
void CFIndexSetRemoveAllIndexes( CFMutableIndexSetRef set );
void CFIndexSetRemoveIndexesInRange( CFMutableIndexSetRef set, CFRange range );

// get
CFIndex CFIndexSetGetFirstIndex( CFIndexSetRef set );
CFIndex CFIndexSetGetLastIndex( CFIndexSetRef set );
CFIndex CFIndexSetGetIndexLessThanIndex( CFIndexSetRef set, CFIndex index );
CFIndex CFIndexSetGetIndexLessThanOrEqualToIndex( CFIndexSetRef set, CFIndex index );
CFIndex CFIndexSetGetIndexGreaterThanIndex( CFIndexSetRef set, CFIndex index );
CFIndex CFIndexSetGetIndexGreaterThanOrEqualToIndex( CFIndexSetRef set, CFIndex index );
CFIndex CFIndexSetGetIndexes( CFIndexSetRef set, CFIndex *indexBuffer, CFIndex bufferSize, void *range );

// shift
void CFIndexSetShiftIndexes( CFMutableIndexSetRef set, CFIndex startIndex, SInt32 delta );

#endif	/*CFINDEXSET_H*/

