
/*
   CFScanner demo

   Bernie Wylde 20100124
*/

//include "ConsoleWindow"
include "CFScanner.incl"


dim as Str255              s
dim as CFCharacterSetRef   set
dim as CFStringRef         string, product
dim as HIRect              r
dim as CFScannerRef        scanner
dim as double              cost
dim as long                sold, value

//window _FBConsoleWndNum, @"CFScanner"


// CFScannerScanSingle - skip whitespace
print "CFScannerScanSingle - skip whitespace"
scanner = fn CFScannerCreate( @"10.0 20.0 30.0 40.0" )
fn CFScannerScanSingle( scanner, @r.origin.x )
fn CFScannerScanSingle( scanner, @r.origin.y )
fn CFScannerScanSingle( scanner, @r.size.width )
fn CFScannerScanSingle( scanner, @r.size.height )
CFRelease( scanner )
print using "##.#";r.origin.x,using "##.#";r.origin.y,using "##.#";r.size.width,using "##.#";r.size.height


// CFScannerScanLong - skip comma
print : print "CFScannerScanLong - skip comma"
scanner = fn CFScannerCreate( @"42,87,13,23,100,56" )
set = fn CFCharacterSetCreateWithCharactersInString( _kCFAllocatorDefault, @"," )
CFScannerSetCharactersToBeSkipped( scanner, set )
CFRelease( set )
while ( fn CFScannerIsAtEnd( scanner ) == _false )
fn CFScannerScanLong( scanner, (ptr)@value )
print value,
wend
print
CFRelease( scanner )


// CFScannerScanUpToCharactersFromSet
print : print "CFScannerScanUpToCharactersFromSet  - skip whitespace & newline"
scanner = fn CFScannerCreate( @"alpha bravo charlie delta echo foxtrot" )
set = fn CFCharacterSetGetPredefined( _kCFCharacterSetWhitespaceAndNewline )
while ( fn CFScannerIsAtEnd( scanner ) == _false )
fn CFScannerScanUpToCharactersFromSet( scanner, set, @string )
fn CFStringGetPascalString( string, @s, 256, 0 )
print s
CFRelease( string )
wend
CFRelease( scanner )


// CFScannerScanString ...UpToString ...Double ...Long - skip whitespace and newline
print : print "CFScannerScanString CFScannerScanUpToString CFScannerScanDouble CFScannerScanLong"
string = @"Product: Acme Potato Peeler; Cost: 0.98 73\nProduct: Chef Pierre Pasta Fork; Cost: 0.75 19\nProduct: Chef Pierre Colander; Cost: 1.27 2\n"
scanner = fn CFScannerCreate( string )
while ( fn CFScannerIsAtEnd( scanner ) == _false )
fn CFScannerScanString( scanner, @"Product:", 0 )
fn CFScannerScanUpToString( scanner, @";", @product )
fn CFScannerScanString( scanner, @";", 0 )
fn CFScannerScanString( scanner, @"Cost:", 0 )
fn CFScannerScanDouble( scanner, @cost )
fn CFScannerScanLong( scanner, (ptr)@sold )
fn CFStringGetPascalString( product, @s, 256, 0 )
CFRelease( product )
print s,cost,sold,cost*sold
wend
CFRelease( scanner )


RunApplicationEventLoop

