//
//  CFScanner.h
//  
//  Bernie Wylde 20100119
//

#ifndef CFSCANNER_H
#define CFSCANNER_H

typedef CFTypeRef CFScannerRef;

// create
CFScannerRef CFScannerCreate( CFStringRef string );
CFScannerRef CFScannerCreateLocalized( CFStringRef string );

// string
CFStringRef CFScannerCopyString( CFScannerRef scanner );

// configure
void CFScannerSetScanLocation( CFScannerRef scanner, CFIndex index );
CFIndex CFScannerGetScanLocation( CFScannerRef scanner );
void CFScannerSetCaseSensitive( CFScannerRef scanner, Boolean flag );
Boolean CFScannerIsCaseSensitive( CFScannerRef scanner );
void CFScannerSetCharactersToBeSkipped( CFScannerRef scanner, CFCharacterSetRef set );
CFCharacterSetRef CFScannerCopyCharactersToBeSkipped( CFScannerRef scanner );
void CFScannerSetLocale( CFScannerRef scanner, CFLocaleRef locale );
CFLocaleRef CFScannerCopyLocale( CFScannerRef scanner );

// scan
Boolean CFScannerScanCharactersFromSet( CFScannerRef scanner, CFCharacterSetRef set, CFStringRef *string );
Boolean CFScannerScanUpToCharactersFromSet( CFScannerRef scanner, CFCharacterSetRef set, CFStringRef *string );
Boolean CFScannerScanDouble( CFScannerRef scanner, double *value );
Boolean CFScannerScanSingle( CFScannerRef scanner, float *value );
Boolean CFScannerScanHexDouble( CFScannerRef scanner, double *value );
Boolean CFScannerScanHexSingle( CFScannerRef scanner, float *value );
Boolean CFScannerScanHexLong( CFScannerRef scanner, unsigned *value );
Boolean CFScannerScanHexUInt64( CFScannerRef scanner, unsigned long long *value );
Boolean CFScannerScanLong( CFScannerRef scanner, int *value );
Boolean CFScannerScanSInt64( CFScannerRef scanner, long long *value );
Boolean CFScannerScanString( CFScannerRef scanner, CFStringRef string, CFStringRef *outString );
Boolean CFScannerScanUpToString( CFScannerRef scanner, CFStringRef string, CFStringRef *outString );
Boolean CFScannerIsAtEnd( CFScannerRef scanner );

#endif	/*CFSCANNER_H*/