//
//  CFSortDescriptor.m
//  
//  Bernie Wylde 20091222
//

#import <Foundation/Foundation.h>
#import "CFSortDescriptor.h"

// create
CFSortDescriptorRef CFSortDescriptorCreate( CFStringRef key, Boolean ascending )
{ return (CFSortDescriptorRef)[[NSSortDescriptor alloc] initWithKey:(NSString *)key ascending:ascending]; }

CFSortDescriptorRef CFSortDescriptorCreateCaseInsensitiveCompare( CFStringRef key, Boolean ascending )
{ return (CFSortDescriptorRef)[[NSSortDescriptor alloc] initWithKey:(NSString *)key ascending:ascending selector:@selector(caseInsensitiveCompare:)]; }


// getting information about a Sort Descriptor
Boolean CFSortDescriptorIsAscending( CFSortDescriptorRef descriptor )
{ return (Boolean)[(NSSortDescriptor *)descriptor ascending]; }

CFStringRef CFSortDescriptorGetKey( CFSortDescriptorRef descriptor )
{ return (CFStringRef)[(NSSortDescriptor *)descriptor key]; }


// using Sort Descriptors
CFSortDescriptorRef CFSortDescriptorReversedSortCopy( CFSortDescriptorRef descriptor )
{ return (CFSortDescriptorRef)[[(NSSortDescriptor *)descriptor reversedSortDescriptor] retain]; }



