//
//  CFIndexSet.m
//  
//  Bernie Wylde 20091214
//

#import <Foundation/Foundation.h>
#import "CFIndexSet.h"

// create
CFIndexSetRef CFIndexSetCreateWithIndex( CFIndex index )
{
	return (CFIndexSetRef)[[NSIndexSet alloc] initWithIndex:(NSUInteger)index];
}

CFIndexSetRef CFIndexSetCreateWithIndexesInRange( CFRange range )
{
	return (CFIndexSetRef)[[NSIndexSet alloc] initWithIndexesInRange:(*(NSRange*)&range)];
}

CFIndexSetRef CFIndexSetCreateWithIndexSet( CFIndexSetRef set )
{
	return (CFIndexSetRef)[[NSIndexSet alloc] initWithIndexSet:(NSMutableIndexSet *)set];
}

CFMutableIndexSetRef CFIndexSetCreateMutable( void )
{
	return (CFMutableIndexSetRef)[[NSMutableIndexSet alloc] init];
}


// query
CFIndex CFIndexSetGetCount( CFIndexSetRef set )
{
	return [(NSIndexSet *)set count];
}

Boolean CFIndexSetContainsIndex( CFIndexSetRef set, CFIndex index )
{
	return [(NSIndexSet *)set containsIndex:index];
}

Boolean CFIndexSetContainsIndexes( CFIndexSetRef set, CFIndexSetRef indexSet )
{
	return [(NSIndexSet *)set containsIndexes:(NSIndexSet *)indexSet];
}

Boolean CFIndexSetContainsIndexesInRange( CFIndexSetRef set, CFRange range )
{
	return [(NSIndexSet *)set containsIndexesInRange:(*(NSRange*)&range)];
}

Boolean CFIndexSetIntersectsIndexesInRange( CFIndexSetRef set, CFRange range )
{
	return [(NSIndexSet *)set intersectsIndexesInRange:(*(NSRange*)&range)];
}

CFIndex CFIndexSetGetCountOfIndexesInRange( CFIndexSetRef set, CFRange range )
{
	return [(NSIndexSet *)set countOfIndexesInRange:(*(NSRange*)&range)];
}


// compare
Boolean CFIndexSetIsEqualToIndexSet( CFIndexSetRef set1, CFIndexSetRef set2 )
{
	return [(NSIndexSet *)set1 isEqualToIndexSet:(NSIndexSet *)set2];
}


// add
void CFIndexSetAddIndex( CFIndexSetRef set, CFIndex index )
{
	[(NSMutableIndexSet *)set addIndex:index];	
}

void CFIndexSetAddIndexes( CFIndexSetRef set, CFIndexSetRef indexSet )
{
	[(NSMutableIndexSet *)set addIndexes:(NSIndexSet *)indexSet];	
}

void CFIndexSetAddIndexesInRange( CFIndexSetRef set, CFRange range )
{
	[(NSMutableIndexSet *)set addIndexesInRange:(*(NSRange*)&range)];	
}


// remove
void CFIndexSetRemoveIndex( CFIndexSetRef set, CFIndex index )
{
	[(NSMutableIndexSet *)set removeIndex:index];	
}

void CFIndexSetRemoveIndexes( CFIndexSetRef set, CFIndexSetRef indexSet )
{
	[(NSMutableIndexSet *)set removeIndexes:(NSIndexSet *)indexSet];
}

void CFIndexSetRemoveAllIndexes( CFIndexSetRef set )
{
	[(NSMutableIndexSet *)set removeAllIndexes];	
}

void CFIndexSetRemoveIndexesInRange( CFIndexSetRef set, CFRange range )
{
	[(NSMutableIndexSet *)set removeIndexesInRange:(*(NSRange*)&range)];	
}


// get
CFIndex CFIndexSetGetFirstIndex( CFIndexSetRef set )
{
	return [(NSIndexSet *)set firstIndex];	
}

CFIndex CFIndexSetGetLastIndex( CFIndexSetRef set )
{
	return [(NSIndexSet *)set lastIndex];	
}

CFIndex CFIndexSetGetIndexLessThanIndex( CFIndexSetRef set, CFIndex index )
{
	return [(NSIndexSet *)set indexLessThanIndex:index];	
}

CFIndex CFIndexSetGetIndexLessThanOrEqualToIndex( CFIndexSetRef set, CFIndex index )
{
	return [(NSIndexSet *)set indexLessThanOrEqualToIndex:index];	
}

CFIndex CFIndexSetGetIndexGreaterThanIndex( CFIndexSetRef set, CFIndex index )
{
	return [(NSIndexSet *)set indexGreaterThanIndex:index];	
}

CFIndex CFIndexSetGetIndexGreaterThanOrEqualToIndex( CFIndexSetRef set, CFIndex index )
{
	return [(NSIndexSet *)set indexGreaterThanOrEqualToIndex:index];	
}

CFIndex CFIndexSetGetIndexes( CFIndexSetRef set, CFIndex *indexBuffer, CFIndex bufferSize, void *range )
{
	return (CFIndex)[(NSIndexSet *)set getIndexes:(NSUInteger *)indexBuffer maxCount:(NSUInteger)bufferSize inIndexRange:range];
}


// shift
void CFIndexSetShiftIndexes( CFMutableIndexSetRef set, CFIndex startIndex, SInt32 delta )
{
	[(NSMutableIndexSet *)set shiftIndexesStartingAtIndex:startIndex by:delta];
}


