//
//  NSLog.h
//  
//  Bernie Wylde 20130725
//

#import <Cocoa/Cocoa.h>

#define _NSLOG 1

extern const NSString *NSLogVers;

// sending messages
void NSLog( NSString *formatString, ... );
void NSLogAlert( NSString *formatString, ... );
int printf( const char *format, ... );

// clearing the log
void NSLogClear();

// message appearance and format
void NSLogSetShowsDate( BOOL flag );
void NSLogSetShowsTime( BOOL flag );
void NSLogSetShowsAppName( BOOL flag );
void NSLogSetShowsProcessID( BOOL flag );
void NSLogSetFont( NSString *name, CGFloat size );
void NSLogSetTempFont( NSString *name, CGFloat size );
NSFont *NSLogFont();
void NSLogRestoreDefaultFont();

// suppressing log output
void NSLogSuppress( BOOL flag );

// accessing message text
NSString *NSLogString();
void NSLogWriteToURL( NSURL *url );
void NSLogSave( NSString *message, NSString *filename );

// window
void NSLogSetTitle( NSString *title );
void NSLogSetFrame( NSRect r );
NSRect NSLogFrame();
void NSLogShow();
void NSLogHide();
NSPanel *NSLogWindow();
void NSLogSetFloatingWindow( BOOL flag );
void NSLogSetBecomesKeyOnlyIfNeeded( BOOL flag );
void NSLogSetTerminateAppWhenWindowClosed( BOOL flag );

// buttons
void NSLogSettingsButtonSetHidden( BOOL flag );
void NSLogWrapTextButtonSetHidden( BOOL flag );
void NSLogNewVersionAvailableButtonSetHidden( BOOL flag );
void NSLogFindButtonSetHidden( BOOL flag );
void NSLogSaveButtonSetHidden( BOOL flag );
void NSLogClearButtonSetHidden( BOOL flag );
void NSLogButtonsSetHidden( BOOL flag );

// console
void NSLogSetForwardToConsole( BOOL flag );

// check for updates
void NSLogSetCheckForUpdates( BOOL flag );



