//
// Although the Alias Manager is not yet flagged as legacy, obsolete or deprecated,
// looks like its replacement is [going to be] bookmarks. 
// The following creates bookmark data from a chosen file and stores it in app prefs. 
// File menus are Choose File & Resolve Bookmark.

//With an extra line of code, we can achieve same with bookmarks.
//The advantage of bookmarks is they are valid between OS reboots. This second example stores the bookmark in app prefs.

'---------------
/*
Bookmark Demo 1

Bernie Wylde 20120623
*/

begin globals
dim as CFDataRef gBookmarkData
end globals

_mainWnd = 1
begin enum 1
_cSaveBtn
_cOpenBtn
end enum

_openBatchFileNum = 2

local fn SaveBtn
'~'1
dim as Str255 s
dim as CFURLRef url

s = files$( _CFURLRefSave, "Create a new Surface Tension project", "Teds files", @url )
long if ( s )
open "O", _openBatchFileNum, @url
print #_openBatchFileNum, "Hello"
close #_openBatchFileNum
if ( gBookmarkData ) then CFRelease( gBookmarkData )
gBookmarkData = fn CFURLCreateBookmarkData( _kCFAllocatorDefault, url, _kCFURLBookmarkCreationMinimalBookmarkMask, 0, 0, NULL )
CFRelease( url )
end if
end fn

local fn OpenBtn
'~'1
dim as Str255 s
dim as CFURLRef url

long if ( gBookmarkData )
url = fn CFURLCreateByResolvingBookmarkData( _kCFAllocatorDefault, gBookmarkData, 0, 0, 0, NULL, NULL )
long if ( url )
open "I", _openBatchFileNum, @url
line input #_openBatchFileNum, s
close _openBatchFileNum
print s
CFRelease( url )
end if
end if
end fn

local fn BuildWindow
'~'1
dim as Rect r

SetRect( r, 0, 0, 516, 366 )
appearance window -_mainWnd, @"Bookmark", @r, _kDocumentWindowClass

SetRect( r, 20, 326, 90, 346 )
appearance button _cSaveBtn,,,,, @"Save", @r, _kControlPushButtonProc

SetRect( r, 102, 326, 172, 346 )
appearance button _cOpenBtn,,,,, @"Open", @r, _kControlPushButtonProc

window _mainWnd
end fn

local fn DoDialog
'~'1
dim as long ev, id

ev = dialog( 0 )
id = dialog( ev )
select ( ev )
case _btnClick
select ( id )
case _cSaveBtn : fn SaveBtn
case _cOpenBtn : fn OpenBtn
end select
end select
end fn

fn BuildWindow

on dialog fn DoDialog

do
HandleEvents
until gFBQuit
'---------------



