
/*
Although the Alias Manager is not yet flagged as legacy, obsolete or deprecated,
looks like its replacement is [going to be] bookmarks. 
The following creates bookmark data from a chosen file and stores it in app prefs.
File menus are Choose File & Rsolve Bookmark.

Bookmark demo 3

Bernie Wylde 20111208
*/

if ( system(_sysVers) < 1060 ) then shutdown "Requires OS X 10.6 or later"

include "Util_FileDirectory.incl"
include "Util_CFPrefs.incl"

_mFile = 1
_iChooseFile = 1
_iResolveBookmark = 2

_mainWnd = 1

_kMyBookmarkPrefsKey$ = "MyBookmark"

local fn ResolveBookmark
'~'1
dim as CFDataRef bookmarkData
dim as CFURLRef url
dim as CFStringRef path
dim as Str255 s

bookmarkData = fn CFPrefsCopyAppValue( _kMyBookmarkPrefsKey$ )
long if ( bookmarkData )
url = fn CFURLCreateByResolvingBookmarkData( _kCFAllocatorDefault, bookmarkData, 0, 0, 0, #0, #0 )
long if ( url )

// do something with url

fn FD_CFURLCreatePath( url, @path )
fn CFStringGetPascalString( path, @s, 256, _kCFStringEncodingMacRoman )
print "Bookmark resolved: "s
CFRelease( path )
CFRelease( url )
xelse
print "Unable to resolve bookmark"
end if
CFRelease( bookmarkData )
xelse
print "No bookmark data"
end if
end fn

local fn MyChooseFileHandler( reply as ^NavReplyRecord, userData as pointer )
'~'1
dim as CFURLRef url
dim as CFDataRef bookmarkData

NavDialog_CopyItemCFURLRef( #reply, 1, @url )
bookmarkData = fn CFURLCreateBookmarkData( _kCFAllocatorDefault, url, _kCFURLBookmarkCreationMinimalBookmarkMask, 0, 0, #0 )
long if ( bookmarkData )
fn CFPrefsSetAppValue( _kMyBookmarkPrefsKey$, bookmarkData )
CFRelease( bookmarkData )
fn CFPrefsAppSynchronize()
window _mainWnd
print "Bookmark stored"
end if
end fn

local fn HandleMenu
'~'1
select ( menu( _itemID ) )
case _iChooseFile : fn NavDialog( _kNavDialogChooseFile + _kNavDialogSheet, "Choose file", "", @fn MyChooseFileHandler, 0 )
case _iResolveBookmark : fn ResolveBookmark()
end select
end fn

menu _mFile, 0, _enable, @"File"
menu _mFile, _iChooseFile, _enable, @"Choose File/O"
menu _mFile, _iResolveBookmark, _enable, @"Resolve Bookmark/R"

on menu fn HandleMenu

window _mainWnd, @"Bookmark demo 1", (0,0)-(400,300)
fn ResolveBookmark()

RunApplicationEventLoop()


