/*
 AppThings.m
 
 Bernie Wylde 20160408
 */

#import "FBtoC.h"
#import "Runtime.h"

void FBFullStop( CFStringRef msg, CFStringRef info, FBBoolean fatal )
{
    NSAlert *alert = [[NSAlert alloc] init];
    [alert setMessageText:(__bridge NSString *)msg];
    [alert setInformativeText:(__bridge NSString *)info];
    if ( fatal ) {
        [alert setAlertStyle:NSCriticalAlertStyle];
        [alert addButtonWithTitle:NSLocalizedStringFromTable( @"Quit",@"Runtime",@"FBFullStop" )];
        [alert addButtonWithTitle:NSLocalizedStringFromTable( @"Crash",@"Runtime",@"FBFullStop" )];
    } else {
        [alert setAlertStyle:NSWarningAlertStyle];
        [alert addButtonWithTitle:NSLocalizedStringFromTable( @"Stop",@"Runtime",@"FBFullStop" )];
        [alert addButtonWithTitle:NSLocalizedStringFromTable( @"Continue",@"Runtime",@"FBFullStop" )];
        [alert addButtonWithTitle:NSLocalizedStringFromTable( @"Crash",@"Runtime",@"FBFullStop" )];
    }
    // unfortunately NSModalResponse is OS X 10.9+, so NSInteger used. See NSApplication.h: 'typedef NSInteger NSModalResponse NS_AVAILABLE_MAC(10_9);' // Brian 20160410
    
    //NSInteger response = [alert runModal]; //2021-Sep-26 Brian - updated to NSModalResponse which is 10.9+
    NSModalResponse response = [alert runModal];
    //if ( response == NSAlertFirstButtonReturn ) ExitToShell(); //2021-Sep-26 Brian. ExitToShell() deprecated in macOS 10.9
    if ( response == NSAlertFirstButtonReturn ) [NSApp terminate:nil];
    //if ( fatal == YES || response == NSAlertThirdButtonReturn ) abort();
    if ( fatal || response == NSAlertThirdButtonReturn ) abort();// 20210407 brian
    [alert release];
}

