/*
 Appearance.h
 
 Bernie Wylde
 */


#import "CocoaUI.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

typedef void (*CUI_AppearancePerformAsCurrentDrawingCallbackType)(NSAppearance*,void*);

// Class
Class AppearanceClass( void );

// Name
CFStringRef AppearanceName( NSAppearance *ref );

// Appearance
NSAppearance *AppearanceNamed( CFStringRef name );

// Most appropriate appearance
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101400
CFStringRef AppearanceBestMatchFromAppearancesWithNames( NSAppearance *ref, CFArrayRef names );
#endif

// Current appearance
NSAppearance *AppearanceCurrent( void );
void AppearanceSetCurrent( NSAppearance *ref );

// Vibrancy
BOOL AppearanceAllowsVibrancy( NSAppearance *ref );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101600
// Type properties
NSAppearance *AppearanceCurrentDrawing( void );

// Instance methods
void AppearancePerformAsCurrentDrawing( NSAppearance *ref, CUI_AppearancePerformAsCurrentDrawingCallbackType callback, void *userData );
#endif// 101600

#endif// 101000
