/*
 AppleScript.m
 
 Bernie Wylde
 */

#import "AppleScript.h"

// Class
Class AppleScriptClass( void )
{ return [NSAppleScript class]; }

// -- init --
NSAppleScript *AppleScriptWithContentsOfURL( CFURLRef url, CFDictionaryRef *errInfo )
{ return [[[NSAppleScript alloc] initWithContentsOfURL:(__bridge NSURL *)url error:(NSDictionary **)errInfo] autorelease]; }

NSAppleScript *AppleScriptWithSource( CFStringRef source )
{ return [[[NSAppleScript alloc] initWithSource:(__bridge NSString *)source] autorelease]; }

// -- info --
BOOL AppleScriptIsCompiled( NSAppleScript *script )
{ return [script isCompiled]; }

CFStringRef AppleScriptSource( NSAppleScript *script )
{ return (__bridge CFStringRef)[script source]; }

CFAttributedStringRef AppleScriptRichTextSource( NSAppleScript *script )
{ return (__bridge CFAttributedStringRef)[script richTextSource]; }

// -- compile and execute --
BOOL AppleScriptCompile( NSAppleScript *script, CFDictionaryRef *errInfo )
{ return [script compileAndReturnError:(NSDictionary **)errInfo]; }

NSAppleEventDescriptor *AppleScriptExecute( NSAppleScript *script, CFDictionaryRef *errInfo )
{ return [script executeAndReturnError:(NSDictionary **)errInfo]; }

NSAppleEventDescriptor *AppleScriptExecuteAppleEvent( NSAppleScript *script, NSAppleEventDescriptor *aeDesc, CFDictionaryRef *errorInfo )
{ return [script executeAppleEvent:aeDesc error:(NSDictionary **)errorInfo]; }


