/*
 AttributeDescription.h
 
 Bernie Wylde
 */

#import <CoreData/CoreData.h>
#import "CocoaUI.h"

// Type
NSAttributeType AttributeDescriptionAttributeType( NSAttributeDescription *ref );
void AttributeDescriptionSetAttributeType( NSAttributeDescription *ref, NSAttributeType type );
CFStringRef AttributeDescriptionAttributeValueClassName( NSAttributeDescription *ref );
void AttributeDescriptionSetAttributeValueClassName( NSAttributeDescription *ref, CFStringRef name );

// Default value
CFTypeRef AttributeDescriptionDefaultValue( NSAttributeDescription *ref );
void AttributeDescriptionSetDefaultValue( NSAttributeDescription *ref, CFTypeRef value );

// Versioning
CFDataRef AttributeDescriptionVersionHash( NSAttributeDescription *ref );

// Transforming attribute value
CFStringRef AttributeDescriptionValueTransformerName( NSAttributeDescription *ref );
void AttributeDescriptionSetValueTransformerName( NSAttributeDescription *ref, CFStringRef name );

// External binary storage
BOOL AttributeDescriptionAllowsExternalBinaryDataStorage( NSAttributeDescription *ref );
void AttributeDescriptionSetAllowsExternalBinaryDataStorage( NSAttributeDescription *ref, BOOL flag );

// Tracking persistent history
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
BOOL AttributeDescriptionPreservesValueInHistoryOnDeletion( NSAttributeDescription *ref );
void AttributeDescriptionSetPreservesValueInHistoryOnDeletion( NSAttributeDescription *ref, BOOL flag );
#endif// 101500

