/*
 AttributeDescription.m
 
 Bernie Wylde
 */

#import "AttributeDescription.h"

// Type
NSAttributeType AttributeDescriptionAttributeType( NSAttributeDescription *ref )
{ return [ref attributeType]; }

void AttributeDescriptionSetAttributeType( NSAttributeDescription *ref, NSAttributeType type )
{ [ref setAttributeType:type]; }

CFStringRef AttributeDescriptionAttributeValueClassName( NSAttributeDescription *ref )
{ return (__bridge CFStringRef)[ref attributeValueClassName]; }

void AttributeDescriptionSetAttributeValueClassName( NSAttributeDescription *ref, CFStringRef name )
{ [ref setAttributeValueClassName:(__bridge NSString *)name]; }

// Default value
CFTypeRef AttributeDescriptionDefaultValue( NSAttributeDescription *ref )
{ return (__bridge CFTypeRef)[ref defaultValue]; }

void AttributeDescriptionSetDefaultValue( NSAttributeDescription *ref, CFTypeRef value )
{ [ref setDefaultValue:(__bridge id)value]; }

// Versioning
CFDataRef AttributeDescriptionVersionHash( NSAttributeDescription *ref )
{ return (__bridge CFDataRef)[ref versionHash]; }

// Transforming attribute value
CFStringRef AttributeDescriptionValueTransformerName( NSAttributeDescription *ref )
{ return (__bridge CFStringRef)[ref valueTransformerName]; }

void AttributeDescriptionSetValueTransformerName( NSAttributeDescription *ref, CFStringRef name )
{ [ref setValueTransformerName:(__bridge NSString *)name]; }

// External binary storage
BOOL AttributeDescriptionAllowsExternalBinaryDataStorage( NSAttributeDescription *ref )
{ return [ref allowsExternalBinaryDataStorage]; }

void AttributeDescriptionSetAllowsExternalBinaryDataStorage( NSAttributeDescription *ref, BOOL flag )
{ [ref setAllowsExternalBinaryDataStorage:flag]; }

// Tracking persistent history
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
BOOL AttributeDescriptionPreservesValueInHistoryOnDeletion( NSAttributeDescription *ref )
{ return [ref preservesValueInHistoryOnDeletion]; }

void AttributeDescriptionSetPreservesValueInHistoryOnDeletion( NSAttributeDescription *ref, BOOL flag )
{ [ref setPreservesValueInHistoryOnDeletion:flag]; }
#endif// 101500

