/*
 ByteCountFormatter.M
 
 Bernie Wylde
 */

#import "ByteCountFormatter.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED > 1080

// Class
Class ByteCountFormatterClass( void )
{ return [NSByteCountFormatter class]; }

// - create -
NSByteCountFormatter *ByteCountFormatterInit( void )
{ return [[[NSByteCountFormatter alloc] init] autorelease]; }

// - string from byte count -
CFStringRef ByteCountFormatterStringFromByteCount( SInt64 byteCount, NSByteCountFormatterCountStyle style )
{ return (__bridge CFStringRef)[NSByteCountFormatter stringFromByteCount:byteCount countStyle:style]; }

// - formatting styles -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
NSFormattingContext ByteCountFormatterFormattingContext( NSByteCountFormatter *ref )
{ return [ref formattingContext]; }

void ByteCountFormatterSetFormattingContext( NSByteCountFormatter *ref, NSFormattingContext ctx )
{ [ref setFormattingContext:ctx]; }
#endif// 101000

NSByteCountFormatterCountStyle ByteCountFormatterCountStyle( NSByteCountFormatter *ref )
{ return [ref countStyle]; }

void ByteCountFormatterSetCountStyle( NSByteCountFormatter *ref, NSByteCountFormatterCountStyle style )
{ [ref setCountStyle:style]; }

BOOL ByteCountFormatterAllowsNonnumericFormatting( NSByteCountFormatter *ref )
{ return [ref allowsNonnumericFormatting]; }

void ByteCountFormatterSetAllowsNonnumericFormatting( NSByteCountFormatter *ref, BOOL flag )
{ [ref setAllowsNonnumericFormatting:flag]; }

BOOL ByteCountFormatterIncludesActualByteCount( NSByteCountFormatter *ref )
{ return [ref includesActualByteCount]; }

void ByteCountFormatterSetIncludesActualByteCount( NSByteCountFormatter *ref, BOOL flag )
{ [ref setIncludesActualByteCount:flag]; }

BOOL ByteCountFormatterIsAdaptive( NSByteCountFormatter *ref )
{ return [ref isAdaptive]; }

void ByteCountFormatterSetAdaptive( NSByteCountFormatter *ref, BOOL flag )
{ [ref setAdaptive:flag]; }

NSByteCountFormatterUnits ByteCountFormatterAllowedUnits( NSByteCountFormatter *ref )
{ return [ref allowedUnits]; }

void ByteCountFormatterSetAllowedUnits( NSByteCountFormatter *ref, NSByteCountFormatterUnits units )
{ [ref setAllowedUnits:units]; }

BOOL ByteCountFormatterIncludesCount( NSByteCountFormatter *ref )
{ return [ref includesCount]; }

void ByteCountFormatterSetIncludesCount( NSByteCountFormatter *ref, BOOL flag )
{ [ref setIncludesCount:flag]; }

BOOL ByteCountFormatterZeroPadsFractionDigits( NSByteCountFormatter *ref )
{ return [ref zeroPadsFractionDigits]; }

void ByteCountFormatterSetZeroPadsFractionDigits( NSByteCountFormatter *ref, BOOL flag )
{ [ref setZeroPadsFractionDigits:flag]; }

// Instance methods
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
CFStringRef ByteCountFormatterStringForObjectValue( NSByteCountFormatter *ref, CFTypeRef obj )
{
    if (@available(macOS 10.15, *)) {
        return (__bridge CFStringRef)[ref stringForObjectValue:(__bridge id)obj];
    }
    return nil;
}

CFStringRef ByteCountFormatterStringFromMeasurement( NSByteCountFormatter *ref, NSMeasurement *measurement )
{
    if (@available(macOS 10.15, *)) {
        return (__bridge CFStringRef)[ref stringFromMeasurement:measurement];
    }
    return nil;
}

// Type methods
CFStringRef ByteCountFormatterStringFromMeasurementCountStyle( NSMeasurement *measurement, NSByteCountFormatterCountStyle countStyle )
{
    if (@available(macOS 10.15, *)) {
        return (__bridge CFStringRef)[NSByteCountFormatter stringFromMeasurement:measurement countStyle:countStyle];
    }
    return nil;
}
#endif// 101500

#endif// 1080

