/*
 CAShapeLayer.m

 Bernie Wylde
 */

#import "CAShapeLayer.h"

// - init -
CAShapeLayer *CAShapeLayerInit( void )
{ return [CAShapeLayer layer]; }

// - path -
//CGPathRef CAShapeLayerPath( CAShapeLayer *layer )
//{
//    ?????
//}

void CAShapeLayerSetPath( CAShapeLayer *layer, NSBezierPath *path )
{
    CGPathRef cgPath = CUI_NSBezierPathToCGPath( path );
    if ( cgPath ) [layer setPath:cgPath];
}

// - properties -
NSColor *CAShapeLayerFillColor( CAShapeLayer *layer )
{ return [NSColor colorWithCGColor:[layer fillColor]]; }

void CAShapeLayerSetFillColor( CAShapeLayer *layer, NSColor *fillColor )
{ [layer setFillColor:[fillColor CGColor]]; }

CFStringRef caShapeLayerFillRule( CAShapeLayer *layer )
{ return (__bridge CFStringRef)[layer fillRule]; }

void CAShapeLayerSetFillRule( CAShapeLayer *layer, CFStringRef fillRule )
{ [layer setFillRule:(__bridge NSString *)fillRule]; }

CFStringRef caShapeLayerLineCap( CAShapeLayer *layer )
{ return (__bridge CFStringRef)[layer lineCap]; }

void CAShapeLayerSetLineCap( CAShapeLayer *layer, CFStringRef lineCap )
{ [layer setLineCap:(__bridge NSString *)lineCap]; }

CFArrayRef CAShapeLayerLineDashPattern( CAShapeLayer *layer )
{ return (__bridge CFArrayRef)[layer lineDashPattern]; }

void CAShapeLayerSetLineDashPattern( CAShapeLayer *layer, CFArrayRef lineDashPattern )
{ [layer setLineDashPattern:(__bridge NSArray *)lineDashPattern]; }

CGFloat CAShapeLayerLineDashPhase( CAShapeLayer *layer )
{ return [layer lineDashPhase]; }

void CAShapeLayerSetLineDashPhase( CAShapeLayer *layer, CGFloat lineDashPhase )
{ [layer setLineDashPhase:lineDashPhase]; }

CFStringRef caShapeLayerLineJoin( CAShapeLayer *layer )
{ return (__bridge CFStringRef)[layer lineJoin]; }

void CAShapeLayerSetLineJoin( CAShapeLayer *layer, CFStringRef lineJoin )
{ [layer setLineJoin:(__bridge NSString *)lineJoin]; }

CGFloat CAShapeLayerLineWidth( CAShapeLayer *layer )
{ return [layer lineWidth]; }

void CAShapeLayerSetLineWidth( CAShapeLayer *layer, CGFloat lineWidth )
{ [layer setLineWidth:lineWidth]; }

CGFloat CAShapeLayerMiterLimit( CAShapeLayer *layer )
{ return [layer miterLimit]; }

void CAShapeLayerSetMiterLimit( CAShapeLayer *layer, CGFloat miterLimit )
{ [layer setMiterLimit:miterLimit]; }

NSColor *CAShapeLayerStrokeColor( CAShapeLayer *layer )
{ return [NSColor colorWithCGColor:[layer strokeColor]]; }

void CAShapeLayerSetStrokeColor( CAShapeLayer *layer, NSColor *strokeColor )
{ [layer setStrokeColor:[strokeColor CGColor]]; }

CGFloat CAShapeLayerStrokeStart( CAShapeLayer *layer )
{ return [layer strokeStart]; }

void CAShapeLayerSetStrokeStart( CAShapeLayer *layer, CGFloat strokeStart )
{ [layer setStrokeStart:strokeStart]; }

CGFloat CAShapeLayerStrokeEnd( CAShapeLayer *layer )
{ return [layer strokeEnd]; }

void CAShapeLayerSetStrokeEnd( CAShapeLayer *layer, CGFloat strokeEnd )
{ [layer setStrokeEnd:strokeEnd]; }


