/*
 ClickGestureRecognizer.m

 Bernie Wylde
 */

#import "ClickGestureRecognizer.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

/*
 Subclass
 */
@implementation CUI_ClickGestureRecognizer
@end

// Class
Class ClickGestureRecognizerClass( void )
{ return [NSClickGestureRecognizer class]; }

// - init -
NSClickGestureRecognizer *ClickGestureRecognizerInit( void *callback, void *userData )
{
    CUI_GestureRecognizerTarget *target = [[[CUI_GestureRecognizerTarget alloc] initWithCallback:callback userData:userData] autorelease];
    return [[[NSClickGestureRecognizer alloc] initWithTarget:target action:@selector(action:)] autorelease];
}

// - configure -
NSUInteger ClickGestureRecognizerButtonMask( NSClickGestureRecognizer *ref )
{ return [ref buttonMask]; }

void ClickGestureRecognizerSetButtonMask( NSClickGestureRecognizer *ref, NSUInteger mask )
{ [ref setButtonMask:mask]; }

NSInteger ClickGestureRecognizerNumberOfClicksRequired( NSClickGestureRecognizer *ref )
{ return [ref numberOfClicksRequired]; }

void ClickGestureRecognizerSetNumberOfClicksRequired( NSClickGestureRecognizer *ref, NSInteger clicks )
{ [ref setNumberOfClicksRequired:clicks]; }

// - instance properties -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101202
NSInteger ClickGestureRecognizerNumberOfTouchesRequired( NSClickGestureRecognizer *ref )
{ return [ref numberOfTouchesRequired]; }

void ClickGestureRecognizerSetNumberOfTouchesRequired( NSClickGestureRecognizer *ref, NSInteger touches )
{ [ref setNumberOfTouchesRequired:touches]; }
#endif

#endif

