/*
  ____                         __   __  __
 /  __| ___   ___   ___   ___ |  | |  ||  |
|  /   / _ \ / __| / _ \ / _ \|  | |  ||  |
|  \__| (_) | (__ | (_) | (_) |  \_/  ||  |
 \____|\___/ \___| \___/|_| |_|\_____/ |__|
 
 CocoaUI.h
 
 Bernie Wylde 20170712 
 */

#import <Quartz/Quartz.h>
#import <objc/runtime.h>

//#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
//#import <CoreImage/CIFilterBuiltins.h>
//#endif

#import "FBtoC.h"
#import "Runtime.h"

#pragma mark - Dev flags



#pragma mark -

// common colors
enum {
    zCurrentColor = -1,// 20211210
    zNoColor = 0,
    //zWhite = 0,// changed to 8 20211229
    zYellow,
    zGreen,
    zCyan,
    zBlue,
    zMagenta,
    zRed,
    zBlack,
    zWhite,// = 8
    zBrown,
    zGray,
    zDarkGray,
    zLightGray,
    zOrange,
    zPurple,
    zClear,
    zText
};


//void CUI_AppRun( void );// 20211002 moved to CUI_AppDelegate.h

// subclass flag
BOOL CUI_IsSubclassFlag( void );
void CUI_SetSubclassFlag( BOOL flag );

// superview
BOOL CUI_IsSuperview( void );
void CUI_SetSuperviewFlag( BOOL flag );
void CUI_AddSuperview( id superview );
id CUI_CurrentSuperview( void );
id CUI_PenultimateSuperview( void );
void CUI_RemoveSuperview( void );
void CUI_SuperviewEndStatement( void );

@class OutlineItem;
@class TableRowView;

#pragma mark - object refs
typedef Class ClassRef;
typedef SEL SELRef;
typedef Ivar IvarRef;
typedef IMP IMPRef;
typedef Method MethodRef;

//typedef Protocol *ProtocolRef;

typedef NSActionCell *ActionCellRef;
typedef NSAffineTransform *AffineTransformRef;
typedef NSAlert *AlertRef;
typedef id<NSAnimatablePropertyContainer> AnimatablePropertyContainerRef;
typedef NSAnimationContext *AnimationContextRef;
typedef NSAnimation *AnimationRef;
typedef NSAppearance *AppearanceRef;
typedef NSAppleEventDescriptor *AppleEventDescriptorRef;
typedef NSAppleEventManager *AppleEventManagerRef;
typedef NSAppleScript *AppleScriptRef;
typedef NSApplication *ApplicationRef;
//typedef NSArray *ArrayRef;
typedef NSAttributeDescription *AttributeDescriptionRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 120000
typedef NSAttributedStringMarkdownParsingOptions *AttributedStringMarkdownParsingOptionsRef;
#endif// 120000
typedef NSAutoreleasePool *AutoreleasePoolRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSBackgroundActivityScheduler *BackgroundActivitySchedulerRef;
#endif// 101000

typedef NSBezierPath *BezierPathRef;
typedef NSBitmapImageRep *BitmapImageRepRef;
typedef NSBlockOperation *BlockOperationRef;
typedef NSBox *BoxRef;
typedef NSBrowser *BrowserRef;
typedef NSBrowserCell *BrowserCellRef;
typedef NSBundle *BundleRef;
typedef NSButton *ButtonRef;
typedef NSButtonCell *ButtonCellRef;
typedef NSByteCountFormatter *ByteCountFormatterRef;

typedef id<CAAction> CAActionRef;
typedef CAAnimation *CAAnimationRef;
typedef CAAnimationGroup *CAAnimationGroupRef;
typedef CABasicAnimation *CABasicAnimationRef;

typedef NSCachedURLResponse *CachedURLResponseRef;

typedef CAEmitterCell *CAEmitterCellRef;
typedef CAEmitterLayer *CAEmitterLayerRef;
typedef CAKeyframeAnimation *CAKeyframeAnimationRef;
typedef CAGradientLayer *CAGradientLayerRef;
typedef CALayer *CALayerRef;
typedef id<CAMediaTiming> CAMediaTimingRef;
typedef CAMediaTimingFunction *CAMediaTimingFunctionRef;
typedef CAPropertyAnimation *CAPropertyAnimationRef;
typedef CAReplicatorLayer *CAReplicatorLayerRef;
typedef CAScrollLayer *CAScrollLayerRef;
typedef CAShapeLayer *CAShapeLayerRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
typedef CASpringAnimation *CASpringAnimationRef;
#endif// 101100

typedef CATextLayer *CATextLayerRef;
typedef CATiledLayer *CATiledLayerRef;
typedef CATransformLayer *CATransformLayerRef;
typedef CATransition *CATransitionRef;
typedef CAValueFunction *CAValueFunctionRef;
//typedef NSCalendar *CalendarRef;
typedef NSCell *CellRef;
//typedef void *CGNSColorRef;

//#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
//typedef CIBarcodeDescriptor *CIBarcodeDescriptorRef;
//typedef CIAztecCodeDescriptor *CIAztecCodeDescriptorRef;
//typedef CIPDF417CodeDescriptor *CIPDF417CodeDescriptorRef;
//typedef CIDataMatrixCodeDescriptor *CIDataMatrixCodeDescriptorRef;
//typedef CIQRCodeDescriptor *CIQRCodeDescriptorRef;
//#endif// 101300
//
//typedef CIColor *CIColorRef;
//typedef CIContext *CIContextRef;
//typedef CIDetector *CIDetectorRef;
//typedef CIFeature *CIFeatureRef;
//
//typedef CIFaceFeature *CIFaceFeatureRef;
//
//typedef CIFilter *CIFilterRef;
//typedef id<CIFilterConstructor> CIFilterConstructorRef;
//typedef CIFilterGenerator *CIFilterGeneratorRef;
//typedef CIFilterShape *CIFilterShapeRef;
//
//typedef CIImage *CIImageRef;
//typedef CIImageAccumulator *CIImageAccumulatorRef;
//
//#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
//typedef CIImageProcessorKernel *CIImageProcessorKernelRef;
//typedef id<CIImageProcessorInput> CIImageProcessorInputRef;
//typedef id<CIImageProcessorOutput> CIImageProcessorOutputRef;
//#endif// 101200
//
//typedef NSCIImageRep *CIImageRepRef;
//
//typedef CIKernel *CIKernelRef;
//
//#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
//typedef CIColorKernel *CIColorKernelRef;
//#endif// 101100
//
//#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
//typedef CIBlendKernel *CIBlendKernelRef;
//#endif//101300
//
//#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
//typedef CIWarpKernel *CIWarpKernelRef;
//#endif// 101100
//
//typedef CIPlugIn *CIPlugInRef;
//typedef id<CIPlugInRegistration> CIPlugInRegistrationRef;
//
//#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
//typedef CIQRCodeFeature *CIQRCodeFeatureRef;
//typedef CIRectangleFeature *CIRectangleFeatureRef;
//#endif// 101000
//
////#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
////typedef CSSearchableItemAttributeSet *CSSearchableItemAttributeSetRef;
////#endif
//
//#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
//typedef CIRenderDestination *CIRenderDestinationRef;
//typedef CIRenderInfo *CIRenderInfoRef;
//typedef CIRenderTask *CIRenderTaskRef;
//#endif// 101300
//
//typedef CISampler *CISamplerRef;
//
//#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
//typedef CITextFeature *CITextFeatureRef;
//#endif// 101100
//
//typedef CIVector *CIVectorRef;
//
//#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
//// CICategoryGradient
//typedef id<CIGaussianGradient> CIGaussianGradientRef;
//typedef id<CIHueSaturationValueGradient> CIHueSaturationValueGradientRef;
//typedef id<CILinearGradient> CILinearGradientRef;
//typedef id<CIRadialGradient> CIRadialGradientRef;
//typedef id<CISmoothLinearGradient> CISmoothLinearGradientRef;
//
//// CICategorySharpen
//typedef id<CISharpenLuminance> CISharpenLuminanceRef;
//typedef id<CIUnsharpMask> CIUnsharpMaskRef;
//typedef id<CICircularScreen> CICircularScreenRef;
//
//// CICategoryHalftoneEffect
//typedef id<CICMYKHalftone> CICMYKHalftoneRef;
//typedef id<CIDotScreen> CIDotScreenRef;
//typedef id<CIHatchedScreen> CIHatchedScreenRef;
//typedef id<CILineScreen> CILineScreenRef;
//
//// CICategoryGeometryAdjustment
//typedef id<CIFourCoordinateGeometryFilter> CIFourCoordinateGeometryFilterRef;
//typedef id<CIBicubicScaleTransform> CIBicubicScaleTransformRef;
//typedef id<CIEdgePreserveUpsample> CIEdgePreserveUpsampleRef;
//typedef id<CIKeystoneCorrectionCombined> CIKeystoneCorrectionCombinedRef;
//typedef id<CIKeystoneCorrectionHorizontal> CIKeystoneCorrectionHorizontalRef;
//typedef id<CIKeystoneCorrectionVertical> CIKeystoneCorrectionVerticalRef;
//typedef id<CILanczosScaleTransform> CILanczosScaleTransformRef;
//typedef id<CIPerspectiveCorrection> CIPerspectiveCorrectionRef;
//typedef id<CIPerspectiveRotate> CIPerspectiveRotateRef;
//typedef id<CIPerspectiveTransform> CIPerspectiveTransformRef;
//typedef id<CIPerspectiveTransformWithExtent> CIPerspectiveTransformWithExtentRef;
//typedef id<CIStraighten> CIStraightenRef;
//
//// CICategoryTransition
//typedef id<CITransitionFilter> CITransitionFilterRef;
//typedef id<CIAccordionFoldTransition> CIAccordionFoldTransitionRef;
//typedef id<CIBarsSwipeTransition> CIBarsSwipeTransitionRef;
//typedef id<CICopyMachineTransition> CICopyMachineTransitionRef;
//typedef id<CIDisintegrateWithMaskTransition> CIDisintegrateWithMaskTransitionRef;
//typedef id<CIDissolveTransition> CIDissolveTransitionRef;
//typedef id<CIFlashTransition> CIFlashTransitionRef;
//typedef id<CIModTransition> CIModTransitionRef;
//typedef id<CIPageCurlTransition> CIPageCurlTransitionRef;
//typedef id<CIPageCurlWithShadowTransition> CIPageCurlWithShadowTransitionRef;
//typedef id<CIRippleTransition> CIRippleTransitionRef;
//typedef id<CISwipeTransition> CISwipeTransitionRef;
//
//// CICategoryCompositeOperation
//typedef id<CICompositeOperation> CICompositeOperationRef;
//
//// CICategoryColorAdjustment
//typedef id<CIColorClamp> CIColorClampRef;
//typedef id<CIColorControls> CIColorControlsRef;
//typedef id<CIColorMatrix> CIColorMatrixRef;
//typedef id<CIColorPolynomial> CIColorPolynomialRef;
//typedef id<CIDepthToDisparity> CIDepthToDisparityRef;
//typedef id<CIDisparityToDepth> CIDisparityToDepthRef;
//typedef id<CIExposureAdjust> CIExposureAdjustRef;
//typedef id<CIGammaAdjust> CIGammaAdjustRef;
//typedef id<CIHueAdjust> CIHueAdjustRef;
//typedef id<CILinearToSRGBToneCurve> CILinearToSRGBToneCurveRef;
//typedef id<CISRGBToneCurveToLinear> CISRGBToneCurveToLinearRef;
//typedef id<CITemperatureAndTint> CITemperatureAndTintRef;
//typedef id<CIToneCurve> CIToneCurveRef;
//typedef id<CIVibrance> CIVibranceRef;
//typedef id<CIWhitePointAdjust> CIWhitePointAdjustRef;
//
//// CICategoryColorEffect
//typedef id<CIColorCrossPolynomial> CIColorCrossPolynomialRef;
//typedef id<CIColorCube> CIColorCubeRef;
//typedef id<CIColorCubesMixedWithMask> CIColorCubesMixedWithMaskRef;
//typedef id<CIColorCubeWithColorSpace> CIColorCubeWithColorSpaceRef;
//typedef id<CIColorCurves> CIColorCurvesRef;
//typedef id<CIColorInvert> CIColorInvertRef;
//typedef id<CIColorMap> CIColorMapRef;
//typedef id<CIColorMonochrome> CIColorMonochromeRef;
//typedef id<CIColorPosterize> CIColorPosterizeRef;
//typedef id<CIDither> CIDitherRef;
//typedef id<CIDocumentEnhancer> CIDocumentEnhancerRef;
//typedef id<CIFalseColor> CIFalseColorRef;
//typedef id<CILabDeltaE> CILabDeltaERef;
//typedef id<CIMaskToAlpha> CIMaskToAlphaRef;
//typedef id<CIMaximumComponent> CIMaximumComponentRef;
//typedef id<CIMinimumComponent> CIMinimumComponentRef;
//typedef id<CIPaletteCentroid> CIPaletteCentroidRef;
//typedef id<CIPalettize> CIPalettizeRef;
//typedef id<CIPhotoEffect> CIPhotoEffectRef;
//typedef id<CISepiaTone> CISepiaToneRef;
//typedef id<CIThermal> CIThermalRef;
//typedef id<CIVignette> CIVignetteRef;
//typedef id<CIVignetteEffect> CIVignetteEffectRef;
//typedef id<CIXRay> CIXRayRef;
//
//// CICategoryTileEffect
//typedef id<CIAffineClamp> CIAffineClampRef;
//typedef id<CIAffineTile> CIAffineTileRef;
//typedef id<CIEightfoldReflectedTile> CIEightfoldReflectedTileRef;
//typedef id<CIFourfoldReflectedTile> CIFourfoldReflectedTileRef;
//typedef id<CIFourfoldRotatedTile> CIFourfoldRotatedTileRef;
//typedef id<CIFourfoldTranslatedTile> CIFourfoldTranslatedTileRef;
//typedef id<CIGlideReflectedTile> CIGlideReflectedTileRef;
//typedef id<CIKaleidoscope> CIKaleidoscopeRef;
//typedef id<CIOpTile> CIOpTileRef;
//typedef id<CIParallelogramTile> CIParallelogramTileRef;
//typedef id<CIPerspectiveTile> CIPerspectiveTileRef;
//typedef id<CISixfoldReflectedTile> CISixfoldReflectedTileRef;
//typedef id<CISixfoldRotatedTile> CISixfoldRotatedTileRef;
//typedef id<CITriangleKaleidoscope> CITriangleKaleidoscopeRef;
//typedef id<CITriangleTile> CITriangleTileRef;
//typedef id<CITwelvefoldReflectedTile> CITwelvefoldReflectedTileRef;
//
//// CICategoryGenerator
//typedef id<CIAttributedTextImageGenerator> CIAttributedTextImageGeneratorRef;
//typedef id<CIAztecCodeGenerator> CIAztecCodeGeneratorRef;
//typedef id<CIBarcodeGenerator> CIBarcodeGeneratorRef;
//typedef id<CICheckerboardGenerator> CICheckerboardGeneratorRef;
//typedef id<CICode128BarcodeGenerator> CICode128BarcodeGeneratorRef;
//typedef id<CILenticularHaloGenerator> CILenticularHaloGeneratorRef;
//typedef id<CIMeshGenerator> CIMeshGeneratorRef;
//typedef id<CIPDF417BarcodeGenerator> CIPDF417BarcodeGeneratorRef;
//typedef id<CIQRCodeGenerator> CIQRCodeGeneratorRef;
//typedef id<CIRandomGenerator> CIRandomGeneratorRef;
//typedef id<CIRoundedRectangleGenerator> CIRoundedRectangleGeneratorRef;
//typedef id<CIStarShineGenerator> CIStarShineGeneratorRef;
//typedef id<CIStripesGenerator> CIStripesGeneratorRef;
//typedef id<CISunbeamsGenerator> CISunbeamsGeneratorRef;
//typedef id<CITextImageGenerator> CITextImageGeneratorRef;
//
//// CICategoryStylize
//typedef id<CIBlendWithMask> CIBlendWithMaskRef;
//typedef id<CIBloom> CIBloomRef;
//typedef id<CIComicEffect> CIComicEffectRef;
//typedef id<CIConvolution> CIConvolutionRef;
//typedef id<CICoreMLModel> CICoreMLModelRef;
//typedef id<CICrystallize> CICrystallizeRef;
//typedef id<CIDepthOfField> CIDepthOfFieldRef;
//typedef id<CIEdges> CIEdgesRef;
//typedef id<CIEdgeWork> CIEdgeWorkRef;
//typedef id<CIGaborGradients> CIGaborGradientsRef;
//typedef id<CIGloom> CIGloomRef;
//typedef id<CIHeightFieldFromMask> CIHeightFieldFromMaskRef;
//typedef id<CIHexagonalPixellate> CIHexagonalPixellateRef;
//typedef id<CIHighlightShadowAdjust> CIHighlightShadowAdjustRef;
//typedef id<CILineOverlay> CILineOverlayRef;
//typedef id<CIMix> CIMixRef;
//typedef id<CIPixellate> CIPixellateRef;
//typedef id<CIPointillize> CIPointillizeRef;
//typedef id<CISaliencyMap> CISaliencyMapRef;
//typedef id<CIShadedMaterial> CIShadedMaterialRef;
//typedef id<CISpotColor> CISpotColorRef;
//typedef id<CISpotLight> CISpotLightRef;
//
//// CICategoryBlur
//typedef id<CIBokehBlur> CIBokehBlurRef;
//typedef id<CIBoxBlur> CIBoxBlurRef;
//typedef id<CIDiscBlur> CIDiscBlurRef;
//typedef id<CIGaussianBlur> CIGaussianBlurRef;
//typedef id<CIMaskedVariableBlur> CIMaskedVariableBlurRef;
//typedef id<CIMedian> CIMedianRef;
//typedef id<CIMorphologyGradient> CIMorphologyGradientRef;
//typedef id<CIMorphologyMaximum> CIMorphologyMaximumRef;
//typedef id<CIMorphologyMinimum> CIMorphologyMinimumRef;
//typedef id<CIMorphologyRectangleMaximum> CIMorphologyRectangleMaximumRef;
//typedef id<CIMorphologyRectangleMinimum> CIMorphologyRectangleMinimumRef;
//typedef id<CIMotionBlur> CIMotionBlurRef;
//typedef id<CINoiseReduction> CINoiseReductionRef;
//typedef id<CIZoomBlur> CIZoomBlurRef;
//#endif// 101500

//typedef IKCameraDeviceView *IKCameraDeviceViewRef;
//typedef IKDeviceBrowserView *IKDeviceBrowserViewRef;
//typedef IKFilterBrowserPanel *IKFilterBrowserPanelRef;
//typedef IKFilterBrowserView *IKFilterBrowserViewRef;
//typedef IKFilterUIView *IKFilterUIViewRef;
//typedef IKImageBrowserCell *IKImageBrowserCellRef;
//typedef IKImageEditPanel *IKImageEditPanelRef;
//typedef id<IKImageEditPanelDataSource> IKImageEditPanelDataSourceRef;
//typedef IKImageView *IKImageViewRef;
//typedef IKPictureTaker *IKPictureTakerRef;
//typedef IKSaveOptions *IKSaveOptionsRef;
//typedef IKScannerDeviceView *IKScannerDeviceViewRef;
//typedef IKSlideshow *IKSlideshowRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSClickGestureRecognizer *ClickGestureRecognizerRef;
#endif// 101000

typedef NSClipView *ClipViewRef;
typedef NSCoder *CoderRef;
typedef NSColor *ColorRef;
typedef NSCollectionView *CollectionViewRef;
typedef NSCollectionViewItem *CollectionViewItemRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
typedef NSCollectionViewLayout *CollectionViewLayoutRef;
typedef NSCollectionViewLayoutAttributes *CollectionViewLayoutAttributesRef;
typedef NSCollectionViewFlowLayout *CollectionViewFlowLayoutRef;
typedef NSCollectionViewGridLayout *CollectionViewGridLayoutRef;
typedef NSCollectionViewTransitionLayout *CollectionViewTransitionLayoutRef;
typedef NSCollectionViewFlowLayoutInvalidationContext *CollectionViewFlowLayoutInvalidationContextRef;
typedef NSCollectionViewLayoutInvalidationContext *CollectionViewLayoutInvalidationContextRef;
#endif// 101100

typedef NSColorList *ColorListRef;
typedef NSColorPanel *ColorPanelRef;
//#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
//typedef NSColorSampler *ColorSamplerRef;
//#endif// 101500
typedef NSColorSpace *ColorSpaceRef;
typedef NSColorWell *ColorWellRef;
typedef NSComboBox *ComboBoxRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 130000
typedef NSComboButton *ComboButtonRef;
#endif// 130000
typedef NSComparisonPredicate *ComparisonPredicateRef;
typedef NSCompoundPredicate *CompoundPredicateRef;
//typedef NSControl *ControlRef;
typedef NSControl *CocoaControlRef;
typedef NSCountedSet *CountedSetRef;
typedef NSCursor *CursorRef;

typedef NSDataDetector *DataDetectorRef;
//typedef NSDate *DateRef;
typedef NSDateComponents *DateComponentsRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSDateComponentsFormatter *DateComponentsFormatterRef;
#endif// 101000
typedef NSDateFormatter *DateFormatterRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
typedef NSDateInterval *DateIntervalRef;
#endif// 101000
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSDateIntervalFormatter *DateIntervalFormatterRef;
#endif// 101000
typedef NSDatePicker *DatePickerRef;
typedef NSDecimalNumber *DecimalNumberRef;
typedef id<NSDecimalNumberBehaviors> DecimalNumberBehaviorsRef;
typedef NSDecimalNumberHandler *DecimalNumberHandlerRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
typedef NSDimension *DimensionRef;
#endif//101200

typedef NSDirectoryEnumerator *DirectoryEnumeratorRef;
typedef NSDistributedNotificationCenter *DistributedNotificationCenterRef;
typedef NSDockTile *DockTileRef;
typedef NSDocument *DocumentRef;
typedef NSDocumentController *DocumentControllerRef;
typedef id<NSDraggingInfo> DraggingInfoRef;
typedef NSDraggingItem *DraggingItemRef;
typedef NSDraggingSession *DraggingSessionRef;
typedef id<NSDraggingSource> DraggingSourceRef;

typedef NSEnumerator *EnumeratorRef;
typedef NSError *ErrorRef;
//typedef NSEvent *EventRef;// same as CocoaEventRef
typedef NSEvent *CocoaEventRef;
typedef NSException *ExceptionRef;
typedef NSExpression *ExpressionRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSExtensionContext *ExtensionContextRef;
typedef id<NSExtensionRequestHandling> ExtensionRequestHandlingRef;
#endif// 101000

typedef NSFileHandle *FileHandleRef;
typedef NSFileManager *FileManagerRef;
typedef NSFileWrapper *FileWrapperRef;
typedef NSFont *FontRef;
typedef CFTypeRef CTNSFontRef;
typedef NSFontDescriptor *FontDescriptorRef;
typedef NSFontManager *FontManagerRef;
typedef NSFontPanel *FontPanelRef;
typedef NSFormatter *FormatterRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSGestureRecognizer *GestureRecognizerRef;
#endif// 101000
typedef NSGlyphGenerator *GlyphGeneratorRef;
typedef id<NSGlyphStorage> GlyphStorageRef;
typedef NSGradient *GradientRef;
typedef NSGraphicsContext *GraphicsContextRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
typedef NSGridCell *GridCellRef;
typedef NSGridColumn *GridColumnRef;
typedef NSGridRow *GridRowRef;
typedef NSGridView *GridViewRef;
#endif// 101200

typedef NSHashTable *HashTableRef;
typedef NSHelpManager *HelpManagerRef;
typedef NSHTTPCookieStorage *HTTPCookieStorageRef;

typedef NSImage *ImageRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101600
typedef NSImageSymbolConfiguration *ImageSymbolConfigurationRef;
#endif// 101600
typedef NSImageRep *ImageRepRef;
typedef NSImageView *ImageViewRef;
typedef NSIndexPath *IndexPathRef;
typedef NSIndexSet *IndexSetRef;
typedef NSMutableIndexSet *MutableIndexSetRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 120000
typedef NSInflectionRule *InflectionRuleRef;
typedef NSInflectionRuleExplicit *InflectionRuleExplicitRef;
typedef NSMorphology *MorphologyRef;
typedef NSMorphologyCustomPronoun *MorphologyCustomPronounRef;
#endif// 120000

typedef NSStream *StreamRef;

typedef NSInputStream *InputStreamRef;

typedef NSInvocation *InvocationRef;
typedef NSInvocationOperation *InvocationOperationRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
typedef NSISO8601DateFormatter *ISO8601DateFormatterRef;
#endif// 101200

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSItemProvider *ItemProviderRef;
#endif// 101000

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
typedef id<NSItemProviderReading> ItemProviderReadingRef;
typedef id<NSItemProviderWriting> ItemProviderWritingRef;
#endif// 101300

typedef NSJSONSerialization *JSONSerializationRef;

typedef NSKeyedArchiver *KeyedArchiverRef;
typedef NSKeyedUnarchiver *KeyedUnarchiverRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
typedef NSLayoutAnchor *LayoutAnchorRef;
typedef NSLayoutDimension *LayoutDimensionRef;
typedef NSLayoutGuide *LayoutGuideRef;
typedef NSLayoutXAxisAnchor *LayoutXAxisAnchorRef;
typedef NSLayoutYAxisAnchor *LayoutYAxisAnchorRef;
#endif// 101100

typedef NSLayoutConstraint *LayoutConstraintRef;
typedef NSLayoutManager *LayoutManagerRef;
typedef NSLevelIndicator *LevelIndicatorRef;
typedef NSLinguisticTagger *LinguisticTaggerRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
typedef NSListFormatter *ListFormatterRef;
#endif// 101500

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSMagnificationGestureRecognizer *MagnificationGestureRecognizerRef;
#endif// 101000

typedef NSMapTable *MapTableRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
typedef NSMeasurement *MeasurementRef;
typedef NSMeasurementFormatter *MeasurementFormatterRef;
#endif// 101200

typedef NSMediaLibraryBrowserController *MediaLibraryBrowserControllerRef;

//typedef NSMenu *MenuRef;
typedef NSMenu *CocoaMenuRef;
typedef NSMenuItem *MenuItemRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
typedef NSMenuToolbarItem *MenuToolbarItemRef;
#endif// 101500

typedef NSMethodSignature *MethodSignatureRef;

typedef NSNetService *NetServiceRef;
typedef NSNib *NibRef;
typedef NSNotification *NotificationRef;
typedef NSNotificationCenter *NotificationCenterRef;
typedef NSNotificationQueue *NotificationQueueRef;
typedef NSNumberFormatter *NumberFormatterRef;

typedef NSObject *ObjectRef;
//typedef NSObject *NSObjectRef;

typedef NSOpenPanel *OpenPanelRef;
typedef NSOperation *OperationRef;
typedef NSOperationQueue *OperationQueueRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
typedef NSOrderedCollectionChange *OrderedCollectionChangeRef;
typedef NSOrderedCollectionDifference *OrderedCollectionDifferenceRef;
#endif// 101500

typedef NSOrderedSet *OrderedSetRef;
typedef NSMutableOrderedSet *MutableOrderedSetRef;
typedef NSOutlineView *OutlineViewRef;
typedef OutlineItem *OutlineItemRef;
typedef NSOrthography *OrthographyRef;
typedef NSOutputStream *OutputStreamRef;

typedef NSPageLayout *PageLayoutRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSPanGestureRecognizer *PanGestureRecognizerRef;
#endif// 101000
typedef NSPanel *PanelRef;
typedef NSParagraphStyle *ParagraphStyleRef;

typedef NSMutableParagraphStyle *MutableParagraphStyleRef;

//typedef NSPasteboard *PasteboardRef;
typedef NSPasteboard *CocoaPasteboardRef;
typedef id<NSPasteboardWriting> PasteboardWritingRef;
typedef NSPathCell *PathCellRef;
typedef NSPathComponentCell *PathComponentCellRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSPathControlItem *PathControlItemRef;
#endif// 101000
typedef NSPathControl *PathControlRef;
typedef NSPDFInfo *PDFInfoRef;
typedef NSPDFPanel *PDFPanelRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
typedef NSPersonNameComponents *PersonNameComponentsRef;
typedef NSPersonNameComponentsFormatter *PersonNameComponentsFormatterRef;
#endif// 101100

typedef NSPipe *PipeRef;
typedef NSPointerFunctions *PointerFunctionsRef;
typedef NSPointerArray *PointerArrayRef;
typedef NSPopover *PopoverRef;
typedef NSPopUpButton *PopUpButtonRef;
typedef NSPort *PortRef;
typedef NSPredicate *PredicateRef;
typedef NSPredicateEditor *PredicateEditorRef;
typedef NSPredicateEditorRowTemplate *PredicateEditorRowTemplateRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSPressGestureRecognizer *PressGestureRecognizerRef;
#endif// 101000
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
typedef NSPressureConfiguration *PressureConfigurationRef;
#endif// 101100
typedef NSPrinter *PrinterRef;
typedef NSPrintInfo *PrintInfoRef;
typedef NSPrintOperation *PrintOperationRef;
typedef NSPrintPanel *PrintPanelRef;
typedef NSProcessInfo *ProcessInfoRef;
typedef NSProgress *ProgressRef;
typedef NSProgressIndicator *ProgressIndicatorRef;
typedef NSPropertyDescription *PropertyDescriptionRef;

typedef NSRegularExpression *RegularExpressionRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
typedef NSRelativeDateTimeFormatter *RelativeDateTimeFormatterRef;
#endif// 101500

typedef NSResponder *ResponderRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSRotationGestureRecognizer *RotationGestureRecognizerRef;
#endif// 101000
typedef NSRuleEditor *RuleEditorRef;
typedef NSRulerMarker *RulerMarkerRef;
typedef NSRulerView *RulerViewRef;
typedef NSRunLoop *RunLoopRef;
typedef NSRunningApplication *RunningApplicationRef;

typedef NSSavePanel *SavePanelRef;
typedef NSScanner *ScannerRef;
typedef NSScreen *ScreenRef;
typedef NSScroller *ScrollerRef;
typedef NSScrollView *ScrollViewRef;
typedef NSSearchField *SearchFieldRef;
typedef NSSearchFieldCell *SearchFieldCellRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101600
typedef NSSearchToolbarItem *SearchToolbarItemRef;
#endif// 101600
typedef id<NSSecureCoding> SecureCodingRef;
typedef NSSecureTextField *SecureTextFieldRef;
typedef NSSegmentedControl *SegmentedControlRef;
typedef NSShadow *ShadowRef;
typedef NSSharingService *SharingServiceRef;
typedef NSSharingServicePicker *SharingServicePickerRef;
typedef NSSlider *SliderRef;
typedef NSSortDescriptor *SortDescriptorRef;
typedef NSSound *SoundRef;
typedef NSSpeechRecognizer *SpeechRecognizerRef;
typedef NSSpeechSynthesizer *SpeechSynthesizerRef;
typedef NSSpellChecker *SpellCheckerRef;
typedef NSSplitView *SplitViewRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSSplitViewController *SplitViewControllerRef;
typedef NSSplitViewItem *SplitViewItemRef;
#endif// 101000
typedef NSStackView *StackViewRef;
typedef NSStatusBar *StatusBarRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSStatusBarButton *StatusBarButtonRef;
#endif// 101000
typedef NSStatusItem *StatusItemRef;
typedef NSStepper *StepperRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSStoryboard *StoryboardRef;
typedef NSStoryboardSegue *StoryboardSegueRef;
#endif// 101000

//typedef CFTypeRef CFNSStringRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
typedef NSStringDrawingContext *StringDrawingContextRef;
#endif// 101100
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
typedef NSSwitch *SwitchRef;
#endif// 101500

typedef NSTableCellView *TableCellViewRef;
typedef NSTableColumn *TableColumnRef;
typedef NSTableHeaderCell *TableHeaderCellRef;
typedef NSTableHeaderView *TableHeaderViewRef;
typedef NSTableRowView *TableRowViewRef;
typedef NSTableView *TableViewRef;
typedef NSTabView *TabViewRef;
typedef NSTabViewItem *TabViewItemRef;
typedef NSTask *TaskRef;
typedef NSText *TextRef;
typedef NSTextAttachment *TextAttachmentRef;
typedef id<NSTextAttachmentCell> TextAttachmentCellRef;
typedef NSTextBlock *TextBlockRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
typedef id<NSTextCheckingClient> TextCheckingClientRef;
typedef NSTextCheckingController *TextCheckingControllerRef;
#endif// 101500
typedef NSTextCheckingResult *TextCheckingResultRef;
typedef NSTextContainer *TextContainerRef;
typedef NSTextField *TextFieldRef;
typedef NSTextField *TextLabelRef;
typedef NSTextFieldCell *TextFieldCellRef;
typedef NSTextList *TextListRef;
typedef id<NSTextFinderBarContainer> TextFinderBarContainerRef;
typedef id<NSTextFinderClient> TextFinderClientRef;
typedef NSTextFinder *TextFinderRef;
typedef NSTextStorage *TextStorageRef;
typedef NSTextTab *TextTabRef;
typedef NSTextTable *TextTableRef;
typedef NSTextTableBlock *TextTableBlockRef;
typedef NSTextView *TextViewRef;
typedef NSThread *ThreadRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101600
typedef NSTintConfiguration *TintConfigurationRef;
#endif// 101600
typedef NSTokenField *TokenFieldRef;
typedef NSToolbar *ToolbarRef;
typedef NSToolbarItem *ToolbarItemRef;
typedef NSToolbarItemGroup *ToolbarItemGroupRef;
typedef NSTouch *TouchRef;
typedef NSTrackingArea *TrackingAreaRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101600
typedef NSTrackingSeparatorToolbarItem *TrackingSeparatorToolbarItemRef;
#endif// 101600

typedef NSUbiquitousKeyValueStore *UbiquitousKeyValueStoreRef;
typedef NSUndoManager *UndoManagerRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
typedef NSUnit *UnitRef;
typedef NSUnitConverter *UnitConverterRef;
typedef NSUnitConverterLinear *UnitConverterLinearRef;
typedef NSUnitAcceleration *UnitAccelerationRef;
typedef NSUnitAngle *UnitAngleRef;
typedef NSUnitArea *UnitAreaRef;
typedef NSUnitConcentrationMass *UnitConcentrationMassRef;
typedef NSUnitDispersion *UnitDispersionRef;
typedef NSUnitDuration *UnitDurationRef;
typedef NSUnitElectricCharge *UnitElectricChargeRef;
typedef NSUnitElectricCurrent *UnitElectricCurrentRef;
typedef NSUnitElectricPotentialDifference *UnitElectricPotentialDifferenceRef;
typedef NSUnitElectricResistance *UnitElectricResistanceRef;
typedef NSUnitEnergy *UnitEnergyRef;
typedef NSUnitFrequency *UnitFrequencyRef;
typedef NSUnitFuelEfficiency *UnitFuelEfficiencyRef;
typedef NSUnitLength *UnitLengthRef;
typedef NSUnitIlluminance *UnitIlluminanceRef;
typedef NSUnitMass *UnitMassRef;
typedef NSUnitPower *UnitPowerRef;
typedef NSUnitPressure *UnitPressureRef;
typedef NSUnitSpeed *UnitSpeedRef;
typedef NSUnitTemperature *UnitTemperatureRef;
typedef NSUnitVolume *UnitVolumeRef;
#endif// 101200
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
typedef NSUnitInformationStorage *UnitInformationStorageRef;
#endif// 101500
typedef NSURLCache *URLCacheRef;
typedef NSURLComponents *URLComponentsRef;
typedef NSURLCredentialStorage *URLCredentialStorageRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSURLQueryItem *URLQueryItemRef;
#endif// 101000
typedef NSURLRequest *URLRequestRef;
typedef NSMutableURLRequest *MutableURLRequestRef;
typedef NSURLResponse *URLResponseRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSURLSession *URLSessionRef;
typedef NSURLSessionConfiguration *URLSessionConfigurationRef;
typedef NSURLSessionTask *URLSessionTaskRef;
typedef NSURLSessionDataTask *URLSessionDataTaskRef;
typedef NSURLSessionDownloadTask *URLSessionDownloadTaskRef;
#endif// 101000
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
typedef NSURLSessionStreamTask *URLSessionStreamTaskRef;
#endif// 101100
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSURLSessionUploadTask *URLSessionUploadTaskRef;
#endif// 101000
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSUserActivity *UserActivityRef;
#endif// 101000
typedef NSUserDefaults *UserDefaultsRef;
typedef NSUserDefaultsController *UserDefaultsControllerRef;

typedef id<NSUserInterfaceItemIdentification> UserInterfaceItemIdentificationRef;

typedef NSUserNotification *UserNotificationRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSUserNotificationAction *UserNotificationActionRef;
#endif// 101000
typedef NSUserNotificationCenter *UserNotificationCenterRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101600
typedef UTType *UTTypeRef;
#endif// 101600
typedef NSUUID *UUIDref;

typedef NSValue *ValueRef;
typedef NSViewController *ViewControllerRef;
typedef NSView *ViewRef;
typedef NSViewAnimation *ViewAnimationRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSVisualEffectView *VisualEffectViewRef;
#endif// 101000

typedef NSWindow *CocoaWindowRef;
//typedef NSWindow *WindowRef;
typedef NSWindowController *WindowControllerRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
typedef NSWindowTab *WindowTabRef;
typedef NSWindowTabGroup *WindowTabGroupRef;
#endif// 101300

typedef NSWorkspace *WorkspaceRef;

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
typedef NSWorkspaceOpenConfiguration *WorkspaceOpenConfigurationRef;
#endif// 101500

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101400
typedef NSWorkspaceAuthorization *WorkspaceAuthorizationRef;
#endif// 101400

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
typedef id<QLPreviewingController> QLPreviewingControllerRef;
#endif// 101300
typedef id<QLPreviewItem> QLPreviewItemRef;
typedef QLPreviewPanel *QLPreviewPanelRef;
typedef id<QLPreviewPanelDataSource> QLPreviewPanelDataSourceRef;
typedef QLPreviewView *QLPreviewViewRef;
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 120000
typedef QLFilePreviewRequest *QLFilePreviewRequestRef;
typedef QLPreviewReply *QLPreviewReplyRef;
typedef QLPreviewReplyAttachment *QLPreviewReplyAttachmentRef;
#endif// 120000

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
typedef NSTitlebarAccessoryViewController *TitlebarAccessoryViewControllerRef;
#endif// 101000

typedef CFRunLoopTimerRef TimerRef;


#pragma mark - header imports
#import "CUI_AppDelegate.h"

#import "AffineTransform.h"
#import "Alert.h"
#import "Animation.h"
#import "AnimationContext.h"
#import "Appearance.h"
#import "AppleEventDescriptor.h"
#import "AppleEventManager.h"
#import "AppleScript.h"
//#import "AutoreleasePool.h"

#import "Window.h"

#import "Application.h"
#import "Array.h"
#import "AttributedString.h"
#import "AttributeDescription.h"

#import "BackgroundActivityScheduler.h"
#import "BezierPath.h"
#import "BitmapImageRep.h"
#import "BitVector.h"
#import "Box.h"
#import "Browser.h"
#import "BrowserCell.h"
#import "Bundle.h"
#import "Button.h"
#import "ByteCountFormatter.h"

#import "CAAnimation.h"
#import "CAEmitterCell.h"
#import "CAEmitterLayer.h"
#import "CAGradientLayer.h"
#import "CALayer.h"
#import "Calendar.h"
#import "CAMediaTiming.h"
#import "CAMediaTimingFunction.h"
#import "CAReplicatorLayer.h"
#import "CAScrollLayer.h"
#import "CAShapeLayer.h"
#import "CATextLayer.h"
#import "CATiledLayer.h"
#import "CATransaction.h"
#import "CATransform3D.h"
#import "CATransformLayer.h"
#import "CAValueFunction.h"
#import "Cell.h"
#import "CharacterSet.h"
//#import "CIColor.h"
//#import "CIContext.h"
//#import "CIDetector.h"
//#import "CIFeature.h"
//#import "CIFilter.h"
//#import "CIFilterBuiltins.h"
//#import "CIFilterConstructor.h"
//#import "CIFilterGenerator.h"
//#import "CIFilterShape.h"
//#import "CIImage.h"
//#import "CIImageAccumulator.h"
//#import "CIImageProcessor.h"
//#import "CIImageRep.h"
//#import "CIKernel.h"
//#import "CIPlugIn.h"
//#import "CIPlugInInterface.h"
//#import "CIRenderDestination.h"
//#import "CISampler.h"
//#import "CIVector.h"
#import "ClickGestureRecognizer.h"
#import "ClipView.h"
#import "Coder.h"
//#import "CollectionView.h"
//#import "CollectionViewLayout.h"
//#import "CollectionViewFlowLayout.h"
//#import "CollectionViewGridLayout.h"
//#import "CollectionViewTransitionLayout.h"
#import "Color.h"
#import "ColorList.h"
#import "ColorPanel.h"
#import "ColorSampler.h"
#import "ColorSpace.h"
#import "ColorWell.h"
#import "ComboBox.h"
#import "ComboButton.h"
#import "ComparisonPredicate.h"
#import "CompoundPredicate.h"
#import "Control.h"
#import "Cursor.h"

#import "Data.h"
#import "Date.h"
#import "DateComponentsFormatter.h"
#import "DateFormatter.h"
#import "DateInterval.h"
#import "DateIntervalFormatter.h"
#import "DatePicker.h"
#import "DecimalNumber.h"
#import "DialogEvent.h"
#import "Dictionary.h"
#import "DistributedNotificationCenter.h"
#import "DockTile.h"
#import "Document.h"
#import "DocumentController.h"
#import "DraggingInfo.h"
#import "DraggingItem.h"
#import "DraggingSession.h"

#import "Enumerator.h"
#import "Error.h"
#import "Event.h"
#import "Exception.h"
#import "Expression.h"
#import "ExtensionContext.h"
#import "ExtensionRequestHandling.h"

#import "FileHandle.h"
#import "FileManager.h"
#import "FileWrapper.h"
#import "Font.h"
#import "FontDescriptor.h"
#import "FontManager.h"
#import "Formatter.h"

#import "Geometry.h"
#import "GestureRecognizer.h"
#import "GlyphGenerator.h"
#import "Gradient.h"
#import "Graphics.h"
#import "GraphicsContext.h"
#import "GridView.h"

#import "HashTable.h"
#import "HelpManager.h"

//#import "IKCameraDeviceView.h"
//#import "IKDeviceBrowserView.h"
//#import "IKFilterBrowserPanel.h"
//#import "IKFilterBrowserView.h"
//#import "IKFilterUIView.h"
//#import "IKImageBrowserCell.h"
//#import "IKImageEditPanel.h"
//#import "IKImageView.h"
//#import "IKPictureTaker.h"
//#import "IKSaveOptions.h"
//#import "IKScannerDeviceView.h"
//#import "IKSlideshow.h"

#import "Image.h"
#import "ImageRep.h"
#import "ImageView.h"
#import "IndexPath.h"
#import "IndexSet.h"
#import "Invocation.h"
#import "ISO8601DateFormatter.h"
#import "ItemProvider.h"

#import "JSONSerialization.h"

#import "KeyedArchiver.h"
#import "KeyValueCoding.h"
#import "KeyValueObserving.h"

#import "LayoutAnchor.h"
#import "LayoutConstraint.h"
#import "LayoutGuide.h"
#import "LayoutManager.h"
#import "LevelIndicator.h"
#import "LinguisticTagger.h"
#import "ListFormatter.h"
#import "Locale.h"

#import "MagnificationGestureRecognizer.h"
#import "MapTable.h"

#import "Measurement.h"
#import "MeasurementFormatter.h"
#import "MediaLibraryBrowserController.h"
#import "Menu.h"
#import "MenuItem.h"
#import "MenuToolbarItem.h"
#import "MethodSignature.h"

#import "Nib.h"
#import "Notification.h"
#import "NotificationQueue.h"
#import "NumberFormatter.h"

#import "ObjCRuntime.h"

#import "Object.h"

#import "SavePanel.h"

#import "OpenPanel.h"
#import "Operation.h"
#import "OrderedCollectionChange.h"
#import "OrderedCollectionDifference.h"
#import "OrderedSet.h"
#import "Orthography.h"

#import "PageLayout.h"
#import "Panel.h"
#import "PanGestureRecognizer.h"
#import "ParagraphStyle.h"
#import "Pasteboard.h"
#import "PathCell.h"
#import "PathComponentCell.h"
#import "PathControlItem.h"
#import "PathControl.h"
#import "PDFInfo.h"
#import "PDFPanel.h"
#import "PersonNameComponents.h"
#import "PersonNameComponentsFormatter.h"
#import "PointerArray.h"
#import "PointerFunctions.h"
#import "Popover.h"
#import "PopUpButton.h"
#import "Port.h"
#import "Predicate.h"
#import "PredicateEditor.h"
#import "PredicateEditorRowTemplate.h"
#import "PressGestureRecognizer.h"
#import "PressureConfiguration.h"
#import "Printer.h"
#import "PrintInfo.h"
#import "PrintOperation.h"
#import "PrintPanel.h"
#import "ProcessInfo.h"
#import "Progress.h"
#import "ProgressIndicator.h"
#import "PropertyList.h"
#import "PropertyDescription.h"

#import "Range.h"
#import "RegularExpression.h"
#import "RelativeDateTimeFormatter.h"
#import "Responder.h"
#import "RotationGestureRecognizer.h"
#import "RuleEditor.h"
#import "RulerMarker.h"
#import "RulerView.h"
#import "RunLoop.h"
#import "RunningApplication.h"

#import "Scanner.h"
#import "Screen.h"
#import "Scroller.h"
#import "ScrollView.h"
#import "SearchField.h"
#import "SearchFieldCell.h"
#import "SearchToolbarItem.h"
#import "SecureTextField.h"
#import "SegmentedControl.h"
#import "Set.h"
#import "Shadow.h"
#import "SharingService.h"
#import "Slider.h"
#import "SortDescriptor.h"
#import "Sound.h"
#import "SpeechRecognizer.h"
#import "SpeechSynthesizer.h"
#import "SpellChecker.h"
#import "SplitView.h"
#import "SplitViewItem.h"
#import "StackView.h"
#import "StatusBar.h"
#import "StatusBarButton.h"
#import "StatusItem.h"
#import "Stepper.h"
#import "Storyboard.h"
#import "StoryboardSegue.h"
#import "Stream.h"
#import "String.h"
#import "StringDrawing.h"
#import "Switch.h"

#import "TableCellView.h"
#import "TableColumn.h"
#import "TableHeaderCell.h"
#import "TableHeaderView.h"
#import "TableRowView.h"
#import "TableView.h"

#import "OutlineView.h"

#import "TabView.h"
#import "TabViewItem.h"
#import "Task.h"
#import "Text.h"
#import "TextAttachment.h"
#import "TextCheckingClient.h"
#import "TextCheckingController.h"
#import "TextCheckingResult.h"
#import "TextContainer.h"
#import "TextField.h"
#import "TextFieldCell.h"
#import "TextLabel.h"
#import "TextList.h"
#import "TextStorage.h"
#import "TextTable.h"
#import "TextView.h"
#import "Thread.h"
#import "Timer.h"
#import "TimeZone.h"
#import "TintConfiguration.h"
#import "TitlebarAccessoryViewController.h"
#import "TokenField.h"
#import "Toolbar.h"
#import "ToolbarItem.h"
#import "ToolbarItemGroup.h"
#import "Touch.h"
#import "TrackingArea.h"
#import "TrackingSeparatorToolbarItem.h"

#import "UbiquitousKeyValueStore.h"
#import "UndoManager.h"
#import "Unit.h"
#import "URL.h"
#import "URLCache.h"
#import "URLRequest.h"
#import "URLResponse.h"
#import "URLSession.h"
#import "UserActivity.h"
#import "UserDefaults.h"
#import "UserDefaultsController.h"
#import "UserInterfaceItemIdentification.h"
#import "UserNotification.h"
#import "UUID.h"

#import "Value.h"
#import "View.h"
#import "ViewController.h"
#import "VisualEffectView.h"

#import "WindowController.h"
#import "WindowTab.h"
#import "WindowTabGroup.h"
#import "Workspace.h"

#pragma mark - runtime alert
void CUI_ShowAlert( NSAlertStyle style, NSString *msg, NSString *info );
void CUI_ShowWindowDoesNotExistAlert( NSInteger tag );


// on error fn 20201221
typedef void (*CUI_OnErrorFunctionType)(NSInteger,NSInteger);
static CUI_OnErrorFunctionType sCUI_OnErrorFunction;
CUI_OnErrorFunctionType CUI_OnErrorFunction( void );
void CUI_SetOnErrorFunction( CUI_OnErrorFunctionType onErrorFn );
void CallUserDefinedOnErrorFunction( long fileID, long errCode );

#pragma mark - utilities
NSColor *CUI_FixColor( long col );
CGPathRef CUI_NSBezierPathToCGPath( NSBezierPath *bezierPath );
NSImage *CUI_ImageResource( NSString *path );
NSImage *CUI_FixImageValue( void *inImage );
NSFont *CUI_FixFont( const void *inFont );
CFRange NSRangeToCFRange( NSRange range );
NSRange NSRangeFromCFRange( CFRange range );
