/*
 ColorSpace.h

 Bernie Wylde
 */


#import "CocoaUI.h"

// Class
Class ColorSpaceClass( void );

// Named spaces
NSColorSpace *ColorSpaceDeviceRGBSpace( void );
NSColorSpace *ColorSpaceGenericRGBSpace( void );
NSColorSpace *ColorSpaceDeviceCMYKSpace( void );
NSColorSpace *ColorSpaceGenericCMYKSpace( void );
NSColorSpace *ColorSpaceDeviceGraySpace( void );
NSColorSpace *ColorSpaceGenericGraySpace( void );
NSColorSpace *ColorSpaceSRGBSpace( void );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
NSColorSpace *ColorSpaceExtendedSRGBSpace( void );
NSColorSpace *ColorSpaceP3Space( void );
#endif

NSColorSpace *ColorSpaceGenericGamma22GraySpace( void );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
NSColorSpace *ColorSpaceExtendedGenericGamma22GraySpace( void );
#endif

NSColorSpace *ColorSpaceAdobeRGB1998Space( void );

// Available system spaces
CFArrayRef ColorSpaceAvailableSpacesWithModel( NSColorSpaceModel model );

// Custom spaces
NSColorSpace *ColorSpaceWithCGColorSpace( CGColorSpaceRef cgColorSpace );
NSColorSpace *ColorSpaceWithColorSyncProfile( void *prof );
NSColorSpace *ColorSpaceWithICCProfileData( CFDataRef dta );

// Data and attributes
CGColorSpaceRef ColorSpaceCGColorSpace( NSColorSpace *ref );
NSColorSpaceModel ColorSpaceModel( NSColorSpace *ref );
void *ColorSpaceColorSyncProfile( NSColorSpace *ref );
CFDataRef ColorSpaceICCProfileData( NSColorSpace *ref );
CFStringRef ColorSpaceLocalizedName( NSColorSpace *ref );
NSInteger ColorSpaceNumberOfColorComponents( NSColorSpace *ref );
