/*
 ColorWell.h

 Bernie Wylde
 */


#import "CocoaUI.h"

#import "View.h"
#import "Window.h"


#pragma mark - pulldown target
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 130000
@interface CUI_ColorWellPulldownTarget : NSObject
@end
CUI_ColorWellPulldownTarget *CUI_ColorWellPulldownTargetObj( void );
#endif// 130000


#pragma mark - subclass
@interface ColorWellSC : NSColorWell
@end

// dialog events
enum {
    colorWellPulldown = 5900
};

// Class
Class ColorWellClass( void );

NSColorWell *ColorWellWithTag( NSInteger tag );
BOOL ColorWellExists( NSInteger tag );

NSColor *ColorWellColor( NSInteger tag );
void ColorWellSetColor( NSInteger tag, NSColor *col );
void ColorWellTakeColorFrom( NSInteger tag, NSInteger senderTag );

void ColorWellActivate( NSInteger tag, BOOL exclusive );
BOOL ColorWellIsActive( NSInteger tag );
void ColorWellDeactivate( NSInteger tag );

BOOL ColorWellIsBordered( NSInteger tag );
void ColorWellSetBordered( NSInteger tag, BOOL flag );

void ColorWellDrawWellInside( NSInteger tag, CGRect insideRect );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 130000
// Style
NSColorWellStyle ColorWellStyle( NSInteger tag );
void ColorWellSetStyle( NSInteger tag, NSColorWellStyle style );

// Image
NSImage *ColorWellImage( NSInteger tag );
void ColorWellSetImage( NSInteger tag, NSImage *image );

// Pulldown action
void ColorWellEnablePulldownAction( NSInteger tag, BOOL flag );
#endif// 130000


// Init
NSColorWell *ColorWellInit( NSInteger inTag, CGRect inRect );

// statement
void CUI_ColorWell( NSInteger inTag, NSInteger inEnabled, NSColor *inColor, CGRect inRect, NSInteger inStyle, NSInteger inWndTag );


