/*
 ComboButton.h
 
 Bernie Wylde
 */

#import "CocoaUI.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 130000

#pragma mark - subclass
@interface ComboButtonSC : NSComboButton
@end

#pragma mark - functions
// Class
Class ComboButtonClass( void );

NSComboButton *ComboButtonWithTag( NSInteger tag );
BOOL ComboButtonExists( NSInteger tag );

// Title
CFStringRef ComboButtonTitle( NSInteger tag );
void ComboButtonSetTitle( NSInteger tag, CFStringRef title );

// Image
NSImage *ComboButtonImage( NSInteger tag );
void ComboButtonSetImage( NSInteger tag, NSImage *image );

// Image scaling
NSImageScaling ComboButtonImageScaling( NSInteger tag );
void ComboButtonSetImageScaling( NSInteger tag, NSImageScaling scaling );

// Menu
NSInteger ComboButtonMenuIndex( NSInteger tag );
void ComboButtonSetMenu( NSInteger tag, NSInteger menuID );
NSMenu *ComboButtonMenu( NSInteger tag );

// Style
NSComboButtonStyle ComboButtonStyle( NSInteger tag );
void ComboButtonSetStyle( NSInteger tag, NSComboButtonStyle style );



// Init
NSComboButton *ComboButtonInit( NSInteger inTag, CGRect inRect );

#pragma mark - combobutton statement
void CUI_ComboButton( NSInteger inTag, NSInteger inEnabled, CFStringRef inTitle, void *inImage, NSInteger inMenu, CGRect inRect, NSInteger inStyle, NSInteger inWndTag );

#endif// 130000
