/*
 Cursor.h

 Bernie Wylde
 */


#import "CocoaUI.h"

@interface CUI_CursorAnimator : NSObject

@property (nonatomic,retain) NSTimer *timer;
@property (assign) long counter;
@property (nonatomic,retain) NSString *name;
@property (nonatomic,retain) NSString *extension;
@property (assign) NSSize size;
@property (assign) NSPoint hotSpot;
@property (assign) long numImages;

- (void)timerFireMethod:(NSTimer *)t;
@end

// Class
Class CursorClass( void );

NSCursor *CursorWithImage( NSImage *image, CGPoint hotSpot );

NSImage *CursorImage( NSCursor *ref );
CGPoint CursorHotSpot( NSCursor *ref );
void CursorHide( void );
void CursorUnhide( void );
void CursorSetHiddenUntilMouseMoves( BOOL flag );

void CursorPop( void );
void CursorPush( NSCursor *ref );
void CursorSet( NSCursor *ref );

NSCursor *CursorCurrent( void );
NSCursor *CursorCurrentSystem( void );
NSCursor *CursorArrow( void );
NSCursor *CursorContextualMenu( void );
NSCursor *CursorClosedHand( void );
NSCursor *CursorCrosshair( void );
NSCursor *CursorDisappearingItem( void );
NSCursor *CursorDragCopy( void );
NSCursor *CursorDragLink( void );
NSCursor *CursorIBeam( void );
NSCursor *CursorOpenHand( void );
NSCursor *CursorOperationNotAllowed( void );
NSCursor *CursorPointingHand( void );
NSCursor *CursorResizeDown( void );
NSCursor *CursorResizeLeft( void );
NSCursor *CursorResizeLeftRight( void );
NSCursor *CursorResizeRight( void );
NSCursor *CursorResizeUp( void );
NSCursor *CursorResizeUpDown( void );
NSCursor *CursorIBeamForVerticalLayout( void );

// -- convenience --
void CursorSetImage( void *inImage, CGPoint hotSpot );
void CursorSetImageNamed( CFStringRef imageName, CGPoint hotSpot );
void CursorSetArrow( void );
void CursorSetContextualMenu( void );
void CursorSetClosedHand( void );
void CursorSetCrosshair( void );
void CursorSetDisappearingItem( void );
void CursorSetDragCopy( void );
void CursorSetDragLink( void );
void CursorSetIBeam( void );
void CursorSetOpenHand( void );
void CursorSetOperationNotAllowed( void );
void CursorSetPointingHand( void );
void CursorSetResizeDown( void );
void CursorSetResizeLeft( void );
void CursorSetResizeRight( void );
void CursorSetResizeUp( void );
void CursorSetResizeUpDown( void );
void CursorSetIBeamForVerticalLayout( void );

// Custom
void CursorAnimatorStart( CFTimeInterval ti, CFStringRef inFirstImageName, CGSize size, CGPoint hotSpot, long numImages );
void CursorAnimatorStop( void );

