/*
 ImageView.h

 Bernie Wylde
 */


#import "CocoaUI.h"

//#import "DialogEvent.h"
//#import "Responder.h"
//#import "View.h"
//#import "Window.h"

@interface ImageViewSC : NSImageView
@end

// Class
Class ImageViewClass( void );

NSImageView *ImageViewWithTag( NSInteger tag );
BOOL ImageViewExists( NSInteger tag );

// - image -
NSImage *ImageViewImage( NSInteger tag );
void ImageViewSetImage( NSInteger tag, void *inImage );
void ImageViewSetImageNamed( NSInteger tag, CFStringRef imageName );

// - visual characteristics -
NSImageFrameStyle ImageViewFrameStyle( NSInteger tag );
void ImageViewSetFrameStyle( NSInteger tag, NSImageFrameStyle style );
NSImageAlignment ImageViewAlignment( NSInteger tag );
void ImageViewSetAlignment( NSInteger tag, NSImageAlignment alignment );
NSImageScaling ImageViewScaling( NSInteger tag );
void ImageViewSetScaling( NSInteger tag, NSImageScaling scaling );
BOOL ImageViewAnimates( NSInteger tag );
void ImageViewSetAnimates( NSInteger tag, BOOL flag );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101600
NSImageSymbolConfiguration *ImageViewSymbolConfiguration( NSInteger tag );
void ImageViewSetSymbolConfiguration( NSInteger tag, NSImageSymbolConfiguration *config );
#endif// 101600

// - user events -
void ImageViewSetEditable( NSInteger tag, BOOL flag );
void ImageViewSetAllowsCutCopyPaste( NSInteger tag, BOOL flag );

// Instance properties
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101400
NSColor *ImageViewContentTintColor( NSInteger tag );
void ImageViewSetContentTintColor( NSInteger tag, NSColor *col );
#endif// 101400


// Init
NSImageView *ImageViewInit( NSInteger inTag, CGRect inRect );

// Statement
void CUI_ImageView( NSInteger inTag, NSInteger inEnabled, void *inImage, CGRect inRect, NSInteger inScaling, NSInteger inAlignment, NSInteger inFrameStyle, NSInteger inWndTag );

