/*
 LayoutAnchor.h

 Bernie Wylde
 */


#import "CocoaUI.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100

// Class
Class LayoutAnchorClass( void );

// Build constraints
NSLayoutConstraint *LayoutAnchorConstraintEqualToAnchor( NSLayoutAnchor *ref, NSLayoutAnchor *anchor );
NSLayoutConstraint *LayoutAnchorConstraintEqualToAnchorConstant( NSLayoutAnchor *ref, NSLayoutAnchor *anchor, CGFloat constant );
NSLayoutConstraint *LayoutAnchorConstraintGreaterThanOrEqualToAnchor( NSLayoutAnchor *ref, NSLayoutAnchor *anchor );
NSLayoutConstraint *LayoutAnchorConstraintGreaterThanOrEqualToAnchorConstant( NSLayoutAnchor *ref, NSLayoutAnchor *anchor, CGFloat constant );
NSLayoutConstraint *LayoutAnchorConstraintLessThanOrEqualToAnchor( NSLayoutAnchor *ref, NSLayoutAnchor *anchor );
NSLayoutConstraint *LayoutAnchorConstraintLessThanOrEqualToAnchorConstant( NSLayoutAnchor *ref, NSLayoutAnchor *anchor, CGFloat constant );

// Debugging
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
CFArrayRef LayoutAnchorConstraintsAffectingLayout( NSLayoutAnchor *ref );
BOOL LayoutAnchorHasAmbiguousLayout( NSLayoutAnchor *ref );
CFStringRef LayoutAnchorName( NSLayoutAnchor *ref );
CFTypeRef LayoutAnchorItem( NSLayoutAnchor *ref );
#endif  // __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300



/*
 LayoutYAxisAnchor
 */
// Class
Class LayoutYAxisAnchorClass( void );

// Create layout dimension
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
NSLayoutDimension *LayoutYAxisAnchorWithOffsetToAnchor( NSLayoutYAxisAnchor *ref, NSLayoutYAxisAnchor *otherAnchor );
#endif



/*
 LayoutXAxisAnchor
 */
// Class
Class LayoutXAxisAnchorClass( void );

// Create layout dimension
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
NSLayoutDimension *LayoutXAxisAnchorWithOffsetToAnchor( NSLayoutXAxisAnchor *ref, NSLayoutXAxisAnchor *otherAnchor );
#endif


/*
 LayoutDimension
 */
// Class
Class LayoutDimensionClass( void );

// Build constraints
NSLayoutConstraint *LayoutDimensionConstraintEqualToAnchor( NSLayoutDimension *ref, NSLayoutDimension *anchor, CGFloat multiplier );
NSLayoutConstraint *LayoutDimensionConstraintEqualToAnchorConstant( NSLayoutDimension *ref, NSLayoutDimension *anchor, CGFloat multiplier, CGFloat constant );
NSLayoutConstraint *LayoutDimensionConstraintEqualToConstant( NSLayoutDimension *ref, CGFloat constant );
NSLayoutConstraint *LayoutDimensionConstraintGreaterThanOrEqualToAnchor( NSLayoutDimension *ref, NSLayoutDimension *anchor, CGFloat multiplier );
NSLayoutConstraint *LayoutDimensionConstraintGreaterThanOrEqualToAnchorConstant( NSLayoutDimension *ref, NSLayoutDimension *anchor, CGFloat multiplier, CGFloat constant );
NSLayoutConstraint *LayoutDimensionConstraintGreaterThanOrEqualToConstant( NSLayoutDimension *ref, CGFloat constant );
NSLayoutConstraint *LayoutDimensionConstraintLessThanOrEqualToAnchor( NSLayoutDimension *ref, NSLayoutDimension *anchor, CGFloat multiplier );
NSLayoutConstraint *LayoutDimensionConstraintLessThanOrEqualToAnchorConstant( NSLayoutDimension *ref, NSLayoutDimension *anchor, CGFloat multiplier, CGFloat constant );
NSLayoutConstraint *LayoutDimensionConstraintLessThanOrEqualToConstant( NSLayoutDimension *ref, CGFloat constant );


#endif  // __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100

