/*
 ListFormatter.m

 Bernie Wylde
 */

#import "ListFormatter.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500

// Class
Class ListFormatterClass( void )
{ return [NSListFormatter class]; }

// Create
NSListFormatter *ListFormatterInit( void )
{
    if (@available(macOS 10.15, *)) {
        return [[[NSListFormatter alloc] init] autorelease];
    }
    return nil;
}

// Instance properties
NSFormatter *ListFormatterItemFormatter( NSListFormatter *ref )
{
    if (@available(macOS 10.15, *)) {
        return [ref itemFormatter];
    }
    return nil;
}

void ListFormatterSetItemFormatter( NSListFormatter *ref, NSFormatter *formatter )
{
    if (@available(macOS 10.15, *)) {
        [ref setItemFormatter:formatter];
    }
}

CFLocaleRef ListFormatterLocale( NSListFormatter *ref )
{
    if (@available(macOS 10.15, *)) {
        return (__bridge CFLocaleRef)[ref locale];
    }
    return nil;
}

void ListFormatterSetLocale( NSListFormatter *ref, CFLocaleRef locale )
{
    if (@available(macOS 10.15, *)) {
        [ref setLocale:(__bridge NSLocale *)locale];
    }
}

// Instance methods
CFStringRef ListFormatterStringForObjectValue( NSListFormatter *ref, CFTypeRef obj )
{
    if (@available(macOS 10.15, *)) {
        return (__bridge CFStringRef)[ref stringForObjectValue:(__bridge id)obj];
    }
    return nil;
}

CFStringRef ListFormatterStringFromItems( NSListFormatter *ref, CFArrayRef items )
{
    if (@available(macOS 10.15, *)) {
        return (__bridge CFStringRef)[ref stringFromItems:(__bridge NSArray *)items];
    }
    return nil;
}

// Type methods
CFStringRef ListFormatterLocalizedStringByJoiningStrings( CFArrayRef strings )
{
    if (@available(macOS 10.15, *)) {
        return (__bridge CFStringRef)[NSListFormatter localizedStringByJoiningStrings:(__bridge NSArray *)strings];
    }
    return nil;
}

#endif// 101500
