/*
 Measurement.m

 Bernie Wylde
 */

#import "Measurement.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200

// Class
Class MeasurementClass( void )
{ return [NSMeasurement class]; }

// Create
NSMeasurement *MeasurementWithDoubleValue( double value, NSUnit *unit )
{ return [[[NSMeasurement alloc] initWithDoubleValue:value unit:unit] autorelease]; }

// Unit and value
NSUnit *MeasurementUnit( NSMeasurement *ref )
{ return [ref unit]; }

double MeasurementDoubleValue( NSMeasurement *ref )
{ return [ref doubleValue]; }

// Convert
BOOL MeasurementCanBeConvertedToUnit( NSMeasurement *ref, NSUnit *unit )
{ return [ref canBeConvertedToUnit:unit]; }

NSMeasurement *MeasurementByConvertingToUnit( NSMeasurement *ref, NSUnit *unit )
{ return [ref measurementByConvertingToUnit:unit]; }

// Operating on measurements
NSMeasurement *MeasurementByAddingMeasurement( NSMeasurement *ref1, NSMeasurement *ref2 )
{ return [ref1 measurementByAddingMeasurement:ref2]; }

NSMeasurement *MeasurementBySubtractingMeasurement( NSMeasurement *ref1, NSMeasurement *ref2 )
{ return [ref1 measurementBySubtractingMeasurement:ref2]; }

#endif// 101200

