/*
 MeasurementFormatter.m

 Bernie Wylde
 */

#import "MeasurementFormatter.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200

// Class
Class MeasurementFormatterClass( void )
{ return [NSMeasurementFormatter class]; }

// Create
NSMeasurementFormatter *MeasurementFormatterInit( void )
{ return [[[NSMeasurementFormatter alloc] init] autorelease]; }

NSMeasurementFormatter *MeasurementFormatterWithUnitOptions( NSMeasurementFormatterUnitOptions options )
{
    NSMeasurementFormatter *formatter = [[[NSMeasurementFormatter alloc] init] autorelease];
    [formatter setUnitOptions:options];
    return formatter;
}

NSMeasurementFormatter *MeasurementFormatterWithUnitOptionsAndStyle( NSMeasurementFormatterUnitOptions options, NSFormattingUnitStyle style )
{
    NSMeasurementFormatter *formatter = [[[NSMeasurementFormatter alloc] init] autorelease];
    [formatter setUnitOptions:options];
    [formatter setUnitStyle:style];
    return formatter;
}

// Format
NSMeasurementFormatterUnitOptions MeasurementFormatterUnitOptions( NSMeasurementFormatter *ref )
{ return [ref unitOptions]; }

void MeasurementFormatterSetUnitOptions( NSMeasurementFormatter *ref, NSMeasurementFormatterUnitOptions options )
{ [ref setUnitOptions:options]; }

NSFormattingUnitStyle MeasurementFormatterUnitStyle( NSMeasurementFormatter *ref )
{ return [ref unitStyle]; }

void MeasurementFormatterSetUnitStyle( NSMeasurementFormatter *ref, NSFormattingUnitStyle style )
{ [ref setUnitStyle:style]; }

CFLocaleRef MeasurementFormatterLocale( NSMeasurementFormatter *ref )
{ return (__bridge CFLocaleRef)[ref locale]; }

void MeasurementFormatterSetLocale( NSMeasurementFormatter *ref, CFLocaleRef locale )
{ [ref setLocale:(__bridge NSLocale *)locale]; }

NSNumberFormatter *MeasurementFormatterNumberFormatter( NSMeasurementFormatter *ref )
{ return [ref numberFormatter]; }

void MeasurementFormatterSetNumberFormatter( NSMeasurementFormatter *ref, NSNumberFormatter *numFormatter )
{ [ref setNumberFormatter:numFormatter]; }

// Convert
CFStringRef MeasurementFormatterStringFromMeasurement( NSMeasurementFormatter *ref, NSMeasurement *measurement )
{ return (__bridge CFStringRef)[ref stringFromMeasurement:measurement]; }

CFStringRef MeasurementFormatterStringFromUnit( NSMeasurementFormatter *ref, NSUnit *unit )
{ return (__bridge CFStringRef)[ref stringFromUnit:unit]; }

#endif// 101200

