/*
 MenuToolbarItem.m

 Bernie Wylde
 */

#import "MenuToolbarItem.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500

// Class
Class MenuToolbarItemClass( void )
{ return [NSMenuToolbarItem class]; }

// Instance properties
NSMenu *MenuToolbarItemMenu( NSMenuToolbarItem *ref )
{
    if (@available(macOS 10.15, *)) {
        return [ref menu];
    }
    return nil;
}

void MenuToolbarItemSetMenu( NSMenuToolbarItem *ref, NSInteger menuIndex )
{
    if (@available(macOS 10.15, *)) {
        NSMenu *menu = MenuAtIndex( menuIndex );
        if ( menu ) [ref setMenu:menu];
    }
}

BOOL MenuToolbarItemShowsIndicator( NSMenuToolbarItem *ref )
{
    if (@available(macOS 10.15, *)) {
        return [ref showsIndicator];
    }
    return NO;
}

void MenuToolbarItemSetShowsIndicator( NSMenuToolbarItem *ref, BOOL flag )
{
    if (@available(macOS 10.15, *)) {
        [ref setShowsIndicator:flag];
    }
}

#endif// 101500
