/*
 Morphology.h

 Bernie Wylde
 */

#import "CocoaUI.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 120000

#pragma mark - Morphology

// User morphology
NSMorphology *MorphologyUser( void );

// Grammatical properties
BOOL MorphologyIsUnspecified( NSMorphology *ref );
NSGrammaticalGender MorphologyGrammaticalGender( NSMorphology *ref );
void MorphologySetGrammaticalGender( NSMorphology *ref, NSGrammaticalGender gender );
NSGrammaticalNumber MorphologyNumber( NSMorphology *ref );
void MorphologySetNumber( NSMorphology *ref, NSGrammaticalNumber number );
NSGrammaticalPartOfSpeech MorphologyPartOfSpeech( NSMorphology *ref );
void MorphologySetPartOfSpeech( NSMorphology *ref, NSGrammaticalPartOfSpeech partOfSpeech );

// Per-language featurs
BOOL MorphologySetCustomPronoun( NSMorphology *ref, NSMorphologyCustomPronoun *pronoun, CFStringRef language, NSError **err );
NSMorphologyCustomPronoun *MorphologyCustomPronoun( NSMorphology *ref, CFStringRef language );


#pragma mark - MorphologyCustomPronoun

// Support
BOOL MorphologyCustomPronounIsSupportedForLanguage( CFStringRef language );
CFArrayRef MorphologyCustomPronounRequiredKeysForLanguage( CFStringRef language );

// Forms
CFStringRef MorphologyCustomPronounSubjectForm( NSMorphologyCustomPronoun *ref );
void MorphologyCustomPronounSetSubjectForm( NSMorphologyCustomPronoun *ref, CFStringRef form );
CFStringRef MorphologyCustomPronounObjectForm( NSMorphologyCustomPronoun *ref );
void MorphologyCustomPronounSetObjectForm( NSMorphologyCustomPronoun *ref, CFStringRef form );
CFStringRef MorphologyCustomPronounPossessiveForm( NSMorphologyCustomPronoun *ref );
void MorphologyCustomPronounSetPossessiveForm( NSMorphologyCustomPronoun *ref, CFStringRef form );
CFStringRef MorphologyCustomPronounPossessiveAdjectiveForm( NSMorphologyCustomPronoun *ref );
void MorphologyCustomPronounSetPossessiveAdjectiveForm( NSMorphologyCustomPronoun *ref, CFStringRef form );
CFStringRef MorphologyCustomPronounReflexiveForm( NSMorphologyCustomPronoun *ref );
void MorphologyCustomPronounSetReflexiveForm( NSMorphologyCustomPronoun *ref, CFStringRef form );

#endif// 120000

