/*
 Object.h

 Bernie Wylde
 */



typedef void (*CUI_ObjectPerformFunctionCallbackType)(id);

@interface CUI_ObjectTarget : NSObject
@property (assign) CUI_ObjectPerformFunctionCallbackType callback;

- (void)objectSelector:(id)object;
@end


@interface NSObject (Additions)
@property (nonatomic,retain) NSNumber *IDNumber;

//@property (nonatomic,retain) NSNumber *tagNumber;// 20200323

@property (nonatomic,retain) NSNumber *wndTagNumber;
@property (nonatomic,retain) NSMutableDictionary *objProperties;

- (NSInteger)ID;
- (void)setID:(NSInteger)objID;

//- (NSInteger)tag;// 20200323
//- (void)setTag:(NSInteger)tag;// 20200323

- (NSInteger)wndTag;
- (void)setWndTag:(NSInteger)tag;

- (NSMutableDictionary *)objectProperties;
- (void)setObjectProperties:(NSMutableDictionary *)properties;
@end

#pragma mark - private
NSMutableArray *CUI_Objects( void );



#pragma mark - public
//NSInteger ObjectTag( CFTypeRef obj );// 20200323
//void ObjectSetTag( CFTypeRef obj, NSInteger tag );// 20200323
//CFTypeRef ObjectWithTag( NSInteger tag );// 20200323


// Init
NSObject *ObjectInit( void );

// - create, copy, dealloc -
CFTypeRef ObjectCopy( CFTypeRef obj );
CFTypeRef ObjectMutableCopy( CFTypeRef obj );


Class ObjectClass( CFTypeRef obj );
Class ObjectSuperclass( CFTypeRef obj );
BOOL ObjectIsSubclassOfClass( CFTypeRef obj, Class class );

// Description
CFStringRef ObjectDescription( CFTypeRef obj );

// Method info
NSMethodSignature *ObjectInstanceMethodSignatureForSelector( CFTypeRef obj, SEL selector );
NSMethodSignature *ObjectMethodSignatureForSelector( CFTypeRef obj, SEL selector );

// Sending messages
void ObjectPerformSelector( CFTypeRef obj, CFStringRef selector, CFTypeRef withObj, CFTimeInterval afterDelay );
void ObjectPerformSelectorOnMainThread( CFTypeRef obj, CFTypeRef selector, CFTypeRef withObj, BOOL waitUntilDone );
void ObjectPerformSelectorInBackground( CFTypeRef obj, CFStringRef selector, CFTypeRef withObj );

// Scripting
CFStringRef ObjectClassName( CFTypeRef obj );

// - instance methods -
BOOL ObjectIsEqual( CFTypeRef obj1, CFTypeRef obj2 );
//void ObjectSetValueForKey( CFTypeRef obj, CFTypeRef value, CFStringRef key );
//CFTypeRef ObjectValueForKey( CFTypeRef obj, CFStringRef key );


// -- NSObject protocol methods --
BOOL ObjectIsKindOfClass( CFTypeRef obj, Class class );


/*
 Custom
 */
// Call function
void ObjectCallFunction( void *fnAddress, CFTypeRef withObj, CFTimeInterval afterDelay );
void ObjectCallFunctionOnMainThread( void *fnAddress, CFTypeRef withObj, BOOL waitUntilDone );
void ObjectCallFunctionInBackground( void *fnAddress, CFTypeRef withObj );

// Object property
CFTypeRef ObjectProperty( CFTypeRef obj, CFStringRef key );
void ObjectSetProperty( CFTypeRef obj, CFStringRef key, CFTypeRef value );
void ObjectRemoveProperty( CFTypeRef obj, CFStringRef key );
void ObjectRemoveAllProperties( CFTypeRef obj );

// Object ID
NSInteger ObjectID( CFTypeRef obj );
CFTypeRef ObjectWithID( NSInteger objID );
void ObjectSetID( CFTypeRef obj, NSInteger objID );
void ObjectRemoveID( NSInteger objID );
