/*
 OrderedCollectionChange.m
 
 Bernie Wylde
 */

#import "OrderedCollectionChange.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500

// Class
Class OrderedCollectionChangeClass( void )
{ return [NSOrderedCollectionChange class]; }

// Init
NSOrderedCollectionChange *OrderedCollectionChangeWithObject( CFTypeRef object, NSCollectionChangeType type, NSUInteger index )
{
    if (@available(macOS 10.15, *)) {
        return [NSOrderedCollectionChange changeWithObject:(__bridge id)object type:type index:index];
    }
    return nil;
}

NSOrderedCollectionChange *OrderedCollectionChangeWithObjectAssociatedIndex( CFTypeRef object, NSCollectionChangeType type, NSUInteger index, NSUInteger associatedIndex )
{
    if (@available(macOS 10.15, *)) {
        return [NSOrderedCollectionChange changeWithObject:(__bridge id)object type:type index:index associatedIndex:associatedIndex];
    }
    return nil;
}

// Instance properties
NSUInteger OrderedCollectionChangeAssociatedIndex( NSOrderedCollectionChange *ref )
{
    if (@available(macOS 10.15, *)) {
        return [ref associatedIndex];
    }
    return 0;
}

NSCollectionChangeType OrderedCollectionChangeType( NSOrderedCollectionChange *ref )
{
    if (@available(macOS 10.15, *)) {
        return [ref changeType];
    }
    return 0;
}

NSUInteger OrderedCollectionChangeIndex( NSOrderedCollectionChange *ref )
{
    if (@available(macOS 10.15, *)) {
        return [ref index];
    }
    return 0;
}

CFTypeRef OrderedCollectionChangeObject( NSOrderedCollectionChange *ref )
{
    if (@available(macOS 10.15, *)) {
        return (__bridge CFTypeRef)[ref object];
    }
    return nil;
}

#endif// 101500
