/*
 OrderedCollectionDifference.h
 
 Bernie Wylde
 */


#import "CocoaUI.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500

typedef NSOrderedCollectionChange *(*CUI_OrderedCollectionDifferenceTransformingChangesFunctionType)(NSOrderedCollectionChange *,void*);

// Class
Class OrderedCollectionDifferenceClass( void );

// Init
NSOrderedCollectionDifference *OrderedCollectionDifferenceWithChanges( CFArrayRef changes );
NSOrderedCollectionDifference *OrderedCollectionDifferenceWithInsertIndexes( NSIndexSet *inserts, CFArrayRef insertedObjects, NSIndexSet *removes, CFArrayRef removedObjects );
NSOrderedCollectionDifference *OrderedCollectionDifferenceWithInsertIndexesAdditionalChanges( NSIndexSet *inserts, CFArrayRef insertedObjects, NSIndexSet *removes, CFArrayRef removedObjects, CFArrayRef changes );

// Instance properties
BOOL OrderedCollectionDifferenceHasChanges( NSOrderedCollectionDifference *ref );
CFArrayRef OrderedCollectionDifferenceInsertions( NSOrderedCollectionDifference *ref );
CFArrayRef OrderedCollectionDifferenceRemovals( NSOrderedCollectionDifference *ref );

// Instance methods
NSOrderedCollectionDifference *OrderedCollectionDifferenceInverse( NSOrderedCollectionDifference *ref );
NSOrderedCollectionDifference *OrderedCollectionDifferenceByTransformingChanges( NSOrderedCollectionDifference *ref, CUI_OrderedCollectionDifferenceTransformingChangesFunctionType fnAddress, void *userData );

#endif// 101500
