/*
 Orthography.h

 Bernie Wylde
 */


#import "CocoaUI.h"

// Class
Class OrthographyClass( void );

// - create -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101300
NSOrthography *OrthographyDefaultForLanguage( CFStringRef language );
#endif
NSOrthography *OrthographyWithDominantScript( CFStringRef script, CFDictionaryRef map );

// - correspondences between languages and scripts -
CFDictionaryRef OrthographyLanguageMap( NSOrthography *ref );
CFStringRef OrthographyDominantLanguage( NSOrthography *ref );
CFStringRef OrthographyDominantScript( NSOrthography *ref );
CFStringRef OrthographyDominantLanguageForScript( NSOrthography *ref, CFStringRef script );
CFArrayRef OrthographyLanguagesForScript( NSOrthography *ref, CFStringRef script );
CFArrayRef OrthographyAllScripts( NSOrthography *ref );
CFArrayRef OrthographyAllLanguages( NSOrthography *ref );

