/*
 PathComponentCell.m

 Bernie Wylde
 */

#import "PathComponentCell.h"

// Class
Class PathComponentCellClass( void )
{ return [NSPathComponentCell class]; }

// Init
NSPathComponentCell *PathComponentCellInit( void )
{ return [[[NSPathComponentCell alloc] init] autorelease]; }

NSPathComponentCell *PathComponentCellWithTitle( CFStringRef title, NSImage *image, CFURLRef url )
{
    NSPathComponentCell *cell = [[[NSPathComponentCell alloc] init] autorelease];
    if ( title ) [cell setTitle:(__bridge NSString *)title];
    if ( image ) [cell setImage:image];
    if ( url ) [cell setURL:(__bridge NSURL *)url];
    return cell;
}

// Image
NSImage *PathComponentCellImage( NSPathComponentCell *ref )
{ return [ref image]; }

void PathComponentCellSetImage( NSPathComponentCell *ref, NSImage *image )
{ [ref setImage:image]; }

// URL
CFURLRef PathComponentCellURL( NSPathComponentCell *ref )
{ return (__bridge CFURLRef)[ref URL]; }

void PathComponentCellSetURL( NSPathComponentCell *ref, CFURLRef url )
{ [ref setURL:(__bridge NSURL *)url]; }

