/*
 PathControlItem.m

 Bernie Wylde
 */

#import "PathControlItem.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

// Class
Class PathControlItemClass( void )
{ return [NSPathControlItem class]; }

// Init
NSPathControlItem *PathControlItemInit( void )
{ return [[[NSPathControlItem alloc] init] autorelease]; }

// Instance properties
CFURLRef PathControlItemURL( NSPathControlItem *ref )
{ return (__bridge CFURLRef)[ref URL]; }

CFAttributedStringRef PathControlItemAttributedTitle( NSPathControlItem *ref )
{ return (__bridge CFAttributedStringRef)[ref attributedTitle]; }

void PathControlItemSetAttributedTitle( NSPathControlItem *ref, CFAttributedStringRef aString )
{ [ref setAttributedTitle:(__bridge NSAttributedString *)aString]; }

NSImage *PathControlItemImage( NSPathControlItem *ref )
{ return [ref image]; }

void PathControlItemSetImage( NSPathControlItem *ref, NSImage *image )
{ [ref setImage:image]; }

CFStringRef PathControlItemTitle( NSPathControlItem *ref )
{ return (__bridge CFStringRef)[ref title]; }

void PathControlItemSetTitle( NSPathControlItem *ref, CFStringRef string )
{ [ref setTitle:(__bridge NSString *)string]; }

#endif// 101000
