/*
 PredicateEditorRowTemplate.m

 Bernie Wylde
 */

#import "PredicateEditorRowTemplate.h"

// Class
Class PredicateEditorRowTemplateClass( void )
{ return [NSPredicateEditorRowTemplate class]; }

// Init
NSPredicateEditorRowTemplate *PredicteEditorRowTemplateWithExpressions( CFArrayRef leftExpressions, CFArrayRef rightExpressions, NSComparisonPredicateModifier modifier, CFArrayRef operators, NSUInteger options )
{ return [[[NSPredicateEditorRowTemplate alloc] initWithLeftExpressions:(__bridge NSArray *)leftExpressions rightExpressions:(__bridge NSArray *)rightExpressions modifier:modifier operators:(__bridge NSArray *)operators options:options] autorelease]; }

NSPredicateEditorRowTemplate *PredicteEditorRowTemplateWithRightExpressionAttributeType( CFArrayRef leftExpressions, NSAttributeType type, NSComparisonPredicateModifier modifier, CFArrayRef operators, NSUInteger options )
{ return [[[NSPredicateEditorRowTemplate alloc] initWithLeftExpressions:(__bridge NSArray *)leftExpressions rightExpressionAttributeType:type modifier:modifier operators:(__bridge NSArray *)operators options:options] autorelease]; }

NSPredicateEditorRowTemplate *PredicteEditorRowTemplateWithCompoundTypes( CFArrayRef compoundTypes )
{ return [[[NSPredicateEditorRowTemplate alloc] initWithCompoundTypes:(__bridge NSArray *)compoundTypes] autorelease]; }

// Primitive methods
double PredicteEditorRowTemplateMatchForPredicate( NSPredicateEditorRowTemplate *ref, NSPredicate *predicate )
{ return [ref matchForPredicate:predicate]; }

CFArrayRef PredicteEditorRowTemplateViews( NSPredicateEditorRowTemplate *ref )
{ return (__bridge CFArrayRef)[ref templateViews]; }

void PredicteEditorRowTemplateSetPredicate( NSPredicateEditorRowTemplate *ref, NSPredicate *predicate )
{ [ref setPredicate:predicate]; }

CFArrayRef PredicteEditorRowTemplateDisplayableSubpredicatesOfPredicate( NSPredicateEditorRowTemplate *ref, NSPredicate *predicate )
{ return (__bridge CFArrayRef)[ref displayableSubpredicatesOfPredicate:predicate]; }

NSPredicate *PredicteEditorRowTemplatePredicateWithSubpredicates( NSPredicateEditorRowTemplate *ref, CFArrayRef subpredicates )
{ return [ref predicateWithSubpredicates:(__bridge NSArray *)subpredicates]; }

// Info
CFArrayRef PredicteEditorRowTemplateLeftExpressions( NSPredicateEditorRowTemplate *ref )
{ return (__bridge CFArrayRef)[ref leftExpressions]; }

CFArrayRef PredicteEditorRowTemplateRightExpressions( NSPredicateEditorRowTemplate *ref )
{ return (__bridge CFArrayRef)[ref rightExpressions]; }

CFArrayRef PredicteEditorRowTemplateCompoundTypes( NSPredicateEditorRowTemplate *ref )
{ return (__bridge CFArrayRef)[ref compoundTypes]; }

NSComparisonPredicateModifier PredicteEditorRowTemplateModifier( NSPredicateEditorRowTemplate *ref )
{ return [ref modifier]; }

CFArrayRef PredicteEditorRowTemplateOperators( NSPredicateEditorRowTemplate *ref )
{ return (__bridge CFArrayRef)[ref operators]; }

NSUInteger PredicteEditorRowTemplateOptions( NSPredicateEditorRowTemplate *ref )
{ return [ref options]; }

NSAttributeType PredicteEditorRowTemplateRightExpressionAttributeType( NSPredicateEditorRowTemplate *ref )
{ return [ref rightExpressionAttributeType]; }

