/*
 PressGestureRecognizer.m

 Bernie Wylde
 */

#import "PressGestureRecognizer.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

/*
 Subclass
 */
@implementation CUI_PressGestureRecognizer
@end

// Class
Class PressGestureRecognizerClass( void )
{ return [NSPressGestureRecognizer class]; }

// - init -
NSPressGestureRecognizer *PressGestureRecognizerInit( void *callback, void *userData )
{
    CUI_GestureRecognizerTarget *target = [[[CUI_GestureRecognizerTarget alloc] initWithCallback:callback userData:userData] autorelease];
    return [[[NSPressGestureRecognizer alloc] initWithTarget:target action:@selector(action:)] autorelease];
}

// - configure -
NSUInteger PressGestureRecognizerButtonMask( NSPressGestureRecognizer *ref )
{ return [ref buttonMask]; }

void PressGestureRecognizerSetButtonMask( NSPressGestureRecognizer *ref, NSUInteger mask )
{ [ref setButtonMask:mask]; }

CFTimeInterval PressGestureRecognizerMinimumPressDuration( NSPressGestureRecognizer *ref )
{ return [ref minimumPressDuration]; }

void PressGestureRecognizerSetMinimumPressDuration( NSPressGestureRecognizer *ref, CFTimeInterval duration )
{ [ref setMinimumPressDuration:duration]; }

CGFloat PressGestureRecognizerAllowableMovement( NSPressGestureRecognizer *ref )
{ return [ref allowableMovement]; }

void PressGestureRecognizerSetAllowableMovement( NSPressGestureRecognizer *ref, CGFloat movement )
{ [ref setAllowableMovement:movement]; }

// - instance properties -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101202
NSInteger PressGestureRecognizerNumberOfTouchesRequired( NSPressGestureRecognizer *ref )
{ return [ref numberOfTouchesRequired]; }

void PressGestureRecognizerSetNumberOfTouchesRequired( NSPressGestureRecognizer *ref, NSInteger touches )
{ [ref setNumberOfTouchesRequired:touches]; }
#endif

#endif
