/*
 ProgressIndicator.h

 Bernie Wylde
 */


#import "CocoaUI.h"

//#import "DialogEvent.h"
//#import "View.h"
//#import "Window.h"

@interface ProgressIndicatorSC : NSProgressIndicator
@end

@interface NSProgressIndicator (Additions)
@property (nonatomic,retain) NSNumber *tagNumber;

- (NSInteger)tag;
- (void)setTag:(NSInteger)tag;
@end

// Class
Class ProgressIndicatorClass( void );

NSProgressIndicator *ProgressIndicatorWithTag( NSInteger tag );
BOOL ProgressIndicatorExists( NSInteger tag );

// - animating -
void ProgressIndicatorStartAnimation( NSInteger tag );
void ProgressIndicatorStopAnimation( NSInteger tag );
BOOL ProgressIndicatorUsesThreadedAnimation( NSInteger tag );
void ProgressIndicatorSetUsesThreadedAnimation( NSInteger tag, BOOL flag );

// - advancing -
void ProgressIndicatorIncrementBy( NSInteger tag, double delta );
double ProgressIndicatorDoubleValue( NSInteger tag );
void ProgressIndicatorSetDoubleValue( NSInteger tag, double value );
double ProgressIndicatorMinValue( NSInteger tag );
void ProgressIndicatorSetMinValue( NSInteger tag, double value );
double ProgressIndicatorMaxValue( NSInteger tag );
void ProgressIndicatorSetMaxValue( NSInteger tag, double value );

// - appearance -
NSControlSize ProgressIndicatorControlSize( NSInteger tag );
void ProgressIndicatorSetControlSize( NSInteger tag, NSControlSize size );
NSControlTint ProgressIndicatorControlTint( NSInteger tag );
void ProgressIndicatorSetControlTint( NSInteger tag, NSControlTint tint );
BOOL ProgressIndicatorIsBezeled( NSInteger tag );
void ProgressIndicatorSetBezeled( NSInteger tag, BOOL flag );
BOOL ProgressIndicatorIsIndeterminate( NSInteger tag );
void ProgressIndicatorSetIndeterminate( NSInteger tag, BOOL flag );
NSUInteger ProgressIndicatorStyle( NSInteger tag );
void ProgressIndicatorSetStyle( NSInteger tag, NSUInteger style );
void ProgressIndicatorSizeToFit( NSInteger tag );
BOOL ProgressIndicatorIsDisplayWhenStopped( NSInteger tag );
void ProgressIndicatorSetDisplayWhenStopped( NSInteger tag, BOOL flag );


// Init
NSProgressIndicator *ProgressIndicatorInit( NSInteger inTag, CGRect inRect );

// Statement
void CUI_ProgressIndicator( NSInteger inTag, double inValue, CGRect inRect, double inMinValue, double inMaxValue, NSInteger inWndTag );

