/*
 PropertyDescription.h
 
 Bernie Wylde
 */

#import <CoreData/CoreData.h>
#import "CocoaUI.h"

// Features
BOOL PropertyDescriptionIsOptional( NSPropertyDescription *ref );
void PropertyDescriptionSetOptional( NSPropertyDescription *ref, BOOL flag );
BOOL PropertyDescriptionIsTransient( NSPropertyDescription *ref );
void PropertyDescriptionSetTransient( NSPropertyDescription *ref, BOOL flag );
CFStringRef PropertyDescriptionName( NSPropertyDescription *ref );
void PropertyDescriptionSetName( NSPropertyDescription *ref, CFStringRef name );
CFDictionaryRef PropertyDescriptionUserInfo( NSPropertyDescription *ref );
void PropertyDescriptionSetUserInfo( NSPropertyDescription *ref, CFDictionaryRef userInfo );

// Validation
CFArrayRef PropertyDescriptionValidationPredicates( NSPropertyDescription *ref );
CFArrayRef PropertyDescriptionValidationWarnings( NSPropertyDescription *ref );
void PropertyDescriptionSetValidationPredicatesWithValidationWarnings( NSPropertyDescription *ref, CFArrayRef predicates, CFArrayRef warnings );

// Versioning
CFDataRef PropertyDescriptionVersionHash( NSPropertyDescription *ref );
CFStringRef PropertyDescriptionVersionHashModifier( NSPropertyDescription *ref );
void PropertyDescriptionSetVersionHashModifier( NSPropertyDescription *ref, CFStringRef modifier );
CFStringRef PropertyDescriptionRenamingIdentifier( NSPropertyDescription *ref );
void PropertyDescriptionSetRenamingIdentifier( NSPropertyDescription *ref, CFStringRef identifier );

// Spotlight support
BOOL PropertyDescriptionIsIndexedBySpotlight( NSPropertyDescription *ref );
void PropertyDescriptionSetIndexedBySpotlight( NSPropertyDescription *ref, BOOL flag );

