/*
 PropertyDescription.m
 
 Bernie Wylde
 */

#import "PropertyDescription.h"

// Features
BOOL PropertyDescriptionIsOptional( NSPropertyDescription *ref )
{ return [ref isOptional]; }

void PropertyDescriptionSetOptional( NSPropertyDescription *ref, BOOL flag )
{ [ref setOptional:flag]; }

BOOL PropertyDescriptionIsTransient( NSPropertyDescription *ref )
{ return [ref isTransient]; }

void PropertyDescriptionSetTransient( NSPropertyDescription *ref, BOOL flag )
{ [ref setTransient:flag]; }

CFStringRef PropertyDescriptionName( NSPropertyDescription *ref )
{ return (__bridge CFStringRef)[ref name]; }

void PropertyDescriptionSetName( NSPropertyDescription *ref, CFStringRef name )
{ [ref setName:(__bridge NSString *)name]; }

CFDictionaryRef PropertyDescriptionUserInfo( NSPropertyDescription *ref )
{ return (__bridge CFDictionaryRef)[ref userInfo]; }

void PropertyDescriptionSetUserInfo( NSPropertyDescription *ref, CFDictionaryRef userInfo )
{ [ref setUserInfo:(__bridge NSDictionary *)userInfo]; }

// Validation
CFArrayRef PropertyDescriptionValidationPredicates( NSPropertyDescription *ref )
{ return (__bridge CFArrayRef)[ref validationPredicates]; }

CFArrayRef PropertyDescriptionValidationWarnings( NSPropertyDescription *ref )
{ return (__bridge CFArrayRef)[ref validationWarnings]; }

void PropertyDescriptionSetValidationPredicatesWithValidationWarnings( NSPropertyDescription *ref, CFArrayRef predicates, CFArrayRef warnings )
{ [ref setValidationPredicates:(__bridge NSArray *)predicates withValidationWarnings:(__bridge NSArray *)warnings]; }

// Versioning
CFDataRef PropertyDescriptionVersionHash( NSPropertyDescription *ref )
{ return (__bridge CFDataRef)[ref versionHash]; }

CFStringRef PropertyDescriptionVersionHashModifier( NSPropertyDescription *ref )
{ return (__bridge CFStringRef)[ref versionHashModifier]; }

void PropertyDescriptionSetVersionHashModifier( NSPropertyDescription *ref, CFStringRef modifier )
{ [ref setVersionHashModifier:(__bridge NSString *)modifier]; }

CFStringRef PropertyDescriptionRenamingIdentifier( NSPropertyDescription *ref )
{ return (__bridge CFStringRef)[ref renamingIdentifier]; }

void PropertyDescriptionSetRenamingIdentifier( NSPropertyDescription *ref, CFStringRef identifier )
{ [ref setRenamingIdentifier:(__bridge NSString *)identifier]; }

// Spotlight support
BOOL PropertyDescriptionIsIndexedBySpotlight( NSPropertyDescription *ref )
{ return [ref isIndexedBySpotlight]; }

void PropertyDescriptionSetIndexedBySpotlight( NSPropertyDescription *ref, BOOL flag )
{ [ref setIndexedBySpotlight:flag]; }

