/*
 QLPreviewReply.h

 Bernie Wylde
 */

#import "CocoaUI.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 120000

typedef PDFDocument *(*CUI_QLPreviewReplyForPDFWithPageSizeHandlerType)(QLPreviewReply*,NSError**,void*);
typedef NSData *(*CUI_QLPreviewReplyWithDataOfContentTypeHandlerType)(QLPreviewReply*,NSError**,void*);
typedef BOOL (*CUI_QLPreviewReplyWithContextSizeHandlerType)(CGContextRef,QLPreviewReply*,NSError**,void*);

// Create
QLPreviewReply *QLPreviewReplyWithFileURL( CFURLRef url );
QLPreviewReply *QLPreviewReplyForPDFWithPageSize( CGSize defaultPageSize, CUI_QLPreviewReplyForPDFWithPageSizeHandlerType pdfDocumentCreationHandler, void *userData );
QLPreviewReply *QLPreviewReplyWithDataOfContentType( UTType *type, CGSize contentSize, CUI_QLPreviewReplyWithDataOfContentTypeHandlerType dataCreationHandler, void *userData );
QLPreviewReply *QLPreviewReplyWithContextSize( CGSize contextSize, BOOL isBitmap, CUI_QLPreviewReplyWithContextSizeHandlerType contextCreationHandler, void *userData );

// Inspect
CFStringRef QLPreviewReplyTitle( QLPreviewReply *ref );
void QLPreviewReplySetTitle( QLPreviewReply *ref, CFStringRef title );
CFDictionaryRef QLPreviewReplyAttachments( QLPreviewReply *ref );
void QLPreviewReplySetAttachments( QLPreviewReply *ref, CFDictionaryRef attachments );
NSStringEncoding QLPreviewReplyStringEncoding( QLPreviewReply *ref );
void QLPreviewReplySetStringEncoding( QLPreviewReply *ref, NSStringEncoding encoding );


#pragma mark - QLPreviewReplyAttachment

// Create
QLPreviewReplyAttachment *QLPreviewReplyAttachmentWithData( CFDataRef dta, UTType *type );

// Inspect
UTType *QLPreviewReplyAttachmentContentType( QLPreviewReplyAttachment *ref );
CFDataRef QLPreviewReplyAttachmentData( QLPreviewReplyAttachment *ref );


#endif// 120000

