/*
 RelativeDateTimeFormatter.m

 Bernie Wylde
 */

#import "RelativeDateTimeFormatter.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500

// Class
Class RelativeDateTimeFormatterClass( void )
{ return [NSRelativeDateTimeFormatter class]; }

// Create
NSRelativeDateTimeFormatter *RelativeDateTimeFormatterInit( void )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return [[[NSRelativeDateTimeFormatter alloc] init] autorelease];
    }
    return nil;
}

// Instance properties
CFCalendarRef RelativeDateTimeFormatterCalendar( NSRelativeDateTimeFormatter *ref )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return (__bridge CFCalendarRef)[ref calendar];
    }
    return nil;
}

void RelativeDateTimeFormatterSetCalendar( NSRelativeDateTimeFormatter *ref, CFCalendarRef cal )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref setCalendar:(__bridge NSCalendar *)cal];
    }
}

NSRelativeDateTimeFormatterStyle RelativeDateTimeFormatterStyle( NSRelativeDateTimeFormatter *ref )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return [ref dateTimeStyle];
    }
    return 0;
}

void RelativeDateTimeFormatterSetStyle( NSRelativeDateTimeFormatter *ref, NSRelativeDateTimeFormatterStyle style )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref setDateTimeStyle:style];
    }
}

NSFormattingContext RelativeDateTimeFormatterFormattingContext( NSRelativeDateTimeFormatter *ref )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return [ref formattingContext];
    }
    return 0;
}

void RelativeDateTimeFormatterSetFormattingContext( NSRelativeDateTimeFormatter *ref, NSFormattingContext context )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref setFormattingContext:context];
    }
}

CFLocaleRef RelativeDateTimeFormatterLocale( NSRelativeDateTimeFormatter *ref )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return (__bridge CFLocaleRef)[ref locale];
    }
    return nil;
}

void RelativeDateTimeFormatterSetLocale( NSRelativeDateTimeFormatter *ref, CFLocaleRef locale )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref setLocale:(__bridge NSLocale *)locale];
    }
}

NSRelativeDateTimeFormatterUnitsStyle RelativeDateTimeFormatterUnitsStyle( NSRelativeDateTimeFormatter *ref )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return [ref unitsStyle];
    }
    return 0;
}

void RelativeDateTimeFormatterSetUnitsStyle( NSRelativeDateTimeFormatter *ref, NSRelativeDateTimeFormatterUnitsStyle style )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref setUnitsStyle:style];
    }
}

// Instance methods
CFStringRef RelativeDateTimeFormatterLocalizedStringForDate( NSRelativeDateTimeFormatter *ref, CFDateRef dt, CFDateRef referenceDate )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return (__bridge CFStringRef)[ref localizedStringForDate:(__bridge NSDate *)dt relativeToDate:(__bridge NSDate *)referenceDate];
    }
    return nil;
}

CFStringRef RelativeDateTimeFormatterLocalizedStringFromDateComponents( NSRelativeDateTimeFormatter *ref, NSDateComponents *components )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return (__bridge CFStringRef)[ref localizedStringFromDateComponents:components];
    }
    return nil;
}

CFStringRef RelativeDateTimeFormatterLocalizedStringFromTimeInterval( NSRelativeDateTimeFormatter *ref, CFTimeInterval ti )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return (__bridge CFStringRef)[ref localizedStringFromTimeInterval:ti];
    }
    return nil;
}

CFStringRef RelativeDateTimeFormatterStringForObjectValue( NSRelativeDateTimeFormatter *ref, CFTypeRef obj )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return (__bridge CFStringRef)[ref stringForObjectValue:(__bridge id)obj];
    }
    return nil;
}

#endif// 101500
