/*
 Responder.h

 Bernie Wylde
 */



//#import "DialogEvent.h"
//#import "Event.h"
//#import "Menu.h"
//#import "View.h"
//#import "Window.h"

@interface CUI_ResponderTarget : NSObject
@end

// dialog events
enum {
    responderDidPresentError = 4900
};


// common selector commands
enum {
    selectorComplete = 1,
    selectorDeleteBackward,
    selectorInsertBacktab,
    selectorInsertNewline,
    selectorInsertTab,
    selectorMoveLeft,
    selectorMoveRight
};

// command for selector
NSInteger CUI_ResponderCommandForSelector( SEL selector );


#pragma mark - private
void CUI_ResponderForwardWindowDialogEvent( NSWindow *w, NSInteger dialogEvent, NSEvent *event );
void CUI_ResponderForwardViewDialogEvent( NSView *view, NSInteger dialogEvent, NSEvent *event );



#pragma mark - mouse events
BOOL CUI_ResponderAcceptsFirstResponder( id responder );
void CUI_ResponderMouseDown( id responder, NSEvent *event );
void CUI_ResponderMouseDragged( id responder, NSEvent *event );
void CUI_ResponderMouseUp( id responder, NSEvent *event );
void CUI_ResponderMouseMoved( id responder, NSEvent *event );
void CUI_ResponderMouseEntered( id responder, NSEvent *event );
void CUI_ResponderMouseExited( id responder, NSEvent *event );

void CUI_ResponderRightMouseDown( id responder, NSEvent *event );
void CUI_ResponderRightMouseDragged( id responder, NSEvent *event );
void CUI_ResponderRightMouseUp( id responder, NSEvent *event );
void CUI_ResponderOtherMouseDown( id responder, NSEvent *event );
void CUI_ResponderOtherMouseDragged( id responder, NSEvent *event );
void CUI_ResponderOtherMouseUp( id responder, NSEvent *event );

#pragma mark - key events
void CUI_ResponderKeyDown( id responder, NSEvent *event );
void CUI_ResponderKeyUp( id responder, NSEvent *event );


#pragma mark - other events
void CUI_ResponderFlagsChanged( id responder, NSEvent *event );








#pragma mark - public
// Class
Class ResponderClass( void );

// Manage next responder
NSResponder *ResponderNextResponder( NSResponder *ref );

// Presenting and customizing error info
BOOL ResponderPresentError( NSResponder *ref, NSError *err );
void ResponderPresentErrorModalForWindow( NSResponder *ref, NSError *err, NSInteger wndTag, void *context );

// Managing a responder's menu
NSMenu *ResponderMenu( NSResponder *ref );
void ResponderSetMenu( NSResponder *ref, NSInteger menuID );

// Getting the undo manager
NSUndoManager *ResponderUndoManager( NSResponder *ref );

