/*
 RotationGestureRecognizer.m

 Bernie Wylde
 */

#import "RotationGestureRecognizer.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

/*
 Subclass
 */
@implementation CUI_RotationGestureRecognizer
@end

// Class
Class RotationGestureRecognizerClass( void )
{ return [NSRotationGestureRecognizer class]; }

// - init -
NSRotationGestureRecognizer *RotationGestureRecognizerInit( void *callback, void *userData )
{
    CUI_GestureRecognizerTarget *target = [[[CUI_GestureRecognizerTarget alloc] initWithCallback:callback userData:userData] autorelease];
    return [[[NSRotationGestureRecognizer alloc] initWithTarget:target action:@selector(action:)] autorelease];
}

// - interpreting -
CGFloat RotationGestureRecognizerRotation( NSRotationGestureRecognizer *ref )
{ return [ref rotation]; }

void RotationGestureRecognizerSetRotation( NSRotationGestureRecognizer *ref, CGFloat rotation )
{ [ref setRotation:rotation]; }

CGFloat RotationGestureRecognizerRotationInDegrees( NSRotationGestureRecognizer *ref )
{ return [ref rotationInDegrees]; }

void RotationGestureRecognizerSetRotationDegrees( NSRotationGestureRecognizer *ref, CGFloat rotation )
{ [ref setRotationInDegrees:rotation]; }

#endif
