
#ifndef RUNTIME_H
#define RUNTIME_H

// Dev flags
#define kNSFBFullStop 1 // 20160408

/* temp_includes.c */
//
// gFBStrStk size increased ( to 127 )to bypass bug that causes crash when memmove() overwrites another var's contents. Brian 20160514
//
extern Str255 gFBStrStk[64];
extern SInt16 gFBStk;
extern Str255 gReturnedString;
extern Str255 gFBTStk[16];
extern SInt8 gFBTStkP;
extern UInt8 gPSDefStrSize;
extern UInt8 gPSDefTabStops;
extern Boolean gFBLeadingSpace;
extern UInt16 gFBPrintPos;
extern char gFBUsingSymbols[4];
extern UInt32 gFBNextData;

#if USE_SJLJ_FOR_GOSUB_RETURN // see _useSJLJForGosubReturn in FBtoC source
extern jmp_buf gReturnEnv[1024];
#else
extern UInt16 gReturnLabelNum[1024];
#endif

extern UInt16 gReturnLevel;
extern long gSelectL[10];
extern double gSelectD[10];
extern Str255 gSelectS[10];
extern CFTypeRef gSelectCF[10];

extern OSStatus gFBSysError;
extern volatile FBBoolean gFBSndBusy;
extern DynArrayInfo gFBDynArrayInfo[64];
extern void *gFBTempContainer;
extern void *gFBTemp2Container;

extern long   gFBFileError;
extern OSType gFBSaveType;
extern OSType gFBSaveCreator;
extern Str255 gFBLineBuf;
extern UInt32 gFBLineDev;
extern UInt32 gFBLinePos;
extern SInt64 gFBLastFilePos;
extern char gFBFileTabMode;
extern UInt16 gFBTabWidth;

extern FBInfoForOpenFile gFBOpenFiles[kMaxFBFiles + kFBMaxSerialFiles];

extern FBOnXxxxxVector gFBOnErrorVector;
extern CFMutableArrayRef gFBIndex[9 + 1];
extern FBBoolean gFBQuit;

extern unsigned char gFBFloatMaxDigits;
extern long gFBWidth;
extern long gFBWidthLprint;
extern int  gFBRoute; //2022-Jan-11 Brian
extern const Boolean gNumberLeadingSpace;

extern Handle gFBBuffer[6];

extern Boolean gThreadsUsed;
extern short gFBInThread;
extern short gFBAbortThreads;
extern long gFBThreadList[32];
extern long gFBThreadFlags[32];
extern long gFBThreadProc[32];
//extern CFMutableArrayRef sFinderInfoArray;
extern const UInt32 kFBEFFilter;
extern Str1 gFBTEKey;
extern FBOnXxxxxVector gFBOnEditVector;
/* temp_includes.c */
StringPtr PSltrl(char *inCString, char *commentForGenstrings);
StringPtr PSltrr(char *inCString, char *commentForGenstrings);
void DebugPrintStackLevel(void);
void FBKillDynamicArray(const int dynArrayNum);
void FBGrowDynamicArray(const int dynArrayNum, const int index);
void FBWriteDynamic(int fileRef, int dynArrayNum);
void FBReadDynamic(int fileRef, int dynArrayNum);
void FBSwap(void *p1, void *p2, const int bytes);
StringPtr PScstr(Str255 s);
StringPtr CSpstr(char *s);
void PSinput( StringPtr s );

StringPtr STACK_PUSH( void ); // replacement for STACK_PUSH macro Brian 20160515

StringPtr PSstrcpy(StringPtr dest, ConstStr255Param source);
StringPtr PSstrcpyn(StringPtr dest, ConstStr255Param source, const int destSize);
StringPtr PSstrcat( StringPtr dest, ConstStr255Param appendStr);
StringPtr PSstrcatn(StringPtr dest, ConstStr255Param source, const int destSize);
void PSdeftab(const int tabstops);
void FBDefUsing(const SInt32 formatchars);
StringPtr PSusing(Str255 format, const double n);

CFStringRef CFUsing( CFStringRef format, double n );// 20210131 bw

StringPtr PSleft(ConstStr255Param s, SInt16 n);
StringPtr PSright(ConstStr255Param s, SInt16 n);
StringPtr PSmid(ConstStr255Param s, SInt16 p, SInt16 n);
StringPtr PSucase(ConstStr255Param s);
StringPtr PSstring(SInt16 n, UInt8 theChar);
StringPtr PSstringstr(SInt16 n, ConstStr255Param s);
StringPtr PSstrampersand(Handle h, int index);
StringPtr PSstrhash(const int resID, const int index);
StringPtr PSpstr(StringPtr p);
CFStringRef DateFormatCreateStringWithAbsoluteTime( CFStringRef formatStr, CFAbsoluteTime at );
StringPtr PSdatePStime( ConstStr255Param s );

CFStringRef DateCFString( CFStringRef formatStr );
CFStringRef TimeCFString( CFStringRef formatStr );

#if 1// INSTR_OPTIONS
SInt64 InString( SInt32 startPos,  CFStringRef strToSearch, CFStringRef strToSearchFor, NSInteger searchOptions );
#else// INSTR_OPTIONS
SInt64 InString( SInt32 startPos,  CFStringRef strToSearch, CFStringRef strToSearchFor );
#endif// INSTR_OPTIONS

CFStringRef RightString( CFStringRef inString, CFIndex howManyChars );
CFStringRef LeftString( CFStringRef inString, CFIndex toIndex );
CFStringRef MidString( CFStringRef inString, CFIndex startPos, CFIndex howManyChars );

CFStringRef HexString( long num );
CFStringRef BinString( long theBytes );
CFStringRef OctString( long theBytes );// 20210123 bw

CFStringRef SpaceCFString( long length );// 20210123 bw
CFStringRef LcaseCFString( CFStringRef string );// 20210123 bw
CFStringRef UcaseCFString( CFStringRef string );// 20210123 bw

CFStringRef MKIString( UInt32 n );// 20210124 bw
NSInteger LenCF( CFTypeRef obj ); // 20210127 bw
void MidStatementCF( CFMutableStringRef inString, CFIndex startPos, CFIndex numChars, CFStringRef repString );// 20210124 bw


SInt16 STRLeadingSpace(void);
void PSdefstr(const UInt8 length);

CFStringRef CopyDblToString( const double user_supplied_number );
StringPtr PSstr(const double n );// maxDigits second param 20210125 bw

StringPtr PShex( long n );
StringPtr PSoct( long n );
StringPtr PSbin( long n );
StringPtr PSuns( const SInt32 n );
StringPtr PSmki(UInt32 n);
SInt8 FBPopCmpStr(Str255 s1, Str255 s2);
int CviCF( CFStringRef s );// 20210129 bw
int FBcvi(ConstStr255Param s);
UInt8 PSlen(ConstStr255Param s);
UInt8 PSasc(ConstStr255Param s);
UInt8 PSinstr(int startPos, Str255 haystack, Str255 needle);
SInt64 PSvalint(Str255 s);
double PSval(Str255 s);
NSInteger FBIntVal( id obj );// 20220627 bw
double FBDblVal( id obj );// 20220627 bw
long MidStmt(void *strvPtr, long position, long length, Str255 s_p);
double frac(const double x);
double sgn(const double value);
SInt32 sgni(const SInt32 value);
SInt32 maybe(void);
long rnd(long expr);
int FBmax(const SInt32 n1, const SInt32 n2);
void FBDelay(const Duration t);
SInt32 FBSystemFunction( const SInt32 expr );
SInt32 OSVersion( void );
void OSGetMajorMinor( NSInteger *maj, NSInteger *min );   //2020-Dec-26 Brian

void FBRunPath( CFStringRef path ); // 20151002 bw
void FBRunURL( CFURLRef url );      // 20151002 bw
void FBPstrDollarStatement(void *address, void *s);

////////////////////////////////////////////////////////
//   Container declares from Container.c              //
////////////////////////////////////////////////////////
StringPtr GetCtnrString(void **srcCtnrVar, StringPtr s, short lstring);
StringPtr CatCtnrString(void **srcCtnrVar, StringPtr sPtr, long lstring);
void FBCtnrCopy(void **srcCtnrVar, void **destCtnrVar);
void * FBCtnrCopy3( void **destCtnrVar, void **srcCtnrVar );

void *CtnrStoreString(void **ctnrVarPtr, Str255 inPStr);
void CtnrFree(void * ptr);

long Asc_ctnr( void **ctnrVarPtr);
void PrintContainer( Handle *ctnrVarPtr );
void FBClearTempContainer(void);
void FBClearTemp2Container(void);

void *AddStringToCtnr(void **ctnrVarPtr, Str255 inPStr);
void *AddCtnrs( void **ctnrV1Ptr, void **ctnrV2Ptr);

SInt64 FBCompareHandles( void **ctnr1, void **ctnr2 );
SInt64 FBCompareContainers( void **ctnr1, void **ctnr2 );
Boolean FBCmpCtnr(void **ctnr1, void **ctnr2);
void *UCase_Ctnr(void **ctnrVarPtr);
void * FBNewContainer(SInt64 length);
SInt64 CtnrRequestedSize(void * ptr);
void *Left_Ctnr( void **ctnrVarPtr, SInt64 length);
SInt64 Len_Ctnr( void **ctnrPtr);
void *Mid_Ctnr( void **ctnrVarPtr, SInt64 startPos, SInt64 length);
void *Right_Ctnr( void **ctnrVarPtr, SInt64 length);
void *StringNum_Ctnr(SInt64 length, long c);
void *StringStr_Ctnr(SInt64 length, Str255 inPStr);
void MidStmt_Ctnr(void **ctnrVarPtr, SInt64 position_L, SInt64 length, Str255 inputPStr);
void MidStmt_Ctnr_Ctnr( void **ctnrVarPtr, SInt64 position_L, SInt64 length, void **srcCtnrVar );
SInt64 Instr_Ctnr(long position_L, void **BigctnrVarPtr, void **SearchctnrVarPtr);
SInt64 Instr_Ctnr_PStr(long position_L, void **BigctnrVarPtr, Str255 inputPStr);
//void CtnrStoreResID(long userID, Handle *destCtnrVar);
////////////////////////////////////////////////////////
//   End of container declares from Container.c       //
////////////////////////////////////////////////////////


// on error fn 20201221 bw
//typedef void (*CUI_OnErrorFunctionType)(NSInteger,NSInteger);
//
//static CUI_OnErrorFunctionType sCUI_OnErrorFunction;
//
//CUI_OnErrorFunctionType CUI_OnErrorFunction( void );
//void CUI_SetOnErrorFunction( CUI_OnErrorFunctionType onErrorFn );
//void CallUserDefinedOnErrorFunction( long fileID, long errCode );


long FBerror(void);

//void FBFileErrorAlert(int fileID, OSStatus err);
void FBFileErrorAlert(long fileID, long err);// 20201221 bw

//void FBCheckFileError(int fileID, OSStatus err);
void FBCheckFileError(long fileID, long err);// 20201221 bw

void FBOpenUNIX(unsigned fileID, Str255 command);
void FBOpenOutput(const int fileID, void *fileNamePtr, void *fs);
void FBOpenRandom(const int fileID, void *fileNamePtr, void *fs, SInt64 recLen, Boolean exclusive);
void FBOpenAppend(const int fileID, void *fileNamePtr, void *fs, SInt64 recLen);
void FBOpenInput(const int fileID, void *fileNamePtr, void *fs, SInt64 recLen, Boolean isResourceOpen);
void FBClose(int fileID);
long FBeof(int fileID);

SInt64 FBlof(int fileID, SInt64 recLen);

void FBAppend(const int fileID);
void FBRecord(const int fileID, SInt64 recNum, SInt64 posInRec);
SInt64 CurrentOffset( int fileID );
SInt64 FBrec(int fileID);
SInt64 FBloc(int fileID);
void FBLineInputHash(int fileID, StringPtr s);
//ByteCount FBReadFile(const int fileID, void *dest, Boolean isInputHashString, ByteCount numBytesRequested);
UInt64 FBReadFile( const int fileID, void * dest, Boolean isInputHashString, UInt64 numBytesRequested ); //2023-Apr-26 Brian

StringPtr FBInkeyFromFile(const int fileID);
short FBReadSwapShort(const unsigned fileID);
//long FBReadSwapLong(const unsigned fileID);
int FBReadSwapLong(const unsigned fileID);
float FBReadSwapSingle(const unsigned fileID);
double FBReadSwapDouble(const unsigned fileID);

void FBParseInput(const short varType, void *vPtr);
void FBToCInputFile(const int fileID, void *target, short varType);

//void FBReadString( const int fileID, void * dest, ByteCount numBytesRequested ); //2023-Apr-26 Brian
void FBReadString( int fileID, void *dest, UInt64 numBytesRequested );

void FBWriteFile(const int fileID, void *src, SInt64 numBytes);

void FBWriteString( const int fileID, char * src, ByteCount varLength );
void FBWriteSwapShort(short s, const unsigned fileID);
void FBWriteSwapLong( int l, const unsigned fileID); //2023-Feb-01 Brian //2022-Jan-10 Brian
void FBWriteSwapSingle(float f, const unsigned fileID);
void FBWriteSwapDouble(double d, const unsigned fileID);

void FBFilePrintChar(char theChar);
SInt64 FBFileGetPos(void);
void FBFilePrintTab(void);
void FBFilePrintCR(void);
void FBFilePrintString(Str255 s_p);

void FBSetOpenType(Str15 opentype_p);

void FBRename(CFURLRef oldName, CFURLRef newName );
void FBKill( CFURLRef fileName );

void CopyNameFromCFURLRef(CFURLRef url, CFStringRef *string);
void GetNameAsPascalStringFromCFURLRef(CFURLRef url, Str255 *name);

CFMutableArrayRef CFIndexGetArrayRef(CFIndex indexID);
CFIndex CFIndexGetCount(CFIndex indexID);
void CFIndexSet(CFIndex indexID, CFIndex element, Str255 pStr);
void FBIndexSet(CFIndex element, CFIndex indexID, Str255 pStr);
StringPtr CFIndexGet(CFIndex indexID, CFIndex element);
StringPtr FBIndexGet(CFIndex element, CFIndex indexID);
void CFIndexInsert(CFIndex indexID, CFIndex element, Str255 pStr);
void FBIndexI(CFIndex element, CFIndex indexID, Str255 pStr);
void CFIndexDelete(CFIndex indexID, CFIndex element);
void FBIndexD(CFIndex element, CFIndex indexID);
CFIndex CFIndexFind(CFIndex indexID, CFIndex startElement, Str255 pStr);
CFIndex FBIndexF(Str255 pStr, CFIndex startElement, CFIndex indexID);
void CFIndexClear(CFIndex indexID);
CFComparisonResult CFIndexCompareFunction(const void *val1, const void *val2, void *context);
void CFIndexSort(CFIndex indexID);
void CFIndexAppend(CFIndex indexID, Str255 pStr);

// Change CFIndexRead/Write to use CFURLs instead of FSSpecs. Brian 20170928
Boolean CFIndexWrite(CFIndex indexID, CFURLRef url);
Boolean CFIndexWriteAll(CFURLRef url);
Boolean CFIndexRead(CFIndex indexID, CFURLRef url);
Boolean CFIndexReadAll(CFURLRef url);
// END Change CFIndexRead/Write to use CFURLs instead of FSSpecs. 

CFIndex FBMem(long expr);
OSErr FBAEHandleQuit(AppleEvent *theAppleEvent, AppleEvent *reply, long myAEFlags);
void FBInitAEEvents(void);
void FBHandleEvents(void);

void FBAddLeadingSpace(char *sPtr);  // relocated here outside the #if !__LP64__  Brian 20170507
void PrintCR(void);
void FBPrintString(Str255 s);
//StringPtr FBFloat2String(const double theNum, long style, long digits);

// these four functions should be okay in either 32 or 64-bit builds. Brian 20180320

#if 1// PRINT_TO_WINDOW
void PrintFloat(const double d, NSString *nextArg);
#else
void PrintFloat(const double d);
#endif

void PrintTab(long tabs);

#if 1// PRINT_TO_WINDOW
//NSString *SpaceString( NSInteger count );
void PrintSpc(long spc,NSString *nextArg);
#else
void PrintSpc(long spc );
#endif

#if 1// PRINT_TO_WINDOW
void PrintLong(const SInt64 theNumber,NSString *nextArg);
#else
void PrintLong(const SInt64 theNumber);
#endif

void PrintContainerWnd(void **ctnrVarPtr);

//char *FBCheckBuffer(long bytes2add); // 2021-Jan-15 Brian
void FBAddCharacterToBuffer(short c);
void FBAddStringToBuffer(Str255 string_p);
long Pos(long device);

void FBRoute( int where); //2022-Jan-11 Brian 'long' to 'int'
void FBCheckForPageFeed(long isCr);
void FBText(long font, long size, long style, long xMode);

void FBStopMsg(ConstStr255Param msg_p, const int lineNumber);

void FBFullStop( CFStringRef maj, CFStringRef exp, FBBoolean fatal );

void RuntimeErrMsg(StringPtr msg);

void FBShutdown( void *msgPtr, Boolean cfType );
void FBReportRangeError(const int value, const int lineNumber, const int limit, CFStringRef fileName);

StringPtr FBInkey(void);
void FBLineInput(Str255 prompt_p, void *vPtr);
void FBToCInput(Str255 prompt, void *target, short varType);

NSMutableArray *DispatchGroups( void );
void DispatchGroupAdd( void );
void DispatchGroupRemove( void );
dispatch_group_t DispatchGroupCurrent( void );

#endif /* RUNTIME_H */
