/*
 Screen.h

 Bernie Wylde
 */


#import "CocoaUI.h"

// Class
Class ScreenClass( void );

NSScreen *ScreenMainScreen( void );
NSScreen *ScreenDeepestScreen( void );
CFArrayRef ScreenScreens( void );

NSWindowDepth ScreenDepth( NSScreen *ref );
CGRect ScreenFrame( NSScreen *ref );
// supportedWindowDepths
CFDictionaryRef ScreenDeviceDescription( NSScreen *ref );
//CFArrayRef ScreenSupportedWindowDepths( ScreenRef ref );
CGRect ScreenVisibleFrame( NSScreen *ref );
NSColorSpace *ScreenColorSpace( NSScreen *ref );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
BOOL ScreenCanRepresentDisplayGamut( NSScreen *ref, NSInteger gamut );
#endif

BOOL ScreenScreensHaveSeparateSpaces( void );

CGRect ScreenBackingAlignedRect( NSScreen *ref, CGRect rect, NSAlignmentOptions options );
CGFloat ScreenBackingScaleFactor( NSScreen *ref );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
CFStringRef ScreenLocalizedName( NSScreen *ref );
#endif// 101500

CGRect ScreenConvertRectFromBacking( NSScreen *ref, CGRect rect );
CGRect ScreenConvertRectToBacking( NSScreen *ref, CGRect rect );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 120000
NSEdgeInsets ScreenSafeAreaInsets( NSScreen *ref );
CGRect ScreenAuxiliaryTopLeftArea( NSScreen *ref );
CGRect ScreenAuxiliaryTopRightArea( NSScreen *ref );
#endif// 120000

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
CGFloat ScreenMaximumExtendedDynamicRangeColorComponentValue( NSScreen *ref );
#endif

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
CGFloat ScreenMaximumPotentialExtendedDynamicRangeColorComponentValue( NSScreen *ref );
CGFloat ScreenMaximumReferenceExtendedDynamicRangeColorComponentValue( NSScreen *ref );
#endif// 101500

// Variable rate refresh
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 120000
NSInteger ScreenMaximumFramesPerSecond( NSScreen *ref );
CFTimeInterval ScreenMinimumRefreshInterval( NSScreen *ref );
CFTimeInterval ScreenMaximumRefreshInterval( NSScreen *ref );
CFTimeInterval ScreenDisplayUpdateGranularity( NSScreen *ref );
CFTimeInterval ScreenLastDisplayUpdateTimestamp( NSScreen *ref );
#endif// 120000

// -- convenience --
CGRect ScreenMainFrame( void );

