/*
 Screen.m

 Bernie Wylde
 */

#import "Screen.h"

// Class
Class ScreenClass( void )
{ return [NSScreen class]; }

NSScreen *ScreenMainScreen( void )
{ return [NSScreen mainScreen]; }

NSScreen *ScreenDeepestScreen( void )
{ return [NSScreen deepestScreen]; }

CFArrayRef ScreenScreens( void )
{ return (__bridge CFArrayRef)[NSScreen screens]; }

NSWindowDepth ScreenDepth( NSScreen *ref )
{ return [ref depth]; }

CGRect ScreenFrame( NSScreen *ref )
{ return NSRectToCGRect([ref frame]); }

// supportedWindowDepths

CFDictionaryRef ScreenDeviceDescription( NSScreen *ref )
{ return (__bridge CFDictionaryRef)[ref deviceDescription]; }

//CFArrayRef ScreenSupportedWindowDepths( ScreenRef ref )
//{
//    const NSWindowDepth *depths = [ref supportedWindowDepths];
//    size_t size = malloc_size((void *)depths);
//    
//    // ...
//    
//    return nil;
//}

CGRect ScreenVisibleFrame( NSScreen *ref )
{ return NSRectToCGRect([ref visibleFrame]); }

NSColorSpace *ScreenColorSpace( NSScreen *ref )
{ return [ref colorSpace]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
BOOL ScreenCanRepresentDisplayGamut( NSScreen *ref, NSInteger gamut )
{ return [ref canRepresentDisplayGamut:gamut]; }
#endif

BOOL ScreenScreensHaveSeparateSpaces( void )
{ return [NSScreen screensHaveSeparateSpaces]; }

CGRect ScreenBackingAlignedRect( NSScreen *ref, CGRect rect, NSAlignmentOptions options )
{ return NSRectToCGRect([ref backingAlignedRect:NSRectFromCGRect(rect) options:options]); }

CGFloat ScreenBackingScaleFactor( NSScreen *ref )
{ return [ref backingScaleFactor]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
CFStringRef ScreenLocalizedName( NSScreen *ref )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return (__bridge CFStringRef)[ref localizedName];
    }
    return nil;
}
#endif// 101500

CGRect ScreenConvertRectFromBacking( NSScreen *ref, CGRect rect )
{ return NSRectToCGRect([ref convertRectFromBacking:NSRectFromCGRect(rect)]); }

CGRect ScreenConvertRectToBacking( NSScreen *ref, CGRect rect )
{ return NSRectToCGRect([ref convertRectToBacking:NSRectFromCGRect(rect)]); }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 120000
NSEdgeInsets ScreenSafeAreaInsets( NSScreen *ref )
{
    if (@available(macOS 12.0, *)) {
        return [ref safeAreaInsets];
    }
    return NSEdgeInsetsZero;
}

CGRect ScreenAuxiliaryTopLeftArea( NSScreen *ref )
{
    if (@available(macOS 12.0, *)) {
        return NSRectToCGRect([ref auxiliaryTopLeftArea]);
    }
    return NSZeroRect;
}

CGRect ScreenAuxiliaryTopRightArea( NSScreen *ref )
{
    if (@available(macOS 12.0, *)) {
        return NSRectToCGRect([ref auxiliaryTopRightArea]);
    }
    return NSZeroRect;
}
#endif// 120000

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
CGFloat ScreenMaximumExtendedDynamicRangeColorComponentValue( NSScreen *ref )
{ return [ref maximumExtendedDynamicRangeColorComponentValue]; }
#endif

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500
CGFloat ScreenMaximumPotentialExtendedDynamicRangeColorComponentValue( NSScreen *ref )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return [ref maximumPotentialExtendedDynamicRangeColorComponentValue];
    }
    return 0.0;
}

CGFloat ScreenMaximumReferenceExtendedDynamicRangeColorComponentValue( NSScreen *ref )
{ return [ref maximumReferenceExtendedDynamicRangeColorComponentValue]; }
#endif// 101500

// Variable rate refresh
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 120000
NSInteger ScreenMaximumFramesPerSecond( NSScreen *ref )
{
    if (@available(macOS 12.0, *)) {
        return [ref maximumFramesPerSecond];
    }
    return 0;
}

CFTimeInterval ScreenMinimumRefreshInterval( NSScreen *ref )
{
    if (@available(macOS 12.0, *)) {
        return [ref minimumRefreshInterval];
    }
    return 0.0;
}

CFTimeInterval ScreenMaximumRefreshInterval( NSScreen *ref )
{
    if (@available(macOS 12.0, *)) {
        return [ref maximumRefreshInterval];
    }
    return 0.0;
}

CFTimeInterval ScreenDisplayUpdateGranularity( NSScreen *ref )
{
    if (@available(macOS 12.0, *)) {
        return [ref displayUpdateGranularity];
    }
    return 0.0;
}

CFTimeInterval ScreenLastDisplayUpdateTimestamp( NSScreen *ref )
{
    if (@available(macOS 12.0, *)) {
        return [ref lastDisplayUpdateTimestamp];
    }
    return 0.0;
}
#endif// 120000

// -- convenience --
CGRect ScreenMainFrame( void )
{ return NSRectToCGRect([[NSScreen mainScreen] frame]); }

