/*
 SearchField.h

 Bernie Wylde
 */


#import "CocoaUI.h"

//#import "Control.h"
//#import "DialogEvent.h"
//#import "Menu.h"
//#import "View.h"
//#import "Window.h"

@interface SearchFieldSC : NSSearchField
@end

// dialog events
enum {
    searchFieldDidStartSearching = 1400,
    searchFieldDidEndSearching
};


#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
@interface CUI_SearchFieldDelegate : NSObject <NSSearchFieldDelegate>
@end
#else
@interface CUI_SearchFieldDelegate : NSObject <NSTextFieldDelegate>
@end
#endif

//@interface CUI_SearchFieldDelegate : NSObject <NSTextFieldDelegate>
//@end

CUI_SearchFieldDelegate *CUI_SearchFieldDelegateObj( void );

// Class
Class SearchFieldClass( void );

NSSearchField *SearchFieldWithTag( NSInteger tag );
BOOL SearchFieldExists( NSInteger tag );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
BOOL SearchFieldSendsSearchStringImmediately( NSInteger tag );
void SearchFieldSetSendsSearchStringImmediately( NSInteger tag, BOOL flag );
BOOL SearchFieldSendsWholeSearchString( NSInteger tag );
void SearchFieldSetSendsWholeSearchString( NSInteger tag, BOOL flag );
#endif

CFArrayRef SearchFieldRecentSearches( NSInteger tag );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
BOOL SearchFieldCentersPlaceholder( NSInteger tag );
void SearchFieldSetCentersPlaceholder( NSInteger tag, BOOL flag );
#endif

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
NSInteger SearchFieldMaximumRecents( NSInteger tag );
void SearchFieldSetMaximumRecents( NSInteger tag, NSInteger value );
#endif

CFStringRef SearchFieldRecentsAutosaveName( NSInteger tag );
void SearchFieldSetRecentsAutosaveName( NSInteger tag, CFStringRef name );

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
NSInteger SearchFieldSearchMenuTemplate( NSInteger tag );
void SearchFieldSetSearchMenuTemplate( NSInteger tag, NSInteger menuIndex );
#endif

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101600
CGRect SearchFieldSearchTextBounds( NSInteger tag );
CGRect SearchFieldSearchButtonBounds( NSInteger tag );
CGRect SearchFieldCancelButtonBounds( NSInteger tag );
#endif// 101600

// Convenience
void SearchFieldSetSearchButtonImage( NSInteger tag, NSImage *image );
void SearchFieldSetCancelButtonImage( NSInteger tag, NSImage *image );



// Init
NSSearchField *SearchFieldInit( NSInteger inTag, CGRect inRect );

// Statement
void CUI_SearchField( NSInteger inTag, NSInteger inEnabled, CFStringRef inText, CGRect inRect, NSInteger inWndTag );
