/*
 SearchToolbarItem.m

 Bernie Wylde
 */

#import "SearchToolbarItem.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101600

// Class
Class SearchToolbarItemClass( void )
{ return [NSSearchToolbarItem class]; }

// Configure
BOOL SearchToolbarItemResignsFirstResponderWithCancel( NSSearchToolbarItem *ref )
{
    if (@available(macOS 11.0, *)) {// 20210101
        return [ref resignsFirstResponderWithCancel];
    }
    return NO;
}

void SearchToolbarItemSetResignsFirstResponderWithCancel( NSSearchToolbarItem *ref, BOOL flag )
{
    if (@available(macOS 11.0, *)) {// 20210101
        [ref setResignsFirstResponderWithCancel:flag];
    }
}

NSSearchField *SearchToolbarItemSearchField( NSSearchToolbarItem *ref )
{
    if (@available(macOS 11.0, *)) {// 20210101
        return [ref searchField];
    }
    return nil;
}

void SearchToolbarItemSetSearchField( NSSearchToolbarItem *ref, NSSearchField *searchFld )
{
    if (@available(macOS 11.0, *)) {// 20210101
        [ref setSearchField:searchFld];
    }
}

// Instance properties
CGFloat SearchToolbarItemPreferredWidthForSearchField( NSSearchToolbarItem *ref )
{
    if (@available(macOS 11.0, *)) {// 20210101
        return [ref preferredWidthForSearchField];
    }
    return 0.0;
}

void SearchToolbarItemSetPreferredWidthForSearchField( NSSearchToolbarItem *ref, CGFloat width )
{
    if (@available(macOS 11.0, *)) {// 20210101
        [ref setPreferredWidthForSearchField:width];
    }
}

// Instance methods
void SearchToolbarItemBeginSearchInteraction( NSSearchToolbarItem *ref )
{
    if (@available(macOS 11.0, *)) {// 20210101
        [ref beginSearchInteraction];
    }
}

void SearchToolbarItemEndSearchInteraction( NSSearchToolbarItem *ref )
{
    if (@available(macOS 11.0, *)) {// 20210101
        [ref endSearchInteraction];
    }
}

#endif// 101600
