/*
 Shadow.m

 Bernie Wylde
 */

#import "Shadow.h"

// Class
Class ShadowClass( void )
{ return [NSShadow class]; }

NSShadow *ShadowInit( void )
{ return [[[NSShadow alloc] init] autorelease]; }

CGSize ShadowOffset( NSShadow *ref )
{ return NSSizeToCGSize([ref shadowOffset]); }

void ShadowSetOffset( NSShadow *ref, CGSize offset )
{ [ref setShadowOffset:NSSizeFromCGSize(offset)]; }

CGFloat ShadowBlurRadius( NSShadow *ref )
{ return [ref shadowBlurRadius]; }

void ShadowSetBlurRadius( NSShadow *ref, CGFloat radius )
{ [ref setShadowBlurRadius:radius]; }

NSColor *ShadowColor( NSShadow *ref )
{ return [ref shadowColor]; }

void ShadowSetColor( NSShadow *ref, NSColor *col )
{ [ref setShadowColor:col]; }

void ShadowSet( NSShadow *ref )
{ [ref set]; }

// convenience
NSShadow *ShadowWithAttributes( CGSize offset, CGFloat blurRadius, NSColor *col )
{
    NSShadow *ref = [[[NSShadow alloc] init] autorelease];
    [ref setShadowOffset:NSSizeFromCGSize(offset)];
    [ref setShadowBlurRadius:blurRadius];
    if ( col ) [ref setShadowColor:col];
    return ref;
}

void ShadowSetWithAttributes( CGSize offset, CGFloat blurRadius, NSColor *col )
{
    NSShadow *ref = [[[NSShadow alloc] init] autorelease];
    [ref setShadowOffset:NSSizeFromCGSize(offset)];
    [ref setShadowBlurRadius:blurRadius];
    if ( col ) [ref setShadowColor:col];
    [ref set];
}
