/*
 SliderAccessory.h

 Bernie Wylde
 */

#import <AppKit/AppKit.h>

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101202

// Init
NSSliderAccessory *SliderAccessoryWithImage( NSImage *image );

// Instance properties
NSSliderAccessoryBehavior *SliderAccessoryBehavior( NSSliderAccessory *ref );
void SliderAccessorySetBehavior( NSSliderAccessory *ref, NSSliderAccessoryBehavior *behavior );
BOOL SliderAccessoryIsEnabled( NSSliderAccessory *ref );
void SliderAccessorySetEnabled( NSSliderAccessory *ref, BOOL flag );


#pragma mark - SliderAccessoryBehavior
/*
  SliderAccessoryBehavior.incl
*/

// Init
NSSliderAccessoryBehavior *SliderAccessoryBehaviorWithHandler( void *handler, void *userData );
NSSliderAccessoryBehavior *SliderAccessoryBehaviorWithTarget( CFTypeRef target, SEL action );

// Type properties
NSSliderAccessoryBehavior *SliderAccessoryBehaviorAutomatic( void );
NSSliderAccessoryBehavior *SliderAccessoryBehaviorValueReset( void );
NSSliderAccessoryBehavior *SliderAccessoryBehaviorValueStep( void );

// Instance methods
void SliderAccessoryBehaviorHandleAction( NSSliderAccessory *accessory );

#endif// 101202

