/*
 Sound.h

 Bernie Wylde
 */


#import "CocoaUI.h"

//#import "DialogEvent.h"

// dialog events
enum {
    soundDidFinishPlaying = 3700
};

@interface CUI_SoundDelegate : NSObject <NSSoundDelegate>
@end

CUI_SoundDelegate *CUI_SoundDelegateObj( void );

// Class
Class SoundClass( void );

// -- create --
BOOL SoundCanInitWithPasteboard( NSPasteboard *pb );
NSSound *SoundWithContentsOfURL( CFURLRef url, BOOL byReference );
NSSound *SoundWithData( CFDataRef data );
NSSound *SoundWithPasteboard( NSPasteboard *pb );

// -- configure --
CFStringRef SoundName( NSSound *ref );
BOOL SoundSetName( NSSound *ref, CFStringRef name );
float SoundVolume( NSSound *ref );
void SoundSetVolume( NSSound *ref, float value );
CFTimeInterval SoundCurrentTime( NSSound *ref );
void SoundSetCurrentTime( NSSound *ref, CFTimeInterval ti );
BOOL SoundLoops( NSSound *ref );
void SoundSetLoops( NSSound *ref, BOOL flag );
CFStringRef SoundPlaybackDeviceIdentifier( NSSound *ref );
void SoundSetPlaybackDeviceIdentifier( NSSound *ref, CFStringRef identifier );

// -- info --
CFArrayRef SoundUnfilteredTypes( void );
NSSound *SoundNamed( CFStringRef name );
CFTimeInterval SoundDuration( NSSound *ref );

// -- play --
BOOL SoundIsPlaying( NSSound *ref );
BOOL SoundPause( NSSound *ref );
BOOL SoundPlay( NSSound *ref );
BOOL SoundResume( NSSound *ref );
BOOL SoundStop( NSSound *ref );

// -- write --
void SoundWriteToPasteboard( NSSound *ref, NSPasteboard *pb );

