/*
 SplitViewItem.h

 Bernie Wylde
 */


#import "CocoaUI.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

// Class
Class SplitViewItemClass( void );

// Create
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
NSSplitViewItem *SplitViewItemSidebarWithViewController( NSViewController *vc );
NSSplitViewItem *SplitViewItemContentListWithViewController( NSViewController *vc );
#endif// 101100
NSSplitViewItem *SplitViewItemWithViewController( NSViewController *vc );

// Thickness
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
CGFloat SplitViewItemAutomaticMaximumThickness( NSSplitViewItem *ref );
void SplitViewItemSetAutomaticMaximumThickness( NSSplitViewItem *ref, CGFloat thickness );
CGFloat SplitViewItemPreferredThicknessFraction( NSSplitViewItem *ref );
void SplitViewItemSetPreferredThicknessFraction( NSSplitViewItem *ref, CGFloat fraction );
CGFloat SplitViewItemMinimumThickness( NSSplitViewItem *ref );
void SplitViewItemSetMinimumThicknessFraction( NSSplitViewItem *ref, CGFloat thickness );
CGFloat SplitViewItemMaximumThickness( NSSplitViewItem *ref );
void SplitViewItemSetMaximumThickness( NSSplitViewItem *ref, CGFloat thickness );
#endif// 101100

// Autolayout behaviors
NSLayoutPriority SplitViewItemHoldingPriority( NSSplitViewItem *ref );
void SplitViewItemSetHoldingPriority( NSSplitViewItem *ref, NSLayoutPriority priority );

// Behavior
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
NSSplitViewItemBehavior SplitViewItemBehavior( NSSplitViewItem *ref );
#endif// 101100

// Collapsing and expanding
BOOL SplitViewItemIsCollapsed( NSSplitViewItem *ref );
void SplitViewItemSetCollapsed( NSSplitViewItem *ref, BOOL flag );
BOOL SplitViewItemCanCollapse( NSSplitViewItem *ref );
void SplitViewItemSetCanCollapse( NSSplitViewItem *ref, BOOL flag );
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
NSSplitViewItemCollapseBehavior SplitViewItemCollapseBehavior( NSSplitViewItem *ref );
void SplitViewItemSetCollapseBehavior( NSSplitViewItem *ref, NSSplitViewItemCollapseBehavior behavior );
BOOL SplitViewItemIsSpringLoaded( NSSplitViewItem *ref );
void SplitViewItemSetSpringLoaded( NSSplitViewItem *ref, BOOL flag );
#endif// 101100

// Customizing appearance
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101600
BOOL SplitViewItemAllowsFullHeightLayout( NSSplitViewItem *ref );
void SplitViewItemSetAllowsFullHeightLayout( NSSplitViewItem *ref, BOOL flag );
NSTitlebarSeparatorStyle SplitViewItemTitlebarSeparatorStyle( NSSplitViewItem *ref );
void SplitViewItemSetTitlebarSeparatorStyle( NSSplitViewItem *ref, NSTitlebarSeparatorStyle style );
#endif// 101600

// View controller
NSViewController *SplitViewItemViewController( NSSplitViewItem *ref );

#endif// 101000
