/*
 StatusItem.h

 Bernie Wylde
 */

#import "CocoaUI.h"
#import "StatusBarButton.h"

// Class
Class StatusItemClass( void );

// - status bar -
NSStatusBar *StatusItemStatusBar( NSStatusItem *ref );

// - behavior -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
NSStatusBarButton *StatusItemButton( NSStatusItem *ref );
#endif
NSMenu *StatusItemMenu( NSStatusItem *ref );
void StatusItemSetMenu( NSStatusItem *ref, NSInteger menuIndex );

// - appearance -
CGFloat StatusItemLength( NSStatusItem *ref );
void StatusItemSetLength( NSStatusItem *ref, CGFloat length );

// - instance properties -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
CFStringRef StatusItemAutosaveName( NSStatusItem *ref );
void StatusItemSetAutosaveName( NSStatusItem *ref, CFStringRef name );
NSStatusItemBehavior StatusItemBehavior( NSStatusItem *ref );
void StatusItemSetBehavior( NSStatusItem *ref, NSStatusItemBehavior behavior );
BOOL StatusItemIsVisible( NSStatusItem *ref );
void StatusItemSetVisible( NSStatusItem *ref, BOOL flag );
#endif

// - convenience -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
void StatusItemButtonSetImage( NSStatusItem *ref, NSImage *image );
BOOL StatusItemButtonAppearsDisabled( NSStatusItem *ref );
void StatusItemButtonSetAppearsDisabled( NSStatusItem *ref, BOOL flag );
void StatusItemButtonSetActionCallback( NSStatusItem *ref, void *callback, void *userData );
#endif

