/*
 TextCheckingController.h

 Bernie Wylde
 */


#import "CocoaUI.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500

// Class
Class TextCheckingControllerClass( void );

// Initializers
NSTextCheckingController *TextCheckingControllerWithClient( CFTypeRef client );

// Instance properties
CFTypeRef TextCheckingControllerClient( NSTextCheckingController *ref );
NSInteger TextCheckingControllerSpellCheckerDocumentTag( NSTextCheckingController *ref );
void TextCheckingControllerSetSpellCheckerDocumentTag( NSTextCheckingController *ref, NSInteger tag );

// Instance methods
void TextCheckingControllerChangeSpelling( NSTextCheckingController *ref, CFTypeRef sender );
void TextCheckingControllerCheckSpelling( NSTextCheckingController *ref, CFTypeRef sender );
void TextCheckingControllerCheckTextInRange( NSTextCheckingController *ref, CFRange range, NSTextCheckingTypes types, CFDictionaryRef options );
void TextCheckingControllerCheckTextInDocument( NSTextCheckingController *ref, CFTypeRef sender );
void TextCheckingControllerCheckTextInSelection( NSTextCheckingController *ref, CFTypeRef sender );
void TextCheckingControllerConsiderTextCheckingForRange( NSTextCheckingController *ref, CFRange range );
void TextCheckingControllerDidChangeSelectedRange( NSTextCheckingController *ref );
void TextCheckingControllerDidChangeTextInRange( NSTextCheckingController *ref, CFRange range );
void TextCheckingControllerIgnoreSpelling( NSTextCheckingController *ref, CFTypeRef sender );
void TextCheckingControllerInsertedTextInRange( NSTextCheckingController *ref, CFRange range );
void TextCheckingControllerInvaliate( NSTextCheckingController *ref );
NSMenu *TextCheckingControllerMenuAtIndex( NSTextCheckingController *ref, NSUInteger location, BOOL clickedOnSelection, CFRange *effectiveRange );
void TextCheckingControllerOrderFrontSubstitionsPanel( NSTextCheckingController *ref, CFTypeRef sender );
void TextCheckingControllerShowGuessPanel( NSTextCheckingController *ref, CFTypeRef sender );
void TextCheckingControllerUpdateCandidates( NSTextCheckingController *ref );
CFArrayRef TextCheckingControllerValidAnnotations( NSTextCheckingController *ref );

#endif// 101500

