/*
 TextCheckingController.m

 Bernie Wylde
 */

#import "TextCheckingController.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500

// Class
Class TextCheckingControllerClass( void )
{ return [NSTextCheckingController class]; }

// Initializers
NSTextCheckingController *TextCheckingControllerWithClient( CFTypeRef client )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return [[[NSTextCheckingController alloc] initWithClient:(__bridge id)client] autorelease];
    }
    return nil;
}

// Instance properties
CFTypeRef TextCheckingControllerClient( NSTextCheckingController *ref )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return (__bridge CFTypeRef)[ref client];
    }
    return nil;
}

NSInteger TextCheckingControllerSpellCheckerDocumentTag( NSTextCheckingController *ref )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return [ref spellCheckerDocumentTag];
    }
    return 0;
}

void TextCheckingControllerSetSpellCheckerDocumentTag( NSTextCheckingController *ref, NSInteger tag )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref setSpellCheckerDocumentTag:tag];
    }
}

// Instance methods
void TextCheckingControllerChangeSpelling( NSTextCheckingController *ref, CFTypeRef sender )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref changeSpelling:(__bridge id)sender];
    }
}

void TextCheckingControllerCheckSpelling( NSTextCheckingController *ref, CFTypeRef sender )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref checkSpelling:(__bridge id)sender];
    }
}

void TextCheckingControllerCheckTextInRange( NSTextCheckingController *ref, CFRange range, NSTextCheckingTypes types, CFDictionaryRef options )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref checkTextInRange:NSRangeFromCFRange(range) types:types options:(__bridge NSDictionary *)options];
    }
}

void TextCheckingControllerCheckTextInDocument( NSTextCheckingController *ref, CFTypeRef sender )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref checkTextInDocument:(__bridge id)sender];
    }
}

void TextCheckingControllerCheckTextInSelection( NSTextCheckingController *ref, CFTypeRef sender )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref checkTextInSelection:(__bridge id)sender];
    }
}

void TextCheckingControllerConsiderTextCheckingForRange( NSTextCheckingController *ref, CFRange range )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref considerTextCheckingForRange:NSRangeFromCFRange(range)];
    }
}

void TextCheckingControllerDidChangeSelectedRange( NSTextCheckingController *ref )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref didChangeSelectedRange];
    }
}

void TextCheckingControllerDidChangeTextInRange( NSTextCheckingController *ref, CFRange range )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref didChangeTextInRange:NSRangeFromCFRange(range)];
    }
}

void TextCheckingControllerIgnoreSpelling( NSTextCheckingController *ref, CFTypeRef sender )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref ignoreSpelling:(__bridge id)sender];
    }
}

void TextCheckingControllerInsertedTextInRange( NSTextCheckingController *ref, CFRange range )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref insertedTextInRange:NSRangeFromCFRange(range)];
    }
}

void TextCheckingControllerInvaliate( NSTextCheckingController *ref )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref invalidate];
    }
}

NSMenu *TextCheckingControllerMenuAtIndex( NSTextCheckingController *ref, NSUInteger location, BOOL clickedOnSelection, CFRange *effectiveRange )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return [ref menuAtIndex:location clickedOnSelection:clickedOnSelection effectiveRange:(NSRangePointer)effectiveRange];
    }
    return nil;
}

void TextCheckingControllerOrderFrontSubstitionsPanel( NSTextCheckingController *ref, CFTypeRef sender )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref orderFrontSubstitutionsPanel:(__bridge id)sender];
    }
}

void TextCheckingControllerShowGuessPanel( NSTextCheckingController *ref, CFTypeRef sender )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref showGuessPanel:(__bridge id)sender];
    }
}

void TextCheckingControllerUpdateCandidates( NSTextCheckingController *ref )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref updateCandidates];
    }
}

CFArrayRef TextCheckingControllerValidAnnotations( NSTextCheckingController *ref )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return (__bridge CFArrayRef)[ref validAnnotations];
    }
    return nil;
}

#endif

