/*
 TextContainer.h

 Bernie Wylde
 */


#import "CocoaUI.h"

// Class
Class TextContainerClass( void );

// - create -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
NSTextContainer *TextContainerWithSize( CGSize size );
// - initWithCoder:
#endif

// - components -
NSLayoutManager *TextContainerLayoutManager( NSTextContainer *ref );
void TextContainerSetLayoutManager( NSTextContainer *ref, NSLayoutManager *lm );
void TextContainerReplaceLayoutManager( NSTextContainer *ref, NSLayoutManager *lm );
NSInteger TextContainerTextView( NSTextContainer *ref );

// - shape -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
CGSize TextContainerSize( NSTextContainer *ref );
void TextContainerSetSize( NSTextContainer *ref, CGSize size );
CFArrayRef TextContainerExclusionPaths( NSTextContainer *ref );
void TextContainerSetExclusionPaths( NSTextContainer *ref, CFArrayRef paths );
NSLineBreakMode TextContainerLineBreakMode( NSTextContainer *ref );
void TextContainerSetLineBreakMode( NSTextContainer *ref, NSLineBreakMode lineBreakMode );
#endif
BOOL TextContainerWidthTracksTextView( NSTextContainer *ref );
void TextContainerSetWidthTracksTextView( NSTextContainer *ref, BOOL flag );
BOOL TextContainerHeightTracksTextView( NSTextContainer *ref );
void TextContainerSetHeightTracksTextView( NSTextContainer *ref, BOOL flag );

// - constrain -
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
NSUInteger TextContainerMaximumNumberOfLines( NSTextContainer *ref );
void TextContainerSetMaximumNumberOfLines( NSTextContainer *ref, NSUInteger lines );
#endif
CGFloat TextContainerLineFragmentPadding( NSTextContainer *ref );
void TextContainerSetLineFragmentPadding( NSTextContainer *ref, CGFloat padding );
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101100
CGRect TextContainerLineFragmentRectForProposedRect( NSTextContainer *ref, CGRect proposedRect, NSUInteger index, NSWritingDirection direction, CGRect *remainingRect );
#endif
BOOL TextContainerIsSimpleRectangularTextContainer( NSTextContainer *ref );

