/*
 TextList.m

 Bernie Wylde
 */

#import "TextList.h"

// Class
Class TextListClass( void )
{ return [NSTextList class]; }

// Create
NSTextList *TextListWithMarkerFormat( CFStringRef format, NSUInteger options )
{ return [[[NSTextList alloc] initWithMarkerFormat:(__bridge NSString *)format options:options] autorelease]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 130000
NSTextList *TextListWithCoder( NSCoder *coder )
{ return [[[NSTextList alloc] initWithCoder:coder] autorelease]; }

NSTextList *TextListWithStartingItemNumber( CFStringRef format, NSUInteger options, NSInteger startingItemNumber )
{ return [[[NSTextList alloc] initWithMarkerFormat:(__bridge NSString *)format options:options startingItemNumber:startingItemNumber] autorelease]; }
#endif// 130000

// Markers
CFStringRef TextListMarkerFormat( NSTextList *ref )
{ return (__bridge CFStringRef)[ref markerFormat]; }

CFStringRef TextListMarkerForItemNumber( NSTextList *ref, NSInteger itemNum )
{ return (__bridge CFStringRef)[ref markerForItemNumber:itemNum]; }

// Options
NSUInteger TextListOptions( NSTextList *ref )
{ return [ref listOptions]; }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 130000
BOOL TextListIsOrdered( NSTextList *ref )
{ return [ref isOrdered]; }
#endif// 130000

// Item numbering
NSInteger TextListStartingItemNumber( NSTextList *ref )
{ return [ref startingItemNumber]; }

