/*
 Touch.m

 Bernie Wylde
 */

#import "TitlebarAccessoryViewController.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000

// Class
Class TitlebarAccessoryViewControllerClass( void )
{ return [NSTitlebarAccessoryViewController class]; }

// Configure
CGFloat TitlebarAccessoryViewControllerFullScreenMinHeight( NSTitlebarAccessoryViewController *ref )
{ return [ref fullScreenMinHeight]; }

void TitlebarAccessoryViewControllerSetFullScreenMinHeight( NSTitlebarAccessoryViewController *ref, CGFloat minHeight )
{ [ref setFullScreenMinHeight:minHeight]; }

NSLayoutAttribute TitlebarAccessoryViewControllerLayoutAttribute( NSTitlebarAccessoryViewController *ref )
{ return [ref layoutAttribute]; }

void TitlebarAccessoryViewControllerSetLayoutAttribute( NSTitlebarAccessoryViewController *ref, NSLayoutAttribute attribute )
{ [ref setLayoutAttribute:attribute]; }

// Instance properties
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101600
BOOL TitlebarAccessoryViewControllerAutomaticallyAdjustsSize( NSTitlebarAccessoryViewController *ref )
{
    if (@available(macOS 11.0, *)) {
        return [ref automaticallyAdjustsSize];
    }
    return NO;
}

void TitlebarAccessoryViewControllerSetAutomaticallyAdjustsSize( NSTitlebarAccessoryViewController *ref, BOOL flag )
{
    if (@available(macOS 11.0, *)) {
        [ref setAutomaticallyAdjustsSize:flag];
    }
}
#endif// 101600

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101200
BOOL TitlebarAccessoryViewControllerIsHidden( NSTitlebarAccessoryViewController *ref )
{ return [ref isHidden]; }

void TitlebarAccessoryViewControllerSeHidden( NSTitlebarAccessoryViewController *ref, BOOL flag )
{ [ref setHidden:flag]; }
#endif// 101200

#endif// 101000
