/*
 ToolbarItemGroup.h

 Bernie Wylde
 */


#import "CocoaUI.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500

// Class
Class ToolbarItemGroupClass( void );

// Subitems
CFArrayRef ToolbarItemGroupSubitems( NSToolbarItemGroup *ref );
void ToolbarItemGroupSetSubitems( NSToolbarItemGroup *ref, CFArrayRef subitems );

// Initializers
NSToolbarItemGroup *ToolbarItemGroupWithImages( CFStringRef identifier, CFArrayRef images, NSToolbarItemGroupSelectionMode selectionMode, CFArrayRef labels, CFTypeRef target, SEL action );
NSToolbarItemGroup *ToolbarItemGroupWithTitles( CFStringRef identifier, CFArrayRef titles, NSToolbarItemGroupSelectionMode selectionMode, CFArrayRef labels, CFTypeRef target, SEL action );

// Instance properties
NSToolbarItemGroupControlRepresentation ToolbarItemGroupControlRepresentation( NSToolbarItemGroup *ref );
void ToolbarItemGroupSetControlRepresentation( NSToolbarItemGroup *ref, NSToolbarItemGroupControlRepresentation representation );
NSInteger ToolbarItemGroupSelectedIndex( NSToolbarItemGroup *ref );
void ToolbarItemGroupSetSelectedIndex( NSToolbarItemGroup *ref, NSInteger index );
NSToolbarItemGroupSelectionMode ToolbarItemGroupSelectionMode( NSToolbarItemGroup *ref );
void ToolbarItemGroupSetSelectionMode( NSToolbarItemGroup *ref, NSToolbarItemGroupSelectionMode selectionMode );

// Instance methods
BOOL ToolbarItemGroupIsSelectedAtIndex( NSToolbarItemGroup *ref, NSInteger index );
void ToolbarItemGroupSetSelectedAtIndex( NSToolbarItemGroup *ref, BOOL flag, NSInteger index );

#endif// 101500

