/*
 ToolbarItemGroup.m

 Bernie Wylde
 */

#import "ToolbarItemGroup.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101500

// Class
Class ToolbarItemGroupClass( void )
{ return [NSToolbarItemGroup class]; }

// Subitems
CFArrayRef ToolbarItemGroupSubitems( NSToolbarItemGroup *ref )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return (__bridge CFArrayRef)[ref subitems];
    }
    return nil;
}

void ToolbarItemGroupSetSubitems( NSToolbarItemGroup *ref, CFArrayRef subitems )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref setSubitems:(__bridge NSArray *)subitems];
    }
}

// Initializers
NSToolbarItemGroup *ToolbarItemGroupWithImages( CFStringRef identifier, CFArrayRef images, NSToolbarItemGroupSelectionMode selectionMode, CFArrayRef labels, CFTypeRef target, SEL action )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return [NSToolbarItemGroup groupWithItemIdentifier:(__bridge NSString *)identifier images:(__bridge NSArray *)images selectionMode:selectionMode labels:(__bridge NSArray *)labels target:(__bridge id)target action:action];
    }
    return nil;
}

NSToolbarItemGroup *ToolbarItemGroupWithTitles( CFStringRef identifier, CFArrayRef titles, NSToolbarItemGroupSelectionMode selectionMode, CFArrayRef labels, CFTypeRef target, SEL action )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return [NSToolbarItemGroup groupWithItemIdentifier:(__bridge NSString *)identifier images:(__bridge NSArray *)titles selectionMode:selectionMode labels:(__bridge NSArray *)labels target:(__bridge id)target action:action];
    }
    return nil;
}

// Instance properties
NSToolbarItemGroupControlRepresentation ToolbarItemGroupControlRepresentation( NSToolbarItemGroup *ref )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return [ref controlRepresentation];
    }
    return 0;
}

void ToolbarItemGroupSetControlRepresentation( NSToolbarItemGroup *ref, NSToolbarItemGroupControlRepresentation representation )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref setControlRepresentation:representation];
    }
}

NSInteger ToolbarItemGroupSelectedIndex( NSToolbarItemGroup *ref )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return [ref selectedIndex];
    }
    return 0;
}

void ToolbarItemGroupSetSelectedIndex( NSToolbarItemGroup *ref, NSInteger index )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref setSelectedIndex:index];
    }
}

NSToolbarItemGroupSelectionMode ToolbarItemGroupSelectionMode( NSToolbarItemGroup *ref )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return [ref selectionMode];
    }
    return 0;
}

void ToolbarItemGroupSetSelectionMode( NSToolbarItemGroup *ref, NSToolbarItemGroupSelectionMode selectionMode )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref setSelectionMode:selectionMode];
    }
}

// Instance methods
BOOL ToolbarItemGroupIsSelectedAtIndex( NSToolbarItemGroup *ref, NSInteger index )
{
    if (@available(macOS 10.15, *)) {// 20210102
        return [ref isSelectedAtIndex:index];
    }
    return NO;
}

void ToolbarItemGroupSetSelectedAtIndex( NSToolbarItemGroup *ref, BOOL flag, NSInteger index )
{
    if (@available(macOS 10.15, *)) {// 20210102
        [ref setSelected:flag atIndex:index];
    }
}

#endif// 101500

