/*
 Touch.m

 Bernie Wylde
 */

#import "Touch.h"

// Class
Class TouchClass( void )
{ return [NSTouch class]; }

// Type
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101202
NSTouchType TouchType( NSTouch *ref )
{ return [ref type]; }
#endif

// Properties of this touch
CFTypeRef TouchIdentity( NSTouch *ref )
{ return (__bridge CFTypeRef)[ref identity]; }

NSTouchPhase TouchPhase( NSTouch *ref )
{ return [ref phase]; }

CGPoint TouchNormalizedPosition( NSTouch *ref )
{ return NSPointToCGPoint([ref normalizedPosition]); }

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
BOOL TouchIsResting( NSTouch *ref )
{ return [ref isResting]; }
#endif

// Properties of touch device
CFTypeRef TouchDevice( NSTouch *ref )
{ return (__bridge CFTypeRef)[ref device]; }

CGSize TouchDeviceSize( NSTouch *ref )
{ return NSSizeToCGSize([ref deviceSize]); }

// Touch location
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101202
CGPoint TouchLocationInView( NSTouch *ref, NSInteger tag )
{
    NSView *view = ViewWithTag( tag );
    if ( view ) return NSPointToCGPoint([ref locationInView:view]);
    return CGPointZero;
}

CGPoint TouchPreviousLocationInView( NSTouch *ref, NSInteger tag )
{
    NSView *view = ViewWithTag( tag );
    if ( view ) return NSPointToCGPoint([ref previousLocationInView:view]);
    return CGPointZero;
}
#endif
