/*
 URLResponse.m

 Bernie Wylde
 */

#import "URLResponse.h"

// Class
Class URLResponseClass( void )
{ return [NSURLResponse class]; }

// Create
NSURLResponse *URLResponseWithURL( CFURLRef url, CFStringRef mimeType, NSInteger expectedContentLength, CFStringRef textEncodingName )
{ return [[[NSURLResponse alloc] initWithURL:(__bridge NSURL *)url MIMEType:(__bridge NSString *)mimeType expectedContentLength:expectedContentLength textEncodingName:(__bridge NSString *)textEncodingName] autorelease]; }

// Properties
NSInteger URLResponseExpectedContentLength( NSURLResponse *ref )
{ return [ref expectedContentLength]; }

CFStringRef URLResponseSuggestedFilename( NSURLResponse *ref )
{ return (__bridge CFStringRef)[ref suggestedFilename]; }

CFStringRef URLResponseMIMEType( NSURLResponse *ref )
{ return (__bridge CFStringRef)[ref MIMEType]; }

CFStringRef URLResponseTextEncodingName( NSURLResponse *ref )
{ return (__bridge CFStringRef)[ref textEncodingName]; }

CFURLRef URLResponseURL( NSURLResponse *ref )
{ return (__bridge CFURLRef)[ref URL]; }

