/*
 UTType.h

 Bernie Wylde
 */


#import "CocoaUI.h"

#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 110000

// Look up a type
CFArrayRef UTTypeTypesWithTag( CFStringRef tag, CFStringRef tagClass, UTType *supertype );

// Create
UTType *UTTypeExportedTypeWithIdentifier( CFStringRef identifier );
UTType *UTTypeExportedTypeWithIdentifierConformingToType( CFStringRef identifier, UTType *parentType );
UTType *UTTypeImportedTypeWithIdentifier( CFStringRef identifier );
UTType *UTTypeImportedTypeWithIdentifierConformingToType( CFStringRef identifier, UTType *parentType );
UTType *UTTypeWithIdentifier( CFStringRef identifier );
UTType *UTTypeWithFilenameExtension( CFStringRef identifier );
UTType *UTTypeWithFilenameExtensionConformingToType( CFStringRef identifier, UTType *supertype );
UTType *UTTypeWithMIMEType( CFStringRef mimeType );
UTType *UTTypeWithMIMETypeConformingToType( CFStringRef mimeType, UTType *supertype );
UTType *UTTypeWithTagConformingToType( CFStringRef tag, CFStringRef tagClass, UTType *supertype );

// Identify
CFStringRef UTTypeIdentifier( UTType *ref );

// Tags
CFStringRef UTTypePreferredFilenameExtension( UTType *ref );
CFStringRef UTTypePreferredMIMEType( UTType *ref );
CFDictionaryRef UTTypeTags( UTType *ref );

// Info
BOOL UTTypeIsdeclared( UTType *ref );
BOOL UTTypeIsdynamic( UTType *ref );
BOOL UTTypeIsPublicType( UTType *ref );
CFURLRef UTTypeReferenceURL( UTType *ref );
CFNumberRef UTTypeVersion( UTType *ref );

// Related types
CFSetRef UTTypeSupertypes( UTType *ref );

// Testing
BOOL UTTypeConformsToType( UTType *ref, UTType *otherType );
BOOL UTTypeIsSubtypeOfType( UTType *ref, UTType *otherType );
BOOL UTTypeIsSupertypeOfType( UTType *ref, UTType *otherType );

// Describing
CFStringRef UTTypeLocalizedDescription( UTType *ref );

#endif

