/*
 ViewController.m

 Bernie Wylde
 */

#import "ViewController.h"

// Class
Class ViewControllerClass( void )
{ return [NSViewController class]; }

// - init -
NSViewController *ViewControllerInit( void )
{ return [[[NSViewController alloc] init] autorelease]; }

// Represented object
CFTypeRef ViewControllerRepresentedObject( NSViewController *ref )
{ return (__bridge CFTypeRef)[ref representedObject]; }

void ViewControllerSetRepresentedObject( NSViewController *ref, CFTypeRef obj )
{ [ref setRepresentedObject:(__bridge id)obj]; }

// Nib properties
NSBundle *ViewControllerNibBundle( NSViewController *ref )
{ return [ref nibBundle]; }

CFStringRef ViewControllerNibName( NSViewController *ref )
{ return (__bridge CFStringRef)[ref nibName]; }

// - view properties -
NSView *ViewControllerView( NSViewController *ref )
{ return [ref view]; }

void ViewControllerSetView( NSViewController *ref, NSInteger vwTag )
{
    NSView *view = ViewWithTag( vwTag );
    if ( view ) [ref setView:view];
}

CFStringRef ViewControllerTitle( NSViewController *ref )
{ return (__bridge CFStringRef)[ref title]; }

void ViewControllerSetTitle( NSViewController *ref, CFStringRef title )
{ [ref setTitle:(__bridge NSString *)title]; }

// Storyboard
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
NSStoryboard *ViewControllerStoryboard( NSViewController *ref )
{ return [ref storyboard]; }
#endif// 101000

// View layout
#if __MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
CGSize ViewControllerPreferredContentSize( NSViewController *ref )
{ return NSSizeToCGSize([ref preferredContentSize]); }

void ViewControllerSetPreferredContentSize( NSViewController *ref, CGSize size )
{ [ref setPreferredContentSize:NSSizeFromCGSize(size)]; }
#endif// 101000

