//--------------------------------
include "Tlbx CocoaUI.incl"
//include "Quartz.incl"

system CFStringRef kCTStrokeWidthAttributeName
system CFStringRef kCTStrokeColorAttributeName

local fn CreateAttributedText( stringText as CFStringRef, font as CFStringRef, fontSize as CGFloat ) as CFMutableAttributedStringRef
'~'1
dim as CFIndex                      strLen
dim as CGColorRef                   red, black
dim as double                       strokeWidth
dim as CFNumberRef                  strokeValue
dim as CFAttributedStringRef        attrStr
dim as CFMutableAttributedStringRef mutAttrStr
dim as CTFontRef                    ctFont

// Create mutable attributed string and then add attributes to it
attrStr    = fn CFAttributedStringCreate( NULL, stringText, NULL ) 
mutAttrStr = fn CFAttributedStringCreateMutableCopy( NULL, 0, attrStr )
CFRelease( attrStr )

// Set font face and size
ctFont = fn CTFontCreateWithName( font, fontSize, NULL ) 
strLen = fn CFAttributedStringGetLength( mutAttrStr )
CFAttributedStringSetAttribute( mutAttrStr, fn CFRangeMake( 0, strLen ), kCTFontAttributeName, ctFont )
CFRelease( ctFont )

// Set color of text
black = fn CGColorGetConstantColor( kCGColorBlack )
CFAttributedStringSetAttribute( mutAttrStr, fn CFRangeMake( 0, strLen ), kCTForegroundColorAttributeName, black )

// Set stroke width
strokeWidth = 20.0
strokeValue = fn CFNumberCreate( _kCFAllocatorDefault, _kCFNumberDoubleType, @strokeWidth )
CFAttributedStringSetAttribute( mutAttrStr, fn CFRangeMake( 0, strLen ), kCTStrokeWidthAttributeName, strokeValue )
CFRelease( strokeValue )

// Set color of stroke
//red = fn CGColorCreateGenericRGB( 1.0, 0.0, 0.0, 0.5 ) 
//CFAttributedStringSetAttribute( mutAttrStr, fn CFRangeMake( 0, strLen ), kCTStrokeColorAttributeName, red )
//CGColorRelease( red )


end fn = mutAttrStr


void local fn DrawLinesText( ctx as CGContextRef, r as CGRect, textStr as CFStringRef, font as CFStringRef, fontSize as CGFloat )
'~'1
dim as double                        x, y
dim as CGSize                        shadowOffset
dim as CFMutableAttributedStringRef  attrStr
dim as CTLineRef                     lineRef

x = 45.0 : y = r.size.height - 100.0 //y = 285.0 

//fn QuartzSetCocoaContext( ctx, r )

// Set line attributes
//fn QuartzSetLineCap( _kCGLineCapSquare )
//fn QuartzSetLineWidth( 5.0 )
//fn QuartzSetQDColor( _zBlack )

// Draw first set of horizontal lines
//fn QuartzLine( 50.0, 5.0, 230.0, 5.0 ) 
//fn QuartzLine( 50.0, 15.0, 230.0, 15.0 )

// Create attributed string  
attrStr = fn CreateAttributedText( textStr, font, fontSize )

// Create Core Text line, set text in context and draw it
lineRef = fn CTLineCreateWithAttributedString( attrStr )
CGContextSetTextPosition( ctx, x, y )
CTLineDraw( lineRef, ctx )
CFRelease( lineRef )
CFRelease( attrStr )
CGContextSynchronize( ctx )

// Draw second set of horizontal lines
//fn QuartzLine( 50.0, 45.0, 230.0, 45.0 ) 
//fn QuartzLine( 50.0, 55.0, 230.0, 55.0 ) 

//fn QuartzSetDefaults
end fn


void local fn BuildCocoaWindows
'~'1
cocoa window 1, @"Cocoa Quartz 1", (0,0,800,800)
WindowSubclassContentView(1)  // required for _viewDrawRect intercept in DoDialog
end fn


void local fn DoDialog
'~'1
dim as long ev, id, wnd

ev = dialog(0)
id = dialog(ev)
wnd = dialog(-1)

select ( ev )
case _viewDrawRect
select ( wnd )
case 1
fn DrawLinesText( fn GraphicsCurrentCGContext, fn ViewBounds( _windowContentViewTag ), @"FutureBASIC lives", @"Times", 24.0 )
end select
end select
end fn


fn BuildCocoaWindows

on dialog fn DoDialog

HandleEvents
//--------------------------------


