
/*
   CGLayer Demo (United States Flag)

   Bernie Wylde, 18 November 2006


   Translated from the example on Apple's dev site


   FBtoC mods 26 July 2007   bw
*/


include "Tlbx HIView.incl"
include "Tlbx CoreGraphics.incl"


local fn GetWindowContentView( w as WindowRef ) as HIViewRef
'~'1
dim as HIViewRef   contentView

contentView = 0
fn HIViewFindByID( fn HIViewGetRoot( w ), kHIViewWindowContentID, contentView )
end fn = contentView


local mode
local fn DrawFlag( context as CGContextRef, contextRect as ^CGRect )
'~'1
dim as CGContextRef  myLayerContext1, myLayerContext2
dim as CGLayerRef    stripeLayer, starLayer
dim as CGRect        myBoundingBox, stripeRect, starField
dim as CGPoint       myStarPoints(5)
dim as single        startX, startY, redStripeSpacing, hSpacing, vSpacing
dim as long          i, j, numSixStarRows, numFiveStarRows

startX            = 5.0
startY            = 108.0
hSpacing          = 26.0
vSpacing          = 22.0
redStripeSpacing  = 34.0
numSixStarRows    = 5
numFiveStarRows   = 4

myStarPoints(0) = fn CGPointMake( 5.0, 5.0 )
myStarPoints(1) = fn CGPointMake( 10.0, 15.0 )
myStarPoints(2) = fn CGPointMake( 15.0, 5.0 )
myStarPoints(3) = fn CGPointMake( 2.5, 11.0 )
myStarPoints(4) = fn CGPointMake( 16.5, 11.0 )
myStarPoints(5) = fn CGPointMake( 5.0, 5.0 )

stripeRect = fn CGRectMake( 0, 0, 400, 17 )
starField = fn CGRectMake( 0, 102, 160, 119)
myBoundingBox = fn CGRectMake( 0, 0, contextRect.size.width, contextRect.size.height )

fn CGContextTranslateCTM( context, 0.0, myBoundingBox.size.height )
fn CGContextScaleCTM( context, 1.0, -1.0 )

stripeLayer = fn CGLayerCreateWithContext( context, stripeRect.size, 0 )

long if ( stripeLayer )
myLayerContext1 = fn CGLayerGetContext( stripeLayer )
fn CGContextSetRGBFillColor( myLayerContext1, 1.0, 0.0, 0.0, 1.0 )
fn CGContextFillRect( myLayerContext1, stripeRect )

starLayer = fn CGLayerCreateWithContext( context, starField.size, 0 )

long if ( starLayer )
myLayerContext2 = fn CGLayerGetContext( starLayer )
fn CGContextSetRGBFillColor( myLayerContext2, 1.0, 1.0, 1.0, 1.0 )
fn CGContextAddLines( myLayerContext2, @myStarPoints(0), 6 )
fn CGContextFillPath( myLayerContext2 )   
fn CGContextSaveGState( context )
for i = 0 to 6
fn CGContextDrawLayerAtPoint( context, CGPointZero, stripeLayer )
fn CGContextTranslateCTM( context, 0.0, redStripeSpacing )
next i      
fn CGContextRestoreGState( context )
fn CGContextSetRGBFillColor( context, 0.0, 0.0, 0.329, 1.0 )
fn CGContextFillRect( context, starField )
fn CGContextSaveGState( context )            
fn CGContextTranslateCTM( context, startX, startY )     
for j = 0 to numSixStarRows - 1
 for i = 0 to 5
fn CGContextDrawLayerAtPoint( context, CGPointZero, starLayer )
fn CGContextTranslateCTM( context, hSpacing, 0 )
next i
fn CGContextTranslateCTM( context, (-i*hSpacing), vSpacing )
next j
fn CGContextRestoreGState( context )
fn CGContextSaveGState( context )
fn CGContextTranslateCTM( context, startX + hSpacing/2, startY + vSpacing/2 )
for j = 0 to numFiveStarRows - 1
for i = 0 to 4
fn CGContextDrawLayerAtPoint( context, CGPointZero, starLayer )
fn CGContextTranslateCTM( context, hSpacing, 0 )
next i
fn CGContextTranslateCTM( context, (-i*hSpacing), vSpacing )
next j
fn CGContextRestoreGState( context )
fn CGLayerRelease( starLayer )
end if
fn CGLayerRelease( stripeLayer )
end if
end fn


local fn ControlDrawHandler( handler as EventHandlerCallRef, evnt as EventRef, userData as pointer )
'~'1
dim as HIRect        r
dim as CGContextRef  ctx
dim as HiViewRef     c
dim as OSStatus      result : result = _eventNotHandledErr

select ( fn GetEventClass( evnt ) )
case _kEventClassControl
select ( fn GetEventKind( evnt ) )
case _kEventControlDraw
fn GetEventParameter( evnt, _kEventParamDirectObject, _typeControlRef, #0, sizeof( ControlRef ), #0, @c )
fn GetEventParameter( evnt, _kEventParamCGContextRef, _typeCGContextRef, #0, sizeof( CGContextRef ), #0, @ctx )
fn HIViewGetBounds( c, @r )
fn DrawFlag( ctx, @r )
result = _noErr
end select
end select
end fn = result


local fn InstallControlDrawHandler( c as HIViewRef )
'~'1
dim as EventTypeSpec  evnt

evnt.eventClass = _kEventClassControl
evnt.eventKind = _kEventControlDraw
end fn = fn InstallEventHandler( fn GetControlEventTarget( c ), @fn ControlDrawHandler, 1, @evnt, #0, #0 )


dim as WindowRef  w

appearance window -1, @"United States Flag", (0,0)-(400,221), _kDocumentWindowClass, _kWindowStandardHandlerAttribute + _kWindowCompositingAttribute

w = window(_wndRef)
fn InstallControlDrawHandler( fn GetWindowContentView( w ) )
window 1


do
HandleEvents
until gFBQuit





