//
//  CFStatusItem.m
//  
//  Bernie Wylde 20110802
//

#import "Cocoa/Cocoa.h"
#import "CFStatusItem.h"


CFStatusItemRef CFStatusItemCreate( CGFloat length )
{
	return (CFStatusItemRef)[[[NSStatusBar systemStatusBar] statusItemWithLength:length] retain];
}

void CFStatusItemSetTitle( CFStatusItemRef item, CFStringRef title )
{
	[(NSStatusItem *)item setTitle:(NSString *)title];
}

void CFStatusItemSetAttributedTitle( CFStatusItemRef item, CFAttributedStringRef title )
{
	[(NSStatusItem *)item setAttributedTitle:(NSAttributedString *)title];
}

void CFStatusItemSetImage( CFStatusItemRef item, CGImageRef image )
{
	NSImage *newImage = [[NSImage alloc] initWithCGImage:image size:NSZeroSize];
	[(NSStatusItem *)item setImage:newImage];
	[newImage release];
}


void CFStatusItemSetAlternateImage( CFStatusItemRef item, CGImageRef image )
{
	NSImage *newImage = [[NSImage alloc] initWithCGImage:image size:NSZeroSize];
	[(NSStatusItem *)item setAlternateImage:newImage];
	[newImage release];
}


void CFStatusItemSetResourceImage( CFStatusItemRef item, CFStringRef file, CFStringRef type )
{
	NSString *path = [[NSBundle mainBundle] pathForResource:(NSString *)file ofType:(NSString *)type];
	if( path ){
		NSImage *image = [[NSImage alloc] initWithContentsOfFile:path];
		[image setSize:NSMakeSize( 20.0, 20.0 )];
		[(NSStatusItem *)item setImage:image];
		[image release];
	}
}


void CFStatusItemSetLength( CFStatusItemRef item, CGFloat length )
{
	[(NSStatusItem *)item setLength:length];
}


void CFStatusItemSetHightlightMode( CFStatusItemRef item, Boolean flag )
{
	[(NSStatusItem *)item setHighlightMode:flag];
}


void CFStatusItemSetToolTip( CFStatusItemRef item, CFStringRef string )
{
	[(NSStatusItem *)item setToolTip:(NSString *)string];
}


void CFStatusItemSetEnabled( CFStatusItemRef item, Boolean flag )
{
	[(NSStatusItem *)item setEnabled:flag];
}


void CFStatusItemSetMenu( CFStatusItemRef item, CFMenuRef menu )
{
	[(NSStatusItem *)item setMenu:(NSMenu *)menu];
}


void CFStatusItemRemove( CFStatusItemRef item )
{
	[[NSStatusBar systemStatusBar] removeStatusItem:(NSStatusItem *)item];
}
