/*
Demo using wrappers in Tlbx SQLite3Expanded.incl
Bernie 2013-04-08

This file and Tlbx SQLite3Expanded.incl updated.
N.B. Build with compiler options "-m64 -lsqlite3"
Brian 2019-04-05

*/
include "NSLog.incl"
NSLogSetShowsDate( _false )  // turn off log date display

include "Tlbx SQLite3Expanded.incl"

local fn DoIt
'~'1
dim as CFStringRef       path, task
dim as sqlite3Ptr        db
dim as sqlite3_stmtPtr   statement
dim as long              rc, priority

path = @"/Users/brians/Documents/MySQL3DB"// <- set your path

// announce
NSLog( @"SQLite version: %d", fn SQL3LibVersionNumber() )

// open
NSLog( @"Path: %@", path )
rc = fn SQL3Open( path, @db )
if ( rc )
NSLog( @"  Error result = %d", rc )
xelse
// populate
fn SQL3Exec( db, @"DROP TABLE IF EXISTS memos;" )
fn SQL3Exec( db, @"CREATE TABLE memos( task TEXT, priority INTEGER );" )
fn SQL3Exec( db, @"INSERT INTO memos VALUES( 'Finish this demo', 10 );" )
fn SQL3Exec( db, @"INSERT INTO memos VALUES( 'Post to FB List', 5 );" )
fn SQL3Exec( db, @"INSERT INTO memos VALUES( 'Open bottle of wine', 100 );" )

// query how many rows changed
NSLog( @"Rows changed: %d", fn SQL3TotalChanges( db ) )

// display
NSLog( @"\r" )
rc = fn SQL3PrepareV2( db, @"SELECT task, priority FROM memos", @statement )
if ( rc == _SQLITEOK )
while ( fn SQL3Step( statement ) == _SQLITEROW )
task = fn SQL3ColumnText( statement, 0 )
priority = fn SQL3ColumnInt( statement, 1 )
NSLog( @"%@\t%i", task, priority )
wend
fn SQL3Finalize( statement )
end if

// close
fn SQL3Close( db )
end if
end fn

fn DoIt()

HandleEvents

