include resources "main.nib" // file to be copied to <app>/Contents/Resources/en.lproj

include "Tlbx IBCarbonRuntime.incl"

/*
 Runtime function that converts a nib window into an FB window, and all its controls into FB buttons.
 This persuades FB to treat the windows/buttons as though they were created programmatically.
*/
toolbox MakeIntoFBWindow( WindowRef w, SInt32 wNum )


// These values must match the Control IDs set in the nib
// (the signatures in the nib are irrelevant and may be left blank)
_beepBtn  = 1
_eutcBtn  = 2
_userPane = 3
_helpBtn  = 4


local mode
local fn BuildUIFromNib
'~'1
dim as IBNibRef    @ nib
dim as WindowRef   @ w
dim as OSStatus      err

err = fn CreateNibReference( fn CFSTR( "main" ), @nib ) 
if err then stop "CreateNibReference error"

err = fn SetMenuBarFromNib( nib, fn CFSTR( "MenuBar" ) )
if err then stop "SetMenuBarFromNib error"

err = fn CreateWindowFromNib( nib, fn CFSTR( "Window" ), @w ) 
DisposeNibReference( nib )
if err then stop "CreateWindowFromNib error"
ShowWindow( w )

// the FB wndNum is determined by MakeIntoFBWindow's second parameter; there is nothing relevant in the nib
fn MakeIntoFBWindow( w, 1 )

// use an FB runtime utility to put text into the nib-derived control
fn SetButtonTextString( _eutcBtn, "programmed text" )
end fn


local fn DoDialog
'~'1
dim as long evnt, ref

evnt = dialog( 0 )
ref = dialog( 1 )
select evnt
case _btnClick
select ref
case _beepBtn : beep
case _helpBtn : beep : button _helpBtn, _grayBtn
end select
end select
end  fn

// main
on dialog fn DoDialog
fn BuildUIFromNib
do
HandleEvents
until gFBQuit



