if ( system( _sysVers ) < 1050 ) then stop "Requires OS X 10.5 or greater"


include "Util_PrintColumnarData.incl"

_myLinesPerPage = 28// change to suit
_myColumnTabStop = 100// Tab stops are all 100 here but there is no need for them to be the same

local fn PrintReportHeaders( ctx as CGContextRef )
'~'1
dim as CTFontRef     font
dim as CFStringRef    string
dim as CFIndex      i
dim as CGFloat      x, y

x = 20.0 : y = 550.0// should be measured instead of hard-code
font  = fn CTFontCreateWithName( @"Lucida Grande Bold", 14.0, 0 )

for i = 1 to 6
string = fn CFStringCreateWithFormat( _kCFAllocatorDefault, #0, @"%@%d", @"Head# ", i )
fn PrintLine( ctx, string, x, y, font, _false )
CFRelease( string )
x += _myColumnTabStop
next

CFRelease( font)

end fn = y

//
// DrawGrid function courtesy of Steve Van Voorst
//
local fn DrawGrid( ctx as CGContextRef, l as CGFloat, t as CGFloat , w as CGFloat, h as CGFloat, col as short ,row as short )
'~'1
dim as short j,k

CGContextSetLineWidth( ctx, 1.5 )
CGContextSetRGBStrokeColor( ctx, 0.0, 0.0, 0.0, 1.0 )

for k = 0 to row'Horizontal lines
CGContextBeginPath( ctx )
CGContextMoveToPoint( ctx, l, t - k*h )
CGContextAddLineToPoint( ctx, l + col*w, t - k*h )
CGContextSetLineCap ( ctx, _kCGLineCapSquare)
CGContextStrokePath( ctx )
next k

for j = 0 to col'Vertical lines
CGContextBeginPath( ctx )
CGContextMoveToPoint( ctx, l + j*w, t )
CGContextAddLineToPoint( ctx, l + j*w, t - row*h )
CGContextSetLineCap ( ctx, _kCGLineCapButt)
CGContextStrokePath( ctx )
next j

end fn

local fn DoPrinting
'~'1
dim as PMPrintSession  printSession : printSession = 0
dim as PMPrintSettings  printSettings : printSettings = 0
dim as CGContextRef   ctx
dim as CGFloat      x, y, ascent, descent, yOffset, xOffset
dim as PMPageFormat   pageFormat
dim as CTFontRef     font
dim as CFStringRef    string
dim as CFIndex      i, j

// fn SetUpPrinting must be called first
fn SetUpPrinting( @printSession, @printSettings, @pageFormat, @ctx, _kPMLandscape )// or _kPMPortrait

font  = fn CTFontCreateWithName( @"Lucida Grande", 10.0, 0 )
ascent = fn CTFontGetAscent( font )
descent = fn CTFontGetDescent( font )
yOffset = ascent + descent + 6
xOffset = 20

y = fn PrintReportHeaders( ctx )

fn DrawGrid( ctx, 15, 545, _myColumnTabStop, yOffset, 6, _myLinesPerPage )
// Outer loop is # of detail rows & inner loop # of columns in each row

for i = 1 to 85 // 85 rows
y -= yOffset : x = xOffset

for j = 1 to 6// 6 columns of data
string = fn CFStringCreateWithFormat( _kCFAllocatorDefault, #0, @"%@ %d %d", @"Data# ", i , j )
fn PrintLine( ctx, string, x, y, font, _false )
CFRelease( string )
x += _myColumnTabStop
next

long if ( i mod _myLinesPerPage == 0 ) // page break
fn DoPageBreak( @printSession, @pageFormat, @ctx )
y = fn PrintReportHeaders( ctx )
fn DrawGrid( ctx, 15, 545, _myColumnTabStop, yOffset, 6, _myLinesPerPage )
end if

next

CFRelease( font )

// fn EndPrintSession must be called at the end of the print job
// It releases the 'printed' document to the final destination ( i.e. printer, Preview ap, file etc. ).
fn EndPrintSession( @printSession, @printSettings, @pageFormat )

end fn

fn DoPrinting()

end
'------------


