if ( system( _sysVers ) < 1050 ) then stop "Requires OS X 10.5 or greater"

include "Util_PrintColumnarData.incl"

// 24-June-2011 
//
// fn DoPrinting reworked by Steve Van Voorst to be parameter driven instead of constants. 
//
local fn PrintReportHeaders( ctx as CGContextRef, x as CGFloat, y as CGFloat, col as short, cellW as CGFloat )
'~'1
dim as CTFontRef     font
dim as CFStringRef    string
dim as CFIndex      i

font  = fn CTFontCreateWithName( @"Lucida Grande Bold", 14.0, 0 )

for i = 1 to col
string = fn CFStringCreateWithFormat( _kCFAllocatorDefault, #0, @"%@%d", @"Header ", i )
fn PrintLine( ctx, string, x, y, font, _false )
CFRelease( string )
x += cellW
next

CFRelease( font)

end fn = y

//
// DrawGrid function courtesy of Steve Van Voorst
//
local fn DrawGrid( ctx as CGContextRef, l as CGFloat, t as CGFloat , w as CGFloat, h as CGFloat, col as short ,row as short )
'~'1
dim as short j,k

CGContextSetLineWidth( ctx, 1.5 )
CGContextSetRGBStrokeColor( ctx, 0.0, 0.0, 0.0, 1.0 )

for k = 0 to row'Horizontal lines
CGContextBeginPath( ctx )
CGContextMoveToPoint( ctx, l, t - k*h )
CGContextAddLineToPoint( ctx, l + col*w, t - k*h )
CGContextSetLineCap ( ctx, _kCGLineCapSquare)
CGContextStrokePath( ctx )
next k

for j = 0 to col'Vertical lines
CGContextBeginPath( ctx )
CGContextMoveToPoint( ctx, l + j*w, t )
CGContextAddLineToPoint( ctx, l + j*w, t - row*h )
CGContextSetLineCap ( ctx, _kCGLineCapButt)
CGContextStrokePath( ctx )
next j

end fn

local fn DoPrinting( dataX as CGFloat, dataY as CGFloat, col as short, row as short, linesPerPage as short )
'~'1
dim as PMPrintSession  printSession : printSession = 0
dim as PMPrintSettings  printSettings : printSettings = 0
dim as PMPageFormat   pageFormat
dim as CGContextRef   ctx
dim as CGFloat      ascent, descent
dim as CGFloat  headX, headY
dim as CTFontRef     font
dim as CFStringRef    string
dim as CFIndex      i, j, rowCounter
dim as CGFloat left, top, cellW, cellH

// fn SetUpPrinting must be called first
fn SetUpPrinting( @printSession, @printSettings, @pageFormat, @ctx, _kPMLandscape )// or _kPMPortrait
headX = dataX
headY = dataY + 17'Puts headers above data

font  = fn CTFontCreateWithName( @"Lucida Grande", 10.0, 0 )
ascent = fn CTFontGetAscent( font )
descent = fn CTFontGetDescent( font )
cellH = ascent + descent + 6
cellW = 100.0

fn PrintReportHeaders( ctx, headX, headY, col, cellW )
// Grid includes headers
//fn DrawGrid( ctx, headX - 5.0, headY + 13, cellW, cellH, col, linesPerPage + 1)
// Grid excludes headers
fn DrawGrid( ctx, headX - 5.0, headY - 5.0, cellW, cellH, col, linesPerPage)

rowCounter = 0

for j = 0 to row - 1// enter data by row
for i = 0 to col - 1// data columns
left = dataX + i*( cellW )
top = dataY - ( rowCounter * cellH )

string = fn CFStringCreateWithFormat( _kCFAllocatorDefault, #0, @"%@ %d %d", @"Data# ", i+1, j+1 )
fn PrintLine( ctx, string, left, top, font, _false )
CFRelease( string )

long if (( rowCounter + 1 ) mod linesPerPage == 0 ) && i > col - 2// page break
fn DoPageBreak( @printSession, @pageFormat, @ctx )
fn PrintReportHeaders( ctx, headX, headY, col, cellW )
// Grid includes headers
//fn DrawGrid( ctx, headX - 5.0, headY + 13, cellW, cellH, col, linesPerPage +1)
// Grid excludes headers
fn DrawGrid( ctx, headX - 5.0, headY - 5.0, cellW, cellH, col, linesPerPage)
rowCounter = -1
end if

next i
rowCounter++
next j

CFRelease( font )
// Release the 'printed' document to the final destination ( i.e. printer, Preview app, file etc. ).
fn EndPrintSession( @printSession, @printSettings, @pageFormat )

end fn

//local fn DoPrinting( dataX as CGFloat, dataY as CGFloat, col as short, row as short, linesPerPage as short )
fn DoPrinting( 80.0, 535.0, 6, 85, 28 )

