//Menus
_mFile = 1
_mEdit = 2

begin enum 1
_iNew
_iOpen
_
_iClose
_iSave
_iSaveAs
_iQuit
end enum

BeginCFunction
#import <Cocoa/Cocoa.h>
@interface CocoaPrintOperationController : NSObject {
}
@end

static CocoaPrintOperationController *sCocoaPrintOperationController;

@implementation CocoaPrintOperationController

- (void)printOperationDidEnd:(NSPrintPanel *)printPanel returnCode:(NSInteger)returnCode contextInfo: (void *)contextInfo {
 [sCocoaPrintOperationController release];
 sCocoaPrintOperationController = nil;
}

- (void)runPrintOperationForWindow:(NSWindow *)window andView:(NSView *)view { 
 NSPrintOperation *printOperation = [NSPrintOperation printOperationWithView:view]; 
 [printOperation runOperationModalForWindow:window delegate:self didRunSelector:@selector(printOperationDidEnd:returnCode:contextInfo:) contextInfo:nil];
}
@end

// c wrapper
void CocoaPrintOperationForWindow( WindowRef wndRef )
{
 NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
 HIRect    bounds;
 if ( sCocoaPrintOperationController == nil ) {
  HIWindowGetBounds( wndRef, kWindowContentRgn, kHICoordSpaceScreenPixel, &bounds );
  CGImageRef imageRef = CGWindowListCreateImage( bounds, kCGWindowListOptionAll, HIWindowGetCGWindowID( wndRef ), kCGWindowImageDefault );
  NSImage *image = [[[NSImage alloc] initWithCGImage:imageRef size:NSZeroSize] autorelease];
  NSImageView *imageView = [[[NSImageView alloc] initWithFrame:NSMakeRect( 0.0, 0.0, CGImageGetWidth( imageRef ), CGImageGetHeight( imageRef ) )] autorelease];
  [imageView setImage: image];
  [imageView setImageAlignment:NSImageAlignTopLeft];
  NSWindow *window = [[NSWindow alloc] initWithWindowRef:wndRef];
  sCocoaPrintOperationController = [[CocoaPrintOperationController alloc] init];
  [sCocoaPrintOperationController runPrintOperationForWindow:window andView:imageView];
  CGImageRelease( imageRef );
 }
 [pool drain];
}
EndC
toolbox CocoaPrintOperationForWindow( WindowRef wndRef )


toolbox fn NSApplicationLoad = Boolean
fn NSApplicationLoad()


local fn BuildMenus

'~'1
dim as OSErr  ignore

apple menu "About CocoaPrintOperation"

menu 1, 0, 1, "File"
menu 1, 1, 1, "Print/P"


end fn



local fn DoMenu
'~'1
long if ( menu( _menuID ) == 1 and menu( _itemID ) == 1 )
CocoaPrintOperationForWindow( window( _wndRef ) )
end if
end fn

local fn DoDialog
'~'1
dim as long ev, id

ev = dialog( 0 )
id = dialog( ev )

select ( ev )
case _wndClick : window id
case _wndClose : window close id
end select
end fn


window 2
window 1

fn BuildMenus

text ,48
print : print : print "hello!"
text ,11

on menu fn DoMenu
on dialog fn DoDialog

RunApplicationEventLoop()


