// Mostly Bernie  {20110324} with some from Brian 
BeginCFunction
#import <Cocoa/Cocoa.h>

typedef OSStatus (*CallbackType)(int,void*);

@interface CocoaPrintPanelController : NSObject {
 CallbackType _callback;
}

- (void)setCallback:(CallbackType)callback;

@end

static CocoaPrintPanelController *sCocoaPrintPanelController;

@implementation CocoaPrintPanelController

- (void)setCallback:(CallbackType)callback {
    _callback = callback;
}

- (void)printPanelDidEnd:(NSPrintPanel *)printPanel returnCode:(NSInteger)returnCode contextInfo: (id)printInfo {
 if ( _callback != nil ) (*_callback)(returnCode,printInfo);
 [sCocoaPrintPanelController release];
 sCocoaPrintPanelController = nil;
}

- (void)runPrintPanelForWindow:(NSWindow *)window {
 NSPrintInfo *printInfo = [NSPrintInfo sharedPrintInfo]; 
 NSPrintPanel *panel = [NSPrintPanel printPanel];
 [panel beginSheetWithPrintInfo:printInfo 
     modalForWindow:window 
        delegate:self 
     didEndSelector:@selector(printPanelDidEnd:returnCode:contextInfo:) 
        contextInfo:printInfo];
}
@end

// c wrappers
void CocoaPrintPanelShowSheet( WindowRef wndRef, OSStatus (*callback)(int,void*) )
{
 NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
 if ( sCocoaPrintPanelController == nil ) {
  NSWindow *window = [[NSWindow alloc] initWithWindowRef:wndRef];
  sCocoaPrintPanelController = [[CocoaPrintPanelController alloc] init];
  [sCocoaPrintPanelController setCallback:callback];
  [sCocoaPrintPanelController runPrintPanelForWindow:window];
 }
 [pool drain];
}
EndC
toolbox CocoaPrintPanelShowSheet( WindowRef wndRef, pointer callback )

toolbox fn NSApplicationLoad = Boolean
fn NSApplicationLoad()

local fn MyCocoaPrintPanelCallback( returnCode as SInt32, printInfo as pointer )
'~'1

beep// we got here

print "returnCode:",returnCode
long if ( returnCode == 1 )// NSOKButton

// print something

end if
end fn

local fn DoMenu
'~'1
long if ( menu( _menuID ) == 1 and menu( _itemID ) == 1 )
CocoaPrintPanelShowSheet( window( _wndRef ), @fn MyCocoaPrintPanelCallback )
end if
end fn

menu 1, 0, 1, "File"
menu 1, 1, 1, "Print/P"

window 1

on menu fn DoMenu

RunApplicationEventLoop()


