include "Tlbx CocoaUI.incl"
include "Quartz copy.incl"

_window = 1

_wndW = 650
_wndH = 600

begin enum 1
_customView
_printBtn
_savePDF1
_savePDF2
_quitBtn
end enum

local fn SaveAsPDF1( tag as SInt32, partialPath as CFStringRef )
BeginCCode
NSView *contentView = ViewWithTag(tag);
NSURL *fileURL = [NSURL fileURLWithPath:[NSHomeDirectory() stringByAppendingPathComponent:(NSString *)partialPath]];
NSData *data = [contentView dataWithPDFInsideRect:[contentView bounds]];
[data writeToFile:[fileURL path] atomically:YES];
EndC
end fn

local fn SaveAsPDF2( tag as SInt32 )
BeginCCode
NSView *view = ViewWithTag(tag);
NSPrintInfo *sharedInfo = [NSPrintInfo sharedPrintInfo];
NSMutableDictionary *sharedDict = [sharedInfo dictionary];
NSMutableDictionary *printInfoDict = [NSMutableDictionary dictionaryWithDictionary: sharedDict];
//[printInfoDict setObject:NSPrintSaveJob forKey:NSPrintJobDisposition];
[printInfoDict setObject:NSPrintPreviewJob forKey:NSPrintJobDisposition];
NSURL *fileURL = [NSURL fileURLWithPath:[NSHomeDirectory() stringByAppendingPathComponent:@"Desktop/Test_Method_2.pdf"]];
[printInfoDict setObject:fileURL forKey:NSPrintJobSavingURL];
NSPrintInfo *printInfo = [[NSPrintInfo alloc] initWithDictionary:printInfoDict];
[printInfo setVerticallyCentered:YES];
[printInfo setHorizontallyCentered:YES];
[printInfo setTopMargin:0.0];
[printInfo setBottomMargin:0.0];
[printInfo setLeftMargin:0.0];
[printInfo setRightMargin:0.0];
[printInfo setHorizontalPagination:NSFitPagination];
[printInfo setVerticalPagination:NSFitPagination];
[printInfo setOrientation:NSPaperOrientationLandscape];
NSPrintOperation *printOp = [NSPrintOperation printOperationWithView:view printInfo:printInfo];
[printOp setShowsPrintPanel:NO];
[printOp setShowsProgressPanel:NO];
[printOp runOperation];
EndC
end fn

local fn DrawTextAndStuff(tag as SInt32)
'~'1
dim as CGContextRef   ctx
dim as CGRect         r
dim as CGColorRef     myColor
dim as CFStringRef    cTxt
dim as short        x, y

ctx = fn GraphicsCurrentCGContext
r = fn ViewBounds(tag )

fn QuartzSetCocoaContext( ctx, r )
fn QuartzSetLineWidth( 2.0 )
Fn QuartzRect(3,3,794,594,_False, _True)

fn QuartzSetLineWidth( 6.0 )
fn QuartzSetQDColor( _zBlue )
fn QuartzLine( 20.0, 20.0, 20.0, 20.0 )

// green rect
fn QuartzSetLineWidth( 12.0 )
fn QuartzSetQDColor( _zGreen )
fn QuartzRect( 50.0, 50.0, 100.0, 100.0, _false, _zTrue )

fn QuartzSetLineWidth( 1.0 )
fn QuartzSetQDColor( _zBlack )
fn QuartzLine( 30.0, 50.0, 120.0, 50.0 )
fn QuartzLine( 50.0, 30.0, 50.0, 120.0 )
fn QuartzLine( 30.0, 100.0, 120.0, 100.0 )
fn QuartzLine( 100.0, 30.0, 100.0, 120.0 )

fn QuartzText( @"trial ",@"Menlo Bold",12, 200, 150)

myColor = fn CGColorCreateGenericRGB (0.6, 0.0, 0.9, 1.0)

fn QuartzTextColor( @"other trial", @"Times Bold", 16,250,250, MyColor)

Fn QuartzRotateText( @"Rotated Text", @"Menlo Bold", 14, 300, 300, 45)

Fn QuartzDimLines(25.0,200.0,150.0,300.0,"12'-6 3/16",3.0)

x = 300
y = 20
cTxt =  Fn CFStringFromPStr( "Trial text")
fn QuartzText( cTxt,@"Times Bold",14, x, y)
y = y + 20
cTxt =  Fn CFStringFromPStr("More Trial text")
fn QuartzText(cTxt,@"Times Bold",14, x, y)
y = y + 20
cTxt =  Fn CFStringFromPStr("And yet More Trial text")
fn QuartzText(cTxt,@"Times Bold",14, x, y)
y = y + 20
cTxt =  Fn CFStringFromPStr("Still More Trial text")
fn QuartzText( cTxt,@"Times Bold",14, x, y)
y = y + 20
cTxt =  Fn CFStringFromPStr("Final Trial text")
fn QuartzText( cTxt,@"Times Bold",14, x, y)

CGColorRelease( myColor)
end fn

local fn PrintView( tag as SInt32 )
'~'1
BeginCCode
NSView *view = ViewWithTag(tag);
NSPrintInfo *printInfo = [NSPrintInfo sharedPrintInfo];
[printInfo setVerticallyCentered:NO];
[printInfo setHorizontallyCentered:YES];
[printInfo setTopMargin:10];
[printInfo setBottomMargin:10];
[printInfo setLeftMargin:5];
[printInfo setRightMargin:5];
[printInfo setOrientation:NSPaperOrientationLandscape]; 
NSPrintOperation *printOp;
printOp = [NSPrintOperation printOperationWithView:view printInfo:printInfo];
//[printOp setShowsPrintPanel:YES];
//-- Run print operation ---
[printOp runOperation];
EndC
end fn

local fn BuildWindow
'~'1
dim as SInt32 wndStyleMask

wndStyleMask = NSTitledWindowMask
wndStyleMask += NSClosableWindowMask
wndStyleMask += NSMiniaturizableWindowMask
wndStyleMask += NSResizableWindowMask

// **** Window **** //
window _window, @"Test window", ( 0, 0, _wndW, _wndH ), wndStyleMask

// **** View **** //
view _customView, ( 0, 60, _wndW, _wndH-60 ), _true
ViewSetAutoresizingMask( _customView, NSViewWidthSizable + NSViewHeightSizable )

// ****  Print Btn **** //
button _printBtn, , , @"Print", (_wndW - 230, 20, 140, 24),, NSRoundedBezelStyle
ViewSetAutoresizingMask( _printBtn, NSViewMinXMargin + NSViewMaxYMargin )

button _savePDF1, , , @"Save PDF Method 1", (70, 20, 170, 24),, NSRoundedBezelStyle
ViewSetAutoresizingMask( _printBtn, NSViewMinXMargin + NSViewMaxYMargin )

button _savePDF2, , , @"Save PDF Method 2", (240, 20, 170, 24),, NSRoundedBezelStyle
ViewSetAutoresizingMask( _printBtn, NSViewMinXMargin + NSViewMaxYMargin )

button _quitBtn, , , @"Q", ( _wndW - 50, 10, 40, 40 ),, NSCircularBezelStyle
ViewSetAutoresizingMask( _quitBtn, NSViewMinXMargin + NSViewMaxYMargin )
ControlSetAction( _quitBtn, @"terminate:" )
end fn

local fn DoDialog
'~'1
dim as long ev, id

ev = dialog(0)
id = dialog(ev)

select ( ev )
case _btnClick
select ( id )
case _printBtn
fn PrintView(_customView)
case _savePDF1
fn SaveAsPDF1(_customView, @"Desktop/Test_Method_2.pdf" )
case _savePDF2
fn SaveAsPDF2(_customView )
end select
case _viewDrawRect
select ( id )
case _customView
fn DrawTextAndStuff(_customView)
end select
end select
end fn

fn BuildWindow

on dialog fn DoDialog

HandleEvents


