//
//  PageLayoutController.m
//  
//  Bernie Wylde 20101110
//

#import "PageLayoutController.h"

static PageLayoutController *sPageLayoutController;

typedef void (*PageLayoutReturnVector)();
PageLayoutReturnVector        gPageLayoutVector;

@implementation PageLayoutController

- (void)pageLayoutDidEnd:(NSPageLayout *)pageLayout returnCode:(int)returnCode  contextInfo: (id)printInfo {
	if( returnCode == NSOKButton ) {
        [NSPrintInfo setSharedPrintInfo:printInfo];
		
        NSLog( @"Got to end selector");
		NSLog( @"%ld", [printInfo orientation] );// prove we got here		
		
    }
	[sPageLayoutController release];
	sPageLayoutController = nil;
    (*gPageLayoutVector)(); // call users return function
    gPageLayoutVector = nil;
}

- (void)runPageLayoutForWindow:(NSWindow *)window {
	NSPrintInfo *printInfo = [NSPrintInfo sharedPrintInfo];
	NSPageLayout *layout = [NSPageLayout pageLayout];
	[layout beginSheetWithPrintInfo:printInfo 
					 modalForWindow:window 
						   delegate:self 
					 didEndSelector:@selector(pageLayoutDidEnd:returnCode:contextInfo:) 
						contextInfo:printInfo];
}

@end

// c wrapper
void PageLayoutShowSheet( NSWindow * window, void *inVector ) {
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	sPageLayoutController = [[PageLayoutController alloc] init];
    gPageLayoutVector = (PageLayoutReturnVector)inVector;
	[sPageLayoutController runPageLayoutForWindow:window];
	[pool drain];
}

