include "Tlbx CoreGraphics.incl"
_kCGWindowListOptionAll = 0
_kCGWindowImageDefault = 0

#if ndef _DEFINEDINCARBON
#define CGWindowID as UInt32
#define CGWindowListOption as UInt32
#define CGWindowImageOption as UInt32
#endif

BeginCFunction
#import <Cocoa/Cocoa.h>

void PrintCGImageRefInCocoaWindow( CGImageRef windowImage )
{

     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

     // create an image using the CGImageRef passed in
     NSImage *image = [[[NSImage alloc] initWithCGImage:windowImage size:NSZeroSize] autorelease];

     // create an image view using the coordinates of the CGImageRef
     NSImageView *imageView = [[[NSImageView alloc] initWithFrame:NSMakeRect( 0.0, 0.0, CGImageGetWidth( windowImage ), CGImageGetHeight( windowImage ) )] autorelease];
     [imageView setImage: image];
     [imageView setImageAlignment:NSImageAlignTopLeft];
     
     // retrieve the sharedPrintInfo record and set margins prior to print:
     NSPrintInfo  *printInfo = [NSPrintInfo sharedPrintInfo];
     [printInfo setHorizontallyCentered:NO];
     [printInfo setVerticallyCentered:NO];
     [printInfo setLeftMargin:5.0];
     [printInfo setRightMargin:0.0];
     [printInfo setTopMargin:5.0];
     [printInfo setBottomMargin:0.0];
     //[printInfo setOrientation:NSLandscapeOrientation];  // force landscape orientation
     //[printInfo setScalingFactor:.60];   // notice this is .60 for 60% - i.e. reduce size

     // print it
     [imageView print:nil];

     [pool drain];

}

endc
BeginCFunction
void ShowPagePanel()
{

NSPrintInfo *printInfo = [NSPrintInfo sharedPrintInfo];
NSPageLayout *layOut = [NSPageLayout pageLayout];
[layOut runModalWithPrintInfo:printInfo];
}
endC

toolbox ShowPagePanel()
toolbox PrintCGImageRefInCocoaWindow( CGImageRef windowImage )
toolbox fn NSApplicationLoad() = Boolean
toolbox fn CGWindowListCreateImage( CGRect screenBounds, CGWindowListOption windowOption, CGWindowID windowID, CGWindowImageOption imageOption ) = CGImageRef
toolbox fn HIWindowGetBounds( WindowRef inWindow, WindowRegionCode inRegion, HICoordinateSpace inSpace, HIRect *outBounds ) = OSStatus
toolbox fn HIWindowGetCGWindowID( WindowRef inWindow ) = CGWindowID

dim as WindowRef w
dim as CGImageRef image
dim as CGRect bounds



fn NSApplicationLoad()

window 1, "test"
text _times, 48, _boldBit%
print : print "1. Some test text"
print "2. Some test text"
print "3. Some test text"
print "4. Some test text"

ShowPagePanel()
w = window( _wndRef )
fn HIWindowGetBounds( w, _kWindowContentRgn, _kHICoordSpaceScreenPixel, @bounds )
image = fn CGWindowListCreateImage( bounds, _kCGWindowListOptionAll, fn HIWindowGetCGWindowID( w ), _kCGWindowImageDefault )

PrintCGImageRefInCocoaWindow( image )
CGImageRelease( image )

RunApplicationEventLoop()

