'-------------
include "Tlbx CoreGraphics.incl"
include "Tlbx ControlDefinitions.incl"

_kCGWindowListOptionAll = 0
_kCGWindowImageDefault = 0

#if ndef _DEFINEDINCARBON
#define CGWindowID as UInt32
#define CGWindowListOption as UInt32
#define CGWindowImageOption as UInt32
#endif


toolbox fn CGWindowListCreateImage( CGRect screenBounds, CGWindowListOption windowOption, CGWindowID windowID, CGWindowImageOption imageOption ) = CGImageRef
toolbox fn HIWindowGetBounds( WindowRef inWindow, WindowRegionCode inRegion, HICoordinateSpace inSpace, HIRect *outBounds ) = OSStatus
toolbox fn HIWindowGetCGWindowID( WindowRef inWindow ) = CGWindowID
toolbox PrintCGImageRefInCocoaWindow( CGImageRef windowImage )
toolbox fn NSApplicationLoad = Boolean
toolbox PrintSheet( WindowRef w )

BeginCFunction
void PrintSheet( WindowRef w )
{
NSWindow *window = [[NSWindow alloc] initWithWindowRef:w];
	NSPrintInfo *printInfo = [NSPrintInfo sharedPrintInfo];
	NSPageLayout *layout = [NSPageLayout pageLayout];
	[layout beginSheetWithPrintInfo:printInfo modalForWindow:window delegate:nil didEndSelector:nil contextInfo:printInfo];
}
EndC

BeginCFunction
#import <Cocoa/Cocoa.h>

void PrintCGImageRefInCocoaWindow( CGImageRef windowImage )
{

     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

     // create an image using the CGImageRef passed in
     NSImage *image = [[[NSImage alloc] initWithCGImage:windowImage size:NSZeroSize] autorelease];

     // create an image view using the coordinates of the CGImageRef
     NSImageView *imageView = [[[NSImageView alloc] initWithFrame:NSMakeRect( 0.0, 0.0, CGImageGetWidth( windowImage ), CGImageGetHeight( windowImage ) )] autorelease];
     
     // set the imageview with the CGImageRef
     [imageView setImage: image];
     
     // set the imageView alignment to the top left
     [imageView setImageAlignment:NSImageAlignTopLeft];
     
     // retrieve the sharedPrintInfo record and set margins prior to print:
     NSPrintInfo  *printInfo = [NSPrintInfo sharedPrintInfo];
     //[printInfo setHorizontallyCentered:NO];
     [printInfo setVerticallyCentered:NO];
     [printInfo setLeftMargin:0.0];
     [printInfo setRightMargin:0.0];
     [printInfo setTopMargin:0.0];
     [printInfo setBottomMargin:0.0];
     //[printInfo setOrientation:NSLandscapeOrientation];  // force landscape orientation
     //[printInfo setScalingFactor:.60];   // notice this is .60 for 60% - i.e. reduce size

     // print it
     [imageView print:nil];

     [pool drain];

}

endc

local fn BuildWindow
'~'1
dim as Rect                r
dim as WindowAttributes    wa

wa = _kWindowCloseBoxAttribute
     _kWindowCollapseBoxAttribute
     _kWindowFullZoomAttribute
     _kWindowResizableAttribute

//SetRect( r, 0, 0, 451, 342 )// Optional FB auto-centre
SetRect( r, 0, 44, 451, 386 )
appearance window -1,"Untitled 1", @r, _kDocumentWindowClass, wa
fn SetWindowBackground( _kThemeActiveDialogBackgroundBrush, _zTrue )


SetRect( r, 361, 297, 431, 317 )
appearance button 1,,,,, "Print", @r, _kControlPushButtonProc

window 1
end fn


local fn DoDialog
'~'1
dim as long                       ev, id
dim as CGImageRef image
dim as HIRect bounds
dim as WindowRef w

ev = dialog( 0 )
id = dialog( ev )
select ( ev )
case _wndClick : window id
case _wndClose
case _wndRefresh
case _wndResized
case _wndActivate
case _btnClick
select ( window( _outputWnd ) )
case 1
select ( id )
case 1
w = window( _wndRef )
fn HIWindowGetBounds( w, _kWindowContentRgn, _kHICoordSpaceScreenPixel, @bounds )
image = fn CGWindowListCreateImage( bounds, _kCGWindowListOptionAll, fn HIWindowGetCGWindowID( w ), _kCGWindowImageDefault )

fn PrintCGImageRefInCocoaWindow( image )
CGImageRelease( image )

end select
end select
case _preview
select ( id )
case _preMenuClick
case _preWndGrow
end select
end select
end fn

dim as CGImageRef image
dim as HIRect bounds

fn BuildWindow

on dialog fn DoDialog

fn NSApplicationLoad()

text _times, 48, _boldBit%
print : print "1. Some test text"
print "2. Some test text"
print "3. Some test text"
print "4. Some test text"


PrintSheet( window( _wndRef ) )

do
HandleEvents
until gFBquit


